﻿#ifndef CMDCONFIG_H
#define CMDCONFIG_H

//点击触发型参数枚举(超级用户参数、软件设置参数、网络管理参数等)
enum CLICK_ALL_FUNCTION {
    ROOT_HMICONFIGURATION = 0,      //界面配置
    ROOT_MACHINEPARA,     // 机器参数
    ROOT_WORKPARA,              // 工作参数
    ROOT_TRAVERSESET ,         // 遍历设置
    ROOT_AUTOSETSOFTLIMIT,  // 自动定软限位
    ROOT_PATTERNPARAMETERS,              //花样参数
    ROOT_LOCKTEST ,         // 锁头测试
    ROOT_HOOKTEST,
    ROOT_CLEARPATTERN,              //花样总清
    ROOT_RESOLUTION,           //分辨率
    ROOT_DEBUGMODE,            //界面进入调试模式
    ROOT_MACTYPE,              //机器类型
    ROOT_PRODUCTTYPE,          //产品类型
    ROOT_WATERMARKSET,          //主背景水印设置(是否带水印)
    ROOT_WIFI,
    ROOT_PARASORTSET,          //参数分类设置(是否分类)
    ROOT_HMIDECRYPT,            // 界面解密
    ROOT_TROKECORRECTION,            // 行程矫正
    ROOT_SKIPEFFECT,            // 跳针生效
    ROOT_CHANGEPASSWORD,    //修改一级密码
    ROOT_IOTCONFIGURATION,   //物联网配置-物联网配置
    ROOT_GATEWAYCONNECTIONMETHOD, //物联网配置-网关连接方式
    ROOT_RACKNUMBERINPUT,  //物联网配置-机架号输入
    ROOT_NETWORKSETTINGS,   //物联网配置-网络设置
    ROOT_DELIVERYTIME,   //物联网配置-工厂预计交货时间
    ROOT_DEBUGPROGRESS,   //物联网配置-调试进度
    ROOT_DELETEINI,    //删除配置文件
    ROOT_IMPORTCSV ,   //导入CSV文件
    ROOT_DELETECSV ,   //删除CSV文件
    ROOT_RESETCSV ,   //重置安装调试进度
    ROOT_HIGH_SPEED_SWITCHING,//高低速切换
    ROOT_FRAMEANGLESETTING,    //动框角度设置
    ROOT_SPINDlLEGEARRATIO,//主轴齿轮比测试
    ROOT_FRAMEIMPORTPARA, //动框参数导入
    ROOT_FRAMEEXPORTPARA, //动框参数导出
    ROOT_CLEARPATTERNFCG_FILEID, //清除花样fcg文件影响fileid的数据
    PSE_SOFTWAREPARA_IMPORTPARA,      // 参数导入
    PSE_SOFTWAREPARA_EXPORTPARA,      // 参数导出
    PSE_SOFTWAREPARA_HMIUPDATE,        // 界面升级
    PSE_SOFTWAREPARA_MCUPDATE,         // 主控升级
    PSE_SOFTWAREPARA_EXIT          // 退出程序
};

//此头文件定义了常用功能的枚举
enum SHORTCUT_FUNCTION {
    FUN_ALLTOZERO = 1,     // 全部归零
    FUN_SPINDLEENABLE,        // 主轴使能
    FUN_SPINDLEDISABLE,        // 主轴失能
    FUN_SPINDLETEST,             // 主轴研车
    FUN_BACKWORKPOINT,     // 回工作点
    FUN_BACKANCHORPOINT,   //回定位点
    FUN_BACKTHREADPOINT,   //回穿线点
    FUN_SETOFFSETPOINT,    // 定偏移点
    FUN_BACKOFFSETPOINT,   // 回偏移点
    FUN_SETSTARTPOINT,  // 第一机头（主机头）定起始点
    FUN_SETANCHORPOINT,  // 第一机头（主机头）定定位点
    FUN_BACKSTARTPOINT, // 回起始点
    FUN_CHECKFRAME,        // 边框检查
    FUN_FORWARDORBACK,     // 前进回退
    FUN_PROCESSRESET,    //流程复位
    FUN_PATTERNSELECT,    // 花样选择

    //冲孔机
    FUN_PUNCHSPINDLEJOG,        // 冲孔主轴点动
    FUN_PUNCHMANUALCHANGECOLOR, // 冲孔手动换色
    FUN_PUNCHNEEDLEZERO, // 冲孔换杆归零
    FUN_SINGLEPUNCH,   //单次冲孔
    FUN_FRAMEZERO,      //框架归零
    FUN_MOVETORIGHTUP,    //去右上角
    FUN_MOVETORIGHTDOWN,    //去右下角
    FUN_MOVETOLEFTUP,    //去左上角
    FUN_MOVETOLEFTDOWN,    //去左下角
    FUN_SETWORKRANGE,     //定工作范围
    FUN_TESTPOTENTIOMETER,// 测试电位器  xcy 1024
    FUN_PUNCHSTOPLOWER,     //冲头停下位
    FUN_DRAWOUTLINE,           //画轮廓线 xcy20220909
    FUN_AUTOSETSTARTPOINT,  // 自动定起始点
    FUN_OILSUPPLY ,//连续供油
    FUN_PUNCH_ROT_TO_ZERO,//冲孔旋转去零位
    FUN_ROTATECOMPENSATE,  //旋转补偿

    //冲缝机
    FUN_SEWSPINDLETEST,       // 缝纫主轴研车
    FUN_SEWMOTORUPDOWN,        // 缝纫机头升降
    FUN_SEWSPINDLEJOG,        // 缝纫主轴点动
    FUN_SEWHOOKPOSITION,        // 缝纫主轴去勾线位
    FUN_ROTATEPROOFREAD,     //缝纫旋转校对
    FUN_SECSETSTARTPOINT,      // 次机头（第二机头）定起始点-冲缝机冲孔为次机头
    FUN_SECSETANCHORPOINT,      // 次机头（第二机头）定定位点-冲缝机冲孔为次机头
    FUN_SELECTSEWHEAD,             // 切换缝纫机头
    FUN_SELECTPUCNHHEAD,             // 切换冲孔机头
    FUN_SEWHEADCUTLINEO,       // 机头1剪线
    FUN_SEWHEADCUTLINET,        // 机头2剪线
    FUN_NEEDLECONTRAST,         // 针梭校对
    FUN_NEEDLESHUTTLERESET,     //针梭复位
    FUN_BACKSHUTTLEPOS,     //回换梭位
    FUN_NEEDLERESET,            //针复位
    FUN_SHUTTLERESET,           //梭复位
    FUN_SEWROTATEUP,            //缝纫旋转+
    FUN_SEWROTATEDOWN,          //缝纫旋转-
    FUN_RETURNTOCENTERPOINT,// 回中心点

    //压胶机
    FUN_RESETALL ,     // 全部复位
    FUN_MOTORZEROING,       // 电机归零
    FUN_STATION1GLUING,        // 工位1涂胶
    FUN_STATION2GLUING,        // 工位2涂胶
    FUN_HEADUPDOWN,     // 机头升降
    FUN_TOSTATION1APOS, //回工位1起始点
    FUN_TOSTATION2APOS, //回工位2起始点
    FUN_WORKPAUSE,  //暂停工作
    FUN_TO_WAITTING_POS		,	// 回等料点
    FUN_TO_REMOVE_GLUE_POS	,	// 回排胶点
    FUN_REMOVE_GLUE_ONCE	,	// 排一次胶
    FUN_ADJUST_GLUE_HEGHT   ,//校准胶管高度

    //冲缝绣
    FUN_EMBHOOKPOSITION,        // 平绣主轴去勾线位
    FUN_SEWEMBSPINDLETEST,    //绣花主轴研车
    FUN_SEWEMBSPINDLEJOG,     //绣花主轴点动
    FUN_SEWEMBCHANGECOLOR,    //绣花换色
    FUN_THRIDSETSTARTPOINT,   //第三机头定起始点-冲缝绣时绣花为三机头
    FUN_THRIDSETANCHORPOINT,   //第三机头定定位点-冲缝绣时绣花为三机头
    FUN_SELECTEMBHEAD,        //切换绣花机头
    FUN_SEWEMBCUTLINE,        //绣花剪线

    FUN_NULL   // 无功能                  无功能应该放在最后一位,因为常用功能得最大值就是无功能,否则无法一一对应
};

//辅助功能的枚举
enum ASSIST_FUNCTION {
    ASSIST_SENSOR = 1,     // 传感器信号
    ASSIST_CONTROLACTION,       // 控制动作
    ASSIST_HMIUPGRADE,        // 界面升级
    ASSIST_MCUPGRADE,        // 主控升级
    ASSIST_PARAIMPORT,      // 参数导入
    ASSIST_PARAEXPORT,    // 参数导出
    ASSIST_SOFTWARESET,   // 软件设置
    ASSIST_AUTHORIZATION,  // 软件授权
    ASSIST_NETWORK, // 网络管理
    ASSIST_WIFI, // WIFI管理
    ASSIST_NEEDLESET,        // 针杆设置
    ASSIST_TIMESET,        // 时间设置
    ASSIST_SHORTCUTSET,   // 常用设置
    ASSIST_PRODUCTSTATICS, // 生产统计
    ASSIST_LOGFILE,//文件日志
    ASSIST_ERRORLOG,//错误日志
    ASSIST_BREAKAGELOG,//断线日志
    ASSIST_MCVERSION,     // 版本信息
    ASSIST_BOTTOMLINEDETECT,  //底线检测
    ASSIST_FACELINEDETECT,    //面线检测
    ASSIST_DEBUG,    //调试功能
    ASSIST_ROOT,    //超级用户
    ASSIST_SHUTDOWN,    //关机
    ASSIST_WKPARAIMPORT,      // 工作参数导入
    ASSIST_BOTTOMLINECOUNTRESET, // 底线计数复位
    ASSIST_PARACONTRAST,    // 参数对比
    ASSIST_NULL   // 无功能
};

//花样设置功能的枚举
enum PATTERNSET_FUNCTION {
    PATTERNSET_PATTERNSELECT = 1,     // 花样选择
    PATTERNSET_PATTERNPARA,       // 花样参数
    PATTERNSET_PATTERNCOLOR,        // 花样色序
    PATTERNSET_PATTERNIMPORT,        // 花样导入
    PATTERNSET_PATTERNEXPORT,     // 花样导出
    PATTERNSET_PATTERNDELETE,     // 花样删除
    PATTERNSET_PATTERNSELECT_STATION1,     // 工位1花样选择
    PATTERNSET_PATTERNSELECT_STATION2,     // 工位2花样选择
    PATTERNSET_PATTERNCOLOR_HEADHIGHT,        // 花样机头高度
    PATTERNSET_PATTERN_SWITCHING,          //花样切换
    PATTERNSET_NULL   // 无功能
};

//参数设置参数类型的枚举
enum PARASET_FUNCTION {
    PARASET_POSITION = 1,     // 位置参数
    PARASET_SPEED,                 // 速度参数
    PARASET_ACTION,              // 动作参数
    PARASET_DETECT,               // 检测参数
    PARASET_SETTING,             // 设置参数
    PARASET_WORK                 // 工作参数
};
//调试功能参数类型的枚举
enum DEBUG_FUNCTION {
    DEBUG_TRIM = 1,       // 剪线
    DEBUG_DIECUTTER,       //冲刀
    DEBUG_NEEDLESHUTTLE           // 针梭
};


enum OUTCONTROL_FUN {
    OUTCONTROL_ENABLE = 1, // 使能
    OUTCONTROL_DISABLE,    // 失能
    OUTCONTROL_MS_ENABLE,  // 主轴电机使能
    OUTCONTROL_MS_DISABLE, // 主轴电机失能
    OUTCONTROL_JOGP,       // 正转
    OUTCONTROL_JOGN,       // 反转
    OUTCONTROL_STOP,       // 停止
    OUTCONTROL_ZERO,       // 归零
    OUTCONTROL_UP,         // 上升
    OUTCONTROL_DOWN,       // 下降
    MANUALACTION_RUN,        // 执行
    OUTCONTROL_OPEN,       // 打开
    OUTCONTROL_CLOSE,       // 关闭
    OUTCONTROL_STARTOIL,       // 开始
    OUTCONTROL_STOPOIL,      // 停止
    MOTORHEADO_UP,           // 缝纫机头1升降
    MOTORHEADO_DOWN,            //缝纫机头1下降
    MOTORHEADT_UP,           // 缝纫机头2升降
    MOTORHEADT_DOWN            // 缝纫机头2下降
};

//软件设置的顺序枚举
enum ENUM_SOFTWARESET {
    SET_LANGUAGE,          // 语言
    SET_CONNECTMODE   //连接方式(通讯方式)
};

//花样参数的顺序枚举
enum ENUM_PATTERNPARA {
    SET_ROTATESTYLE = 0,    // 旋转式样
    SET_HORIZONTALSTYLE,    // 水平翻转样式
    SET_VERTICALSTYLE,      // 垂直翻转样式
    SET_ROTATEANGLE,        // 旋转角度
    SET_SPLITSTITCHLENGTH,        // 分割针步长度
    SET_XZOOM,              // X向倍率
    SET_YZOOM,              // Y向倍率
    SET_LOCKNEEDLESNUM,    // 锁针次数
    SET_LOCKNEEDLESSTEPNUM,       // 锁针步数
    SET_LOCKNEEDLESSTEPLENTH,       // 锁针针步长度
    SET_STARTX,       //起始点x   230105 xcy
    SET_STARTY,      //起始点y
    SET_ANCHORX,     //定位点x
    SET_ANCHORY ,     //定位点y
    SET_CONTINURUNCOMP,     //连续动框补偿（0-1000）百分比
    SET_NEEDLETIPCOMP     //针尖补偿
};

//网络管理设置的顺序枚举
enum ENUM_NETWORKSET {
    SET_MQTT_SERVERIP = 0,      // 网关服务器IP
    SET_MQTT_SERVERPORT,        // 网关服务器端口
    SET_MACHINE_SERVERIP,      // 机器服务器IP
    SET_MACHINE_SERVERPORT,        // 机器服务器端口
    SET_LOCALIP,           // 本地IP
    SET_LOCALPORT,          // 本地端口
};

#endif // CMDCONFIG_H
