﻿#include "mainwidget.h"
#include "ui_mainwidget.h"
#ifdef Q_OS_WIN
#include <Windows.h>
#endif
MainWidget::MainWidget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::MainWidget),
    m_pPatternSelectWi(NULL),
    m_pColorOrderSetWi(NULL),
    m_pNeedleBarSetWi(NULL),
    m_pParameterSetDlg(NULL),
    m_pPatternManageWi(NULL),
    m_pSensorInputWi(NULL),
    m_pControlActionWi(NULL),
    m_pMainWidgetFunction(NULL),
    m_pSheetWi(NULL),
    m_pSetWorkAreaWi(NULL),
    m_pRotaComWi(NULL),
    m_initflag(0),
    m_timoutflag(0),
    m_pTimer(NULL),
    m_pConTimer(NULL),
    m_conFlag(0),
    m_linkSta(0)
{
    ui->setupUi(this);

    setWindowFlags (Qt::Widget |
                    Qt::Window |
                    Qt::FramelessWindowHint  |  // 无边框窗口
                    //    Qt::WindowStaysOnTopHint |  // 顶层窗口
                    Qt::Widget);

    setFocusPolicy(Qt::NoFocus);

    this->move(0,0);
    initialize();

    ui->lcdNumberSpeed->display("1200");
    //ui->labelParaType2->setWordWrap(true);
}

MainWidget::~MainWidget()
{
    if(m_pTimer != NULL)
    {
        delete m_pTimer;
    }

    if(m_pConTimer != NULL)
    {
        delete m_pConTimer;
    }

    if(m_pMinTimer != NULL)
    {
        delete m_pMinTimer;
    }

    if(m_pWifiConTimer != NULL)
    {
        delete m_pWifiConTimer;
    }

    if(m_pRefreshVer != NULL)
    {
        delete m_pRefreshVer;
    }

    if(m_pPatternSelectWi != NULL)
    {
        delete m_pPatternSelectWi;
    }

    if(m_pColorOrderSetWi != NULL)
    {
        delete m_pColorOrderSetWi;
    }

    if(m_pNeedleBarSetWi != NULL)
    {
        delete m_pNeedleBarSetWi;
    }

    if(m_pParameterSetDlg != NULL)
    {
        delete m_pParameterSetDlg;
    }

    if(m_pSensorInputWi != NULL)
    {
        delete m_pSensorInputWi;
    }
    if(m_pSetWorkAreaWi != NULL)
    {
        delete m_pSetWorkAreaWi;
    }

    if(m_pRotaComWi != NULL)
    {
        delete m_pRotaComWi;
    }

    if(m_pControlActionWi != NULL)
    {
        delete m_pControlActionWi;
    }

    if(m_pMainWidgetFunction != NULL)
    {
        delete m_pMainWidgetFunction;
    }

    if(m_pSheetWi != NULL)
    {
        delete m_pSheetWi;
    }

    delete ui;
}

void MainWidget::initialize()
{
    m_patternSelectStation = 0;
    m_fileIdx = -1;
    m_itemPerPage = 28;//快捷功能和辅助功能界面各28个按钮
    m_setControlStyle.setUiName(this->objectName());
    memset(m_fileColorTable,0,sizeof(m_fileColorTable));

    hideMenuFrame();
    //主界面按钮选中
    ui->buttonMainMenu->setCheckable(true);
    ui->buttonMainMenu->setChecked(true);

    ui->frameForwardBack->setVisible(false);
    ui->frameShortcutBtn->setVisible(true);
    clearFileInfo();//清除文件信息

    ui->labelWorkState->setVisible(false); //正常工作/模拟工作
    ui->labelEnableWorkState->setVisible(false);//允许工作/禁止工作

    memset(&m_mcStatus,0,sizeof(MCStatus));
    //定时器
    m_pTimer = new QTimer(this);
    m_pTimer->setInterval(1000);    // 设置定时间隔1秒
    connect(m_pTimer, SIGNAL(timeout()), this, SLOT(onOneSecondTimer()));

    //定时器
    m_pConTimer = new QTimer(this);
    m_pConTimer->setInterval(5000);    // 设置定时间隔5秒
    connect(m_pConTimer, SIGNAL(timeout()), this, SLOT(onFiveSecondTimer()));

    //定时器
    m_pWifiConTimer = new QTimer(this);
    m_pWifiConTimer->setInterval(100000);    // 设置定时间隔10分钟
    connect(m_pWifiConTimer, SIGNAL(timeout()), this, SLOT(onTenMiniteTimer()));

    //测试花样刷新的定时器
    m_pRefreshPatternTimer = new QTimer(this);
    m_pRefreshPatternTimer->setInterval(300);    // 设置时间
    connect(m_pRefreshPatternTimer, SIGNAL(timeout()), this, SLOT(onRefreshPatternTimer()));

    //一分钟定时任务,记录当前系统时间,用于上电时计算关机时间
    m_pMinTimer = new QTimer(this);
    m_pMinTimer->setInterval(60000);    // 设置定时间隔60秒
    connect(m_pMinTimer, SIGNAL(timeout()), this, SLOT(onOneMinTimer()));

    m_pRefreshVer = new QTimer(this);
    m_pRefreshVer->setInterval(1000);
    connect(m_pRefreshVer, SIGNAL(timeout()), this, SLOT(onRefreshVer()));
    m_pRefreshVer->start();

    m_curFilePath.clear();
    m_curDatIdx = 0;//当前针数索引
    m_curRpm = -1;
    m_curColorIdx = 0;//当前色序
    m_workStatus = 0;
    m_forwardBackNeedleIdx = 0;//前进回退时的针数索引
    m_forwardBackColorIdx = 0;//前进回退时的颜色索引
    m_ifHMIDecrypt = 1;
    m_connectMode = USE_TCP_COMM;
    m_curPages = 1; // 当前页
    m_showColorIdxBegin = 0;
    memset(&m_fileHead,0,sizeof(DataFileHead));

    m_speedLevel = 2;//速度默认等于2
    m_errorCode = 0;//错误代码
}

//初始化窗体
void MainWidget::initAllWindows(s16 ifHMIDecrypt,s16 connectMode)
{
    m_connectMode = connectMode;
    m_ifHMIDecrypt = ifHMIDecrypt;
    if (m_initflag <= 1)
    {
        connect(g_pCurEmbData,SIGNAL(siDrawNeedleIdx(int)),this,SLOT(slotChangeProgressBar(int)));
        m_initflag = 2;
        sendInitString(QString(tr("Init windows...")));//初始化窗体...
        initControl();//初始化界面控件
        initQuickFunBtn();//初始化快捷功能中的快捷按钮
        initAssisitBtn();//初始化辅助功能中的辅助功能按钮
        initDebugBtn();//初始化辅助功能中的调试按钮
        initPatternSetBtn();//初始化花样设置功能中的功能按钮
        initParaSetBtn();//初始化参数设置功能中的功能按钮

        m_pMainWidgetFunction = new MainWidgetFunction();//主界面功能函数对象
        m_pMainWidgetFunction->setErrorCodeAndStateList(m_errorCodeAndStateItemList);
        connect(m_pMainWidgetFunction, SIGNAL(siSetButtonUserLogo(int)), this, SLOT(slotSetButtonRootLogo(int)));
        connect(m_pMainWidgetFunction, SIGNAL(siClearPatternBreakLineNum()),this,SLOT(slotClearPatternBreakLineNum()));
        connect(m_pMainWidgetFunction, SIGNAL(siClearPattern()), this, SLOT(slotIfFileExist()));//花样总清后，清除当前所选花版路径//两个信号用一个槽
        connect(m_pMainWidgetFunction, SIGNAL(siClearPatternFcg()), this, SLOT(slotClearPatternFcg()));//清除当前所选花版路径
        connect(m_pMainWidgetFunction,SIGNAL(siWifiState(bool)),this,SLOT(slotRefreshWifiIcon(bool)));
        connect(m_pMainWidgetFunction, SIGNAL(siCloseRootPara()),this,SLOT(slotCloseRootPara()));
        connect(m_pMainWidgetFunction, SIGNAL(siDebugState()),this,SLOT(slotDebugState())); //调试模式改变字体颜色

        //connect(m_pMainWidgetFunction, SIGNAL(siRecieveLotDat()),this,SLOT(slotLotDat()));//测试物联网用

        m_pPatternSelectWi = new PatternSelectWidget(this);
        m_pPatternSelectWi->hide();
        connect(m_pPatternSelectWi, SIGNAL(siSelectPattern(QString,s16)), this, SLOT(slotShowPatternPara(QString,s16)));
        connect(m_pParameterSetDlg,SIGNAL(siDebugMode()),m_pMainWidgetFunction,SLOT(slotDebugMode()));//超级用户界面调试模式
        connect(m_pParameterSetDlg,SIGNAL(siParaReadPrompt(s16,s16)),m_pMainWidgetFunction,SLOT(slotParaReadPrompt(s16,s16)));//参数读取中的提示

        m_pColorOrderSetWi = new ColorOrderSetWidget(this);
        m_pColorOrderSetWi->hide();
        connect(m_pColorOrderSetWi,SIGNAL(siChangeColorTable(int,int)),this,SLOT(slotChangeColorTable(int,int)));
        connect(m_pColorOrderSetWi,SIGNAL(siBackHome()),this,SLOT(slotColorOrderChange()));
        connect(m_pColorOrderSetWi,SIGNAL(siCancelChangeColor(QByteArray)),this,SLOT(slotReSetData(QByteArray)));

        m_pNeedleBarSetWi = new NeedleBarSetWidget(this);
        m_pNeedleBarSetWi->hide();
        connect(m_pNeedleBarSetWi,SIGNAL(siChangeNeedleColor(int,int)),m_pColorOrderSetWi,SLOT(slotChangeNeedleColor(int,int)));

        m_pPatternManageWi = new PatternManageWidget(this);
        connect(m_pPatternManageWi, SIGNAL(siDeletePattern()), this, SLOT(slotIfFileExist()));
        connect(m_pPatternManageWi, SIGNAL(siReplacePattrn(QString)), this, SLOT(slotReplacePattrn(QString)));

        m_pParameterSetDlg->hide();
        connect(m_pParameterSetDlg,SIGNAL(siUserLogin(s16)),m_pMainWidgetFunction,SLOT(slotUserLogin(s16)));
        connect(m_pParameterSetDlg,SIGNAL(siFrameAngleSet()),this,SLOT(slotShowFrameAngleWi()));

        m_pRotaComWi = new RotaComWidget(this);
        m_pRotaComWi->hide();
        connect(m_pRotaComWi,SIGNAL(signalManualColorChange()),this,SLOT(slotPunchManualChangeColor()));
        connect(this, SIGNAL(siSpeedLevel(int)),m_pRotaComWi,SLOT(slotSpeedLevel(int))); //

        connect(g_pMachine, SIGNAL(siParaChange(int, int)),
                m_pParameterSetDlg, SLOT(paraChange(int, int)));// 参数改变
        connect(g_pMachine, SIGNAL(siDataFilePos(DataFilePos)),
                this, SLOT(slotResetStartPos(DataFilePos)));// 起始点改变

        connect(m_pParameterSetDlg,SIGNAL(siHMIDecrypt(QString)),m_pMainWidgetFunction,SLOT(slotHMIDecrypt(QString)));
        connect(m_pParameterSetDlg,SIGNAL(siTrokeCorrect()),m_pMainWidgetFunction,SLOT(slotStrokeCorrection()));
        connect(m_pParameterSetDlg,SIGNAL(siSkipEffect()),m_pMainWidgetFunction,SLOT(slotStrokeCorrection()));
        connect(m_pParameterSetDlg,SIGNAL(siAutoSetSoftLimit()),m_pMainWidgetFunction,SLOT(slotAutoSetSoftLimit()));
        connect(m_pParameterSetDlg,SIGNAL(siSpindleTest()),m_pMainWidgetFunction,SLOT(slotSpindleTest()));

        connect(m_pParameterSetDlg,SIGNAL(siFrameParaImport()),m_pMainWidgetFunction,SLOT(slotFrameParaImport()));//动框参数导入
        connect(m_pParameterSetDlg,SIGNAL(siFrameParaExport()),m_pMainWidgetFunction,SLOT(slotFrameParaExport()));//动框参数导出

        connect(m_pParameterSetDlg,SIGNAL(siExit()),m_pMainWidgetFunction,SLOT(slotExitApp()));//超级用户退出程序
        connect(m_pParameterSetDlg,SIGNAL(siDeleteIni()),m_pMainWidgetFunction,SLOT(slotDeleteIni()));//删除执行目录下的config.ini文件
        connect(m_pParameterSetDlg,SIGNAL(siImportCSV()),m_pMainWidgetFunction,SLOT(slotImportCSV()));
        connect(m_pParameterSetDlg,SIGNAL(siDeleteCSV()),m_pMainWidgetFunction,SLOT(slotDeleteCSV()));
        connect(m_pParameterSetDlg,SIGNAL(siResetCSV()),m_pMainWidgetFunction,SLOT(slotResetCSV()));

        connect(m_pParameterSetDlg,SIGNAL(siPatternClear()),m_pMainWidgetFunction,SLOT(slotPatternClear()));//超级用户花样总清
        connect(m_pParameterSetDlg,SIGNAL(siPatternFcgClear()),m_pMainWidgetFunction,SLOT(slotPatternFcgClear()));//超级用户删除花样fcg
        connect(m_pParameterSetDlg,SIGNAL(siPatternFcgClearFileid()),m_pMainWidgetFunction,SLOT(slotPatternFcgClearFileid()));//超级用户删除花样fcg影响fileid的数据

        connect(m_pMainWidgetFunction,SIGNAL(siAfterDeleteFileid()),this,SLOT(slotClearPatternFcg()));//超级用户删除花样fcg影响fileid的数据之后
        m_pPatternManageWi->hide();

        m_pSheetWi = new SheetWidget(this);
        m_pSheetWi->hide();
        connect(g_pMachine, SIGNAL(siParaChange(int, int)),
                m_pSheetWi, SLOT(slotFrameAngleParaChange(int, int)));// 动框角度参数改变

        m_pSetWorkAreaWi = new SetWorkArea(this);
        m_pSetWorkAreaWi->hide();

        m_pSensorInputWi->hide();
        m_pControlActionWi->hide();
        connect(this, SIGNAL(siSpeedLevel(int)),m_pControlActionWi,SLOT(slotSpeed(int))); //手动换挡

        QTimer timer;
        connect(&timer, SIGNAL(timeout()), this, SLOT(slotWaitTimout()));
        timer.start(1000);

        m_timoutflag = 0;
        do
        {
            QCoreApplication::processEvents(QEventLoop::AllEvents);
        }while(m_timoutflag == 0);
        timer.stop();

        sendInitString(QString(tr("Init communication...")));//初始化通讯...

        connect(g_pMachine, SIGNAL(siSensorEnBitmap(SensorsBitmap)),
                m_pSensorInputWi, SLOT(slotRefSensorBitmap(SensorsBitmap)));//传感信号有效位图更新信号
        connect(g_pMachine, SIGNAL(siSensorChange(SensorsBitmap)),
                m_pSensorInputWi , SLOT(slotRefSensorsDat(SensorsBitmap)));//传感信号更新

        //显示报错信息
        connect(g_pMachine, SIGNAL(siStatusChange(int)), this, SLOT(slotMachineStatus(int)));

        // 等待通讯结束....
        timer.start(1000);
        m_timoutflag = 0;
        do
        {
            QCoreApplication::processEvents(QEventLoop::AllEvents);
        }while(m_timoutflag == 0);
        timer.stop();

        refConnectUi(-1);//刷新连接

        m_pTimer->start();//1秒检查一次连接状态
        m_pConTimer->start();//5秒检查一次连接是否断开，若不需要检测与下位机的心跳包时注释掉此行代码

        //窗体初始化完成后自动加载文件并显示、发送
        m_curFilePath = g_pSettings->readFromIniFile("Pattern/name").toString();
        slotShowPatternPara(m_curFilePath,-1);//不显示花样设置窗体，直接加载花样参数

        s16 wifi = g_pSettings->readFromIniFile("HMI/wifi").toInt();//是否有wifi
        if(wifi == 1)
        {
            onTenMiniteTimer();
            ui->buttonWifi->setVisible(true);
            m_pWifiConTimer->start();
        }
        else
        {
            ui->buttonWifi->setVisible(false);
        }
    }
}

//不同机型不同的窗体设置
void MainWidget::initMcTypeWindows()
{
    m_pParameterSetDlg = new ParameterSetDialog(this);
    m_pControlActionWi = new ControlActionWidget(this);
    m_pSensorInputWi = new SensorInputWidget(this);

    m_quickItemList.clear();
    m_assistItemList.clear();
    m_debugItemList.clear();
    m_patternSetItemList.clear();
    m_paraSetItemList.clear();

    MachineTypeFun * curMachineType = NULL;
    if(g_emMacType == MACHINE_PUNCH)
    {
        curMachineType = new PunchMachine;
        ui->labelTitle->setText(tr("Richpeace Punching Control System"));//富怡冲孔控制系统
    }
    //等于定制冲孔机
    else if(g_emMacType == MACHINE_PUNCH_AUTOPOS)
    {
        curMachineType = new AutoPosPunchMachine;
        ui->labelTitle->setText(tr("Richpeace Punching Control System"));//富怡冲孔控制系统
    }
    //等于冲缝机
    else if(g_emMacType == MACHINE_PUNCH_SEW)
    {
        curMachineType = new PunchSewMachine;
        ui->labelTitle->setText(tr("Richpeace PunchSew Control System"));//富怡冲缝控制系统
    }
    //等于压胶机
    else if(g_emMacType == MACHINE_ADHESIVE)
    {
        curMachineType = new AdhesiveMachine;
        ui->labelTitle->setText(tr("Richpeace PressGlue Control System"));//富怡压胶控制系统
    }
    else if(g_emMacType == MACHINE_PUNCH_SEW_EMB)
    {
        curMachineType = new PunchSewEmbMachine;
        ui->labelTitle->setText(tr("Richpeace punchSewEmb Control System"));//富怡冲绣缝控制系统
    }
    else if(g_emMacType == MACHINE_TEMPLATE_SEW)//模板缝纫机
    {
        curMachineType = new TemplateSewMachine;
        ui->labelTitle->setText(tr("Richpeace TemplateSew Control System"));//富怡模板缝纫机控制系统
    }

    //初始化快捷按钮列表要在初始化控件前
    m_quickItemList = curMachineType->getShortCutListByFilter();
    m_assistItemList = curMachineType->getAssistListByFilter();
    m_debugItemList = curMachineType->getDebugFunList();
    m_patternSetItemList = curMachineType->getPatternSetListByFilter();
    m_paraSetItemList = curMachineType->getParaSetListByFilter();

    m_pControlActionWi->addItemList(curMachineType->getOutCtrlListByFilter());
    //添加机器参数和工作参数
    m_pParameterSetDlg->addParaItem(curMachineType->getParasListByMcSel());
    m_pParameterSetDlg->setItemList(operate,PARA_TYPE_MACH|PARA_TYPE_WORK);
    m_pSensorInputWi->addSensorItems(curMachineType->getSensorList());

    m_errorCodeAndStateItemList.clear();
    m_errorCodeAndStateItemList = curMachineType->getErrorCodeAndStateList();

    if(curMachineType != NULL)
    {
        delete curMachineType;
    }
}

//初始化快捷功能中的快捷按钮
void MainWidget::initQuickFunBtn()
{
    for(int i = 0; i < m_quickBtnList.size(); i++)
    {
        if(i < m_quickItemList.size())
        {
            m_quickBtnList[i]->setVisible(true);
            m_quickLabelList[i]->setVisible(true);

            QString name = m_quickItemList[i].m_name;
            m_quickLabelList[i]->setText(name);

            QString topImageName = m_quickItemList[i].m_topImageName;
            //加载按钮顶图图标
            QString btnStyle = m_setControlStyle.getTopStyleSheet(topImageName);
            m_quickBtnList[i]->setTopImage(btnStyle);
        }
        else
        {
            m_quickBtnList[i]->setVisible(false);
            m_quickLabelList[i]->setVisible(false);
        }
    }
}

//初始化辅助功能中的辅助按钮
void MainWidget::initAssisitBtn()
{
    for(int i = 0; i < m_assistBtnList.size(); i++)
    {
        if(i < m_assistItemList.size())
        {
            m_assistBtnList[i]->setVisible(true);
            m_assistLabelList[i]->setVisible(true);

            QString name = m_assistItemList[i].m_name;
            m_assistLabelList[i]->setText(name);

            QString topImageName = m_assistItemList[i].m_topImageName;
            //加载按钮顶图图标
            QString btnStyle = m_setControlStyle.getTopStyleSheet(topImageName);
            m_assistBtnList[i]->setTopImage(btnStyle);
        }
        else
        {
            m_assistBtnList[i]->setVisible(false);
            m_assistLabelList[i]->setVisible(false);
        }
    }
}

//初始化辅助功能中的调试按钮
void MainWidget::initDebugBtn()
{
    for(int i = 0; i < m_debugBtnList.size(); i++)
    {
        if(i < m_debugItemList.size())
        {
            m_debugBtnList[i]->setVisible(true);
            m_debugLabelList[i]->setVisible(true);

            QString name = m_debugItemList[i].m_name;
            m_debugLabelList[i]->setText(name);

            QString topImageName = m_debugItemList[i].m_topImageName;
            //加载按钮顶图图标
            QString btnStyle = m_setControlStyle.getTopStyleSheet(topImageName);
            m_debugBtnList[i]->setTopImage(btnStyle);
        }
        else
        {
            m_debugBtnList[i]->setVisible(false);
            m_debugLabelList[i]->setVisible(false);
        }
    }
}

//初始化花样设置功能中的花样设置按钮
void MainWidget::initPatternSetBtn()
{
    for(int i = 0; i < m_patternSetBtnList.size(); i++)
    {
        if(i < m_patternSetItemList.size())
        {
            m_patternSetBtnList[i]->setVisible(true);
            m_patternSetLabelList[i]->setVisible(true);

            QString name = m_patternSetItemList[i].m_name;
            m_patternSetLabelList[i]->setText(name);

            QString topImageName = m_patternSetItemList[i].m_topImageName;
            //加载按钮顶图图标
            QString btnStyle = m_setControlStyle.getTopStyleSheet(topImageName);
            m_patternSetBtnList[i]->setTopImage(btnStyle);

            //无花样时花样参数、花样色序
            if(m_patternSetItemList[i].m_enumFunction == PATTERNSET_PATTERNPARA)
            {
                m_patternSetBtnList[i]->setEnabled(false);
            }
        }
        else
        {
            m_patternSetBtnList[i]->setVisible(false);
            m_patternSetLabelList[i]->setVisible(false);
        }
    }
}

//初始化参数设置功能中的参数设置按钮
void MainWidget::initParaSetBtn()
{
    for(int i = 0; i < m_paraSetBtnList.size(); i++)
    {
        if(i < m_paraSetItemList.size())
        {
            m_paraSetBtnList[i]->setVisible(true);
            m_paraSetLabelList[i]->setVisible(true);

            QString name = m_paraSetItemList[i].m_name;
            m_paraSetLabelList[i]->setText(name);

            //m_paraSetLabelList[i]->setWordWrap(true);
            QString topImageName = m_paraSetItemList[i].m_topImageName;
            //加载按钮顶图图标
            QString btnStyle = m_setControlStyle.getTopStyleSheet(topImageName);
            m_paraSetBtnList[i]->setTopImage(btnStyle);

            //无花样时花样参数、花样色序
            if(m_patternSetItemList[i].m_enumFunction == PATTERNSET_PATTERNPARA ||
                    m_patternSetItemList[i].m_enumFunction == PATTERNSET_PATTERNCOLOR ||
                    m_patternSetItemList[i].m_enumFunction == PATTERNSET_PATTERNCOLOR_HEADHIGHT)
            {
                m_patternSetBtnList[i]->setEnabled(false);
            }
        }
        else
        {
            m_paraSetBtnList[i]->setVisible(false);
            m_paraSetLabelList[i]->setVisible(false);
        }
    }
}

void MainWidget::setFrameNineBtnStyle()
{
    switch (m_speedLevel)
    {
    case 1:
        ui->buttonNineBtnMiddle->setTopImage(m_setControlStyle.getTopStyleSheet("frameNineBtnMiddle_1"));
        break;
    case 2:
        ui->buttonNineBtnMiddle->setTopImage(m_setControlStyle.getTopStyleSheet("frameNineBtnMiddle_2"));
        break;
    case 3:
        ui->buttonNineBtnMiddle->setTopImage(m_setControlStyle.getTopStyleSheet("frameNineBtnMiddle_3"));
        break;
    default:
        ui->buttonNineBtnMiddle->setTopImage(m_setControlStyle.getTopStyleSheet("frameNineBtnMiddle1"));
        break;
    }
}

//清除文件信息
void MainWidget::clearFileInfo()
{
    ui->labelXValue->setText("0");
    ui->labelYValue->setText("0");
    ui->labelWValue->setText("0");
    ui->labelHValue->setText("0");
    //ui->labelCValue->setText("0");
    ui->labelNValue->setText("0");

    ui->labelWorkingTime->setText("0:0");
    QTextCodec *cod = QTextCodec::codecForLocale();
    ui->labelSpindleAngle->setText(cod->toUnicode("0°"));
    ui->labelColorOrder->setText("0");
    ui->labelNeedleIdx->setText("0");
    ui->labelCoorXY->setText("(0, 0)");
    ui->progressBarProgress->setValue(0);
    ui->labelRelativeCoorXY->setText("(0, 0)");

    ui->labelNeedleCurAndTotal->setText("0/0");
    ui->labelColorCurAndTotal->setText("0/0");
}

//初始化窗体控件，包括位置、尺寸、样式
void MainWidget::initControl()
{
    ui->buttonShortCutPgDn->setVisible(false);
    ui->buttonShortCutPgUp->setVisible(false);
    ui->labelShortCutPage->setVisible(false);

    ui->buttonAssistPgDn->setVisible(false);
    ui->buttonAssistPgUp->setVisible(false);
    ui->labelAssistPage->setVisible(false);

    m_quickBtnList.clear();
    m_quickBtnList.append(ui->buttonQuick1);
    m_quickBtnList.append(ui->buttonQuick2);
    m_quickBtnList.append(ui->buttonQuick3);
    m_quickBtnList.append(ui->buttonQuick4);
    m_quickBtnList.append(ui->buttonQuick5);
    m_quickBtnList.append(ui->buttonQuick6);
    m_quickBtnList.append(ui->buttonQuick7);
    m_quickBtnList.append(ui->buttonQuick8);
    m_quickBtnList.append(ui->buttonQuick9);
    m_quickBtnList.append(ui->buttonQuick10);
    m_quickBtnList.append(ui->buttonQuick11);
    m_quickBtnList.append(ui->buttonQuick12);
    m_quickBtnList.append(ui->buttonQuick13);
    m_quickBtnList.append(ui->buttonQuick14);
    m_quickBtnList.append(ui->buttonQuick15);
    m_quickBtnList.append(ui->buttonQuick16);
    m_quickBtnList.append(ui->buttonQuick17);
    m_quickBtnList.append(ui->buttonQuick18);
    m_quickBtnList.append(ui->buttonQuick19);
    m_quickBtnList.append(ui->buttonQuick20);
    m_quickBtnList.append(ui->buttonQuick21);
    m_quickBtnList.append(ui->buttonQuick22);
    m_quickBtnList.append(ui->buttonQuick23);
    m_quickBtnList.append(ui->buttonQuick24);
    m_quickBtnList.append(ui->buttonQuick25);
    m_quickBtnList.append(ui->buttonQuick26);
    m_quickBtnList.append(ui->buttonQuick27);
    m_quickBtnList.append(ui->buttonQuick28);

    for(int i = 0; i < m_quickBtnList.size(); i++)
    {
        connect(m_quickBtnList.at(i),
                SIGNAL(clicked()),
                this,
                SLOT(slotQuickBtnClick())
                );
    }

    m_quickLabelList.clear();
    m_quickLabelList.append(ui->labelQuick1);
    m_quickLabelList.append(ui->labelQuick2);
    m_quickLabelList.append(ui->labelQuick3);
    m_quickLabelList.append(ui->labelQuick4);
    m_quickLabelList.append(ui->labelQuick5);
    m_quickLabelList.append(ui->labelQuick6);
    m_quickLabelList.append(ui->labelQuick7);
    m_quickLabelList.append(ui->labelQuick8);
    m_quickLabelList.append(ui->labelQuick9);
    m_quickLabelList.append(ui->labelQuick10);
    m_quickLabelList.append(ui->labelQuick11);
    m_quickLabelList.append(ui->labelQuick12);
    m_quickLabelList.append(ui->labelQuick13);
    m_quickLabelList.append(ui->labelQuick14);
    m_quickLabelList.append(ui->labelQuick15);
    m_quickLabelList.append(ui->labelQuick16);
    m_quickLabelList.append(ui->labelQuick17);
    m_quickLabelList.append(ui->labelQuick18);
    m_quickLabelList.append(ui->labelQuick19);
    m_quickLabelList.append(ui->labelQuick20);
    m_quickLabelList.append(ui->labelQuick21);
    m_quickLabelList.append(ui->labelQuick22);
    m_quickLabelList.append(ui->labelQuick23);
    m_quickLabelList.append(ui->labelQuick24);
    m_quickLabelList.append(ui->labelQuick25);
    m_quickLabelList.append(ui->labelQuick26);
    m_quickLabelList.append(ui->labelQuick27);
    m_quickLabelList.append(ui->labelQuick28);

    m_shortCutBtnList.clear();
    m_shortCutBtnList.append(ui->buttonShortcut1);
    m_shortCutBtnList.append(ui->buttonShortcut2);
    m_shortCutBtnList.append(ui->buttonShortcut3);
    m_shortCutBtnList.append(ui->buttonShortcut4);
    m_shortCutBtnList.append(ui->buttonShortcut5);
    m_shortCutBtnList.append(ui->buttonShortcut6);
    m_shortCutBtnList.append(ui->buttonShortcut7);
    m_shortCutBtnList.append(ui->buttonShortcut8);
    m_shortCutBtnList.append(ui->buttonShortcut9);
    m_shortCutBtnList.append(ui->buttonShortcut10);

    for(int i = 0; i < m_shortCutBtnList.size(); i++)
    {
        connect(m_shortCutBtnList.at(i),
                SIGNAL(clicked()),
                this,
                SLOT(slotShortCutBtnClick())
                );
    }

    m_assistBtnList.clear();
    m_assistBtnList.append(ui->buttonAssist1);
    m_assistBtnList.append(ui->buttonAssist2);
    m_assistBtnList.append(ui->buttonAssist3);
    m_assistBtnList.append(ui->buttonAssist4);
    m_assistBtnList.append(ui->buttonAssist5);
    m_assistBtnList.append(ui->buttonAssist6);
    m_assistBtnList.append(ui->buttonAssist7);
    m_assistBtnList.append(ui->buttonAssist8);
    m_assistBtnList.append(ui->buttonAssist9);
    m_assistBtnList.append(ui->buttonAssist10);
    m_assistBtnList.append(ui->buttonAssist11);
    m_assistBtnList.append(ui->buttonAssist12);
    m_assistBtnList.append(ui->buttonAssist13);
    m_assistBtnList.append(ui->buttonAssist14);
    m_assistBtnList.append(ui->buttonAssist15);
    m_assistBtnList.append(ui->buttonAssist16);
    m_assistBtnList.append(ui->buttonAssist17);
    m_assistBtnList.append(ui->buttonAssist18);
    m_assistBtnList.append(ui->buttonAssist19);
    m_assistBtnList.append(ui->buttonAssist20);
    m_assistBtnList.append(ui->buttonAssist21);
    m_assistBtnList.append(ui->buttonAssist22);
    m_assistBtnList.append(ui->buttonAssist23);
    m_assistBtnList.append(ui->buttonAssist24);
    m_assistBtnList.append(ui->buttonAssist25);
    m_assistBtnList.append(ui->buttonAssist26);
    m_assistBtnList.append(ui->buttonAssist27);
    m_assistBtnList.append(ui->buttonAssist28);

    for(int i = 0; i < m_assistBtnList.size(); i++)
    {
        connect(m_assistBtnList.at(i),
                SIGNAL(clicked()),
                this,
                SLOT(slotAssistBtnClick())
                );
    }

    m_assistLabelList.clear();
    m_assistLabelList.append(ui->labelAssist1);
    m_assistLabelList.append(ui->labelAssist2);
    m_assistLabelList.append(ui->labelAssist3);
    m_assistLabelList.append(ui->labelAssist4);
    m_assistLabelList.append(ui->labelAssist5);
    m_assistLabelList.append(ui->labelAssist6);
    m_assistLabelList.append(ui->labelAssist7);
    m_assistLabelList.append(ui->labelAssist8);
    m_assistLabelList.append(ui->labelAssist9);
    m_assistLabelList.append(ui->labelAssist10);
    m_assistLabelList.append(ui->labelAssist11);
    m_assistLabelList.append(ui->labelAssist12);
    m_assistLabelList.append(ui->labelAssist13);
    m_assistLabelList.append(ui->labelAssist14);
    m_assistLabelList.append(ui->labelAssist15);
    m_assistLabelList.append(ui->labelAssist16);
    m_assistLabelList.append(ui->labelAssist17);
    m_assistLabelList.append(ui->labelAssist18);
    m_assistLabelList.append(ui->labelAssist19);
    m_assistLabelList.append(ui->labelAssist20);
    m_assistLabelList.append(ui->labelAssist21);
    m_assistLabelList.append(ui->labelAssist22);
    m_assistLabelList.append(ui->labelAssist23);
    m_assistLabelList.append(ui->labelAssist24);
    m_assistLabelList.append(ui->labelAssist25);
    m_assistLabelList.append(ui->labelAssist26);
    m_assistLabelList.append(ui->labelAssist27);
    m_assistLabelList.append(ui->labelAssist28);

    m_debugBtnList.clear();
    m_debugBtnList.append(ui->buttonDebugFunction1);
    m_debugBtnList.append(ui->buttonDebugFunction2);
    m_debugBtnList.append(ui->buttonDebugFunction3);
    m_debugBtnList.append(ui->buttonDebugFunction4);
    m_debugBtnList.append(ui->buttonDebugFunction5);
    m_debugBtnList.append(ui->buttonDebugFunction6);
    m_debugBtnList.append(ui->buttonDebugFunction7);
    m_debugBtnList.append(ui->buttonDebugFunction8);
    m_debugBtnList.append(ui->buttonDebugFunction9);
    m_debugBtnList.append(ui->buttonDebugFunction10);
    m_debugBtnList.append(ui->buttonDebugFunction11);
    m_debugBtnList.append(ui->buttonDebugFunction12);
    m_debugBtnList.append(ui->buttonDebugFunction13);
    m_debugBtnList.append(ui->buttonDebugFunction14);
    m_debugBtnList.append(ui->buttonDebugFunction15);
    m_debugBtnList.append(ui->buttonDebugFunction16);
    m_debugBtnList.append(ui->buttonDebugFunction17);
    m_debugBtnList.append(ui->buttonDebugFunction18);
    m_debugBtnList.append(ui->buttonDebugFunction19);
    m_debugBtnList.append(ui->buttonDebugFunction20);
    m_debugBtnList.append(ui->buttonDebugFunction21);
    m_debugBtnList.append(ui->buttonDebugFunction22);
    m_debugBtnList.append(ui->buttonDebugFunction23);
    m_debugBtnList.append(ui->buttonDebugFunction24);
    m_debugBtnList.append(ui->buttonDebugFunction25);
    m_debugBtnList.append(ui->buttonDebugFunction26);
    m_debugBtnList.append(ui->buttonDebugFunction27);
    m_debugBtnList.append(ui->buttonDebugFunction28);

    for(int i = 0; i < m_debugBtnList.size(); i++)
    {
        connect(m_debugBtnList.at(i),
                SIGNAL(clicked()),
                this,
                SLOT(slotDebugBtnClick())
                );
    }

    m_debugLabelList.clear();
    m_debugLabelList.append(ui->labelDebugFunction1);
    m_debugLabelList.append(ui->labelDebugFunction2);
    m_debugLabelList.append(ui->labelDebugFunction3);
    m_debugLabelList.append(ui->labelDebugFunction4);
    m_debugLabelList.append(ui->labelDebugFunction5);
    m_debugLabelList.append(ui->labelDebugFunction6);
    m_debugLabelList.append(ui->labelDebugFunction7);
    m_debugLabelList.append(ui->labelDebugFunction8);
    m_debugLabelList.append(ui->labelDebugFunction9);
    m_debugLabelList.append(ui->labelDebugFunction10);
    m_debugLabelList.append(ui->labelDebugFunction11);
    m_debugLabelList.append(ui->labelDebugFunction12);
    m_debugLabelList.append(ui->labelDebugFunction13);
    m_debugLabelList.append(ui->labelDebugFunction14);
    m_debugLabelList.append(ui->labelDebugFunction15);
    m_debugLabelList.append(ui->labelDebugFunction16);
    m_debugLabelList.append(ui->labelDebugFunction17);
    m_debugLabelList.append(ui->labelDebugFunction18);
    m_debugLabelList.append(ui->labelDebugFunction19);
    m_debugLabelList.append(ui->labelDebugFunction20);
    m_debugLabelList.append(ui->labelDebugFunction21);
    m_debugLabelList.append(ui->labelDebugFunction22);
    m_debugLabelList.append(ui->labelDebugFunction23);
    m_debugLabelList.append(ui->labelDebugFunction24);
    m_debugLabelList.append(ui->labelDebugFunction25);
    m_debugLabelList.append(ui->labelDebugFunction26);
    m_debugLabelList.append(ui->labelDebugFunction27);
    m_debugLabelList.append(ui->labelDebugFunction28);


    m_patternSetBtnList.clear();
    m_patternSetBtnList.append(ui->buttonPatternSet1);
    m_patternSetBtnList.append(ui->buttonPatternSet2);
    m_patternSetBtnList.append(ui->buttonPatternSet3);
    m_patternSetBtnList.append(ui->buttonPatternSet4);
    m_patternSetBtnList.append(ui->buttonPatternSet5);
    m_patternSetBtnList.append(ui->buttonPatternSet6);
    m_patternSetBtnList.append(ui->buttonPatternSet7);
    m_patternSetBtnList.append(ui->buttonPatternSet8);
    m_patternSetBtnList.append(ui->buttonPatternSet9);
    m_patternSetBtnList.append(ui->buttonPatternSet10);
    m_patternSetBtnList.append(ui->buttonPatternSet11);
    m_patternSetBtnList.append(ui->buttonPatternSet12);
    m_patternSetBtnList.append(ui->buttonPatternSet13);
    m_patternSetBtnList.append(ui->buttonPatternSet14);

    for(int i = 0; i < m_patternSetBtnList.size(); i++)
    {
        connect(m_patternSetBtnList.at(i),
                SIGNAL(clicked()),
                this,
                SLOT(slotPatternSetBtnClick())
                );
    }

    m_patternSetLabelList.append(ui->labelPatternSet1);
    m_patternSetLabelList.append(ui->labelPatternSet2);
    m_patternSetLabelList.append(ui->labelPatternSet3);
    m_patternSetLabelList.append(ui->labelPatternSet4);
    m_patternSetLabelList.append(ui->labelPatternSet5);
    m_patternSetLabelList.append(ui->labelPatternSet6);
    m_patternSetLabelList.append(ui->labelPatternSet7);
    m_patternSetLabelList.append(ui->labelPatternSet8);
    m_patternSetLabelList.append(ui->labelPatternSet9);
    m_patternSetLabelList.append(ui->labelPatternSet10);
    m_patternSetLabelList.append(ui->labelPatternSet11);
    m_patternSetLabelList.append(ui->labelPatternSet12);
    m_patternSetLabelList.append(ui->labelPatternSet13);
    m_patternSetLabelList.append(ui->labelPatternSet14);

    m_paraSetBtnList.clear();
    m_paraSetBtnList.append(ui->buttonParaType1);
    m_paraSetBtnList.append(ui->buttonParaType2);
    m_paraSetBtnList.append(ui->buttonParaType3);
    m_paraSetBtnList.append(ui->buttonParaType4);
    m_paraSetBtnList.append(ui->buttonParaType5);
    m_paraSetBtnList.append(ui->buttonParaType6);
    m_paraSetBtnList.append(ui->buttonParaType7);
    m_paraSetBtnList.append(ui->buttonParaType8);
    m_paraSetBtnList.append(ui->buttonParaType9);
    m_paraSetBtnList.append(ui->buttonParaType10);
    m_paraSetBtnList.append(ui->buttonParaType11);
    m_paraSetBtnList.append(ui->buttonParaType12);
    m_paraSetBtnList.append(ui->buttonParaType13);
    m_paraSetBtnList.append(ui->buttonParaType14);

    for(int i = 0; i < m_paraSetBtnList.size(); i++)
    {
        connect(m_paraSetBtnList.at(i),
                SIGNAL(clicked()),
                this,
                SLOT(slotParaTypeBtnClick())
                );
    }

    m_paraSetLabelList.append(ui->labelParaType1);
    m_paraSetLabelList.append(ui->labelParaType2);
    m_paraSetLabelList.append(ui->labelParaType3);
    m_paraSetLabelList.append(ui->labelParaType4);
    m_paraSetLabelList.append(ui->labelParaType5);
    m_paraSetLabelList.append(ui->labelParaType6);
    m_paraSetLabelList.append(ui->labelParaType7);
    m_paraSetLabelList.append(ui->labelParaType8);
    m_paraSetLabelList.append(ui->labelParaType9);
    m_paraSetLabelList.append(ui->labelParaType10);
    m_paraSetLabelList.append(ui->labelParaType11);
    m_paraSetLabelList.append(ui->labelParaType12);
    m_paraSetLabelList.append(ui->labelParaType13);
    m_paraSetLabelList.append(ui->labelParaType14);

    m_colorBtnList.clear();
    m_colorBtnList.append(ui->buttonColor1);
    m_colorBtnList.append(ui->buttonColor2);
    m_colorBtnList.append(ui->buttonColor3);
    m_colorBtnList.append(ui->buttonColor4);
    m_colorBtnList.append(ui->buttonColor5);
    m_colorBtnList.append(ui->buttonColor6);
    m_colorBtnList.append(ui->buttonColor7);
    m_colorBtnList.append(ui->buttonColor8);

    //根据不同分辨率设置控件的位置和尺寸
    switch (g_emResolut)
    {
    case resolution1910:
        initResolution1910();
        break;
    case resolution1006:
        initResolution1006();
        break;
    default:
        this->resize(1920,1080);
        break;
    }

    initControlStyle();//初始化窗体控件样式
    setCommonBtn();//设置常用按钮样式
}

//初始化窗体控件为1920x1080分辨率
void MainWidget::initResolution1910()
{
    //上状态栏
    this->resize(1920,1080);
    ui->frameBack->setGeometry(0,0,1920,1080);
    ui->frameUp->setGeometry(0,0,1920,64);
    ui->labelTitle->setGeometry(26,0,1200,64);
    ui->labelHMIVersion->setGeometry(1000,0,855,64);
    ui->buttonWifi->setGeometry(1870,16,32,32);

    //左侧主按钮
    ui->frameMainFunction->setGeometry(0,65,188,938);
    ui->buttonPatternSet->setGeometry(26,0,106,106);
    ui->buttonParaSet->setGeometry(26,160,106,106);
    ui->buttonShortcutFunction->setGeometry(26,320,106,106);
    ui->buttonAccessFunction->setGeometry(26,480,106,106);
    ui->buttonMainMenu->setGeometry(26,640,106,106);
    ui->labelPatternSet->setGeometry(0,106,160,32);
    ui->labelParaSet->setGeometry(0,266,160,32);
    ui->labelShortcutFunction->setGeometry(0,426,160,32);
    ui->labelAccessFunction->setGeometry(0,586,160,32);
    ui->labelMainMenu->setGeometry(0,746,160,32);

    //下方的10个快捷按钮
    ui->frameShortcutBtn->setGeometry(190,895,1322,106);
    for(int i = 0; i < m_shortCutBtnList.size(); i++)
    {
        m_shortCutBtnList[i]->setGeometry(16+132*i,0,106,106);
    }

    //花样显示区域
    ui->framePatternView->setGeometry(195,66,1317,815);
    ui->labelPatternView->setGeometry(24,48,1100,752);
    ui->progressBarProgress->setGeometry(1132,498,166,40);
    ui->labelFilename->setGeometry(14,8,300,32);
    ui->frameColor->setGeometry(1208,20,98,510);
    QRect rectImage(18,6,24,62);
    QRect rectName(50,10,30,58);
    ui->buttonNeedle->setGeometry(10,9,82,73);
    ui->buttonNeedle->initLeftImageRightName(rectImage,rectName);
    for(int i = 0; i < m_colorBtnList.size(); i++)
    {
        m_colorBtnList.at(i)->setGeometry(10,90+i*40,82,36);
    }
    ui->framePatternInfo->setGeometry(1132,540,166,254);
    ui->framePatternInfoImage->setGeometry(0,0,166,254);
    ui->buttonPatternInfo->setGeometry(0,0,166,254);
    ui->labelX->setGeometry(10,10,32,32);
    ui->labelXValue->setGeometry(44,10,116,32);
    ui->labelY->setGeometry(10,50,32,32);
    ui->labelYValue->setGeometry(44,50,116,32);
    ui->labelW->setGeometry(10,90,32,32);
    ui->labelWValue->setGeometry(44,90,116,32);
    ui->labelH->setGeometry(10,130,32,32);
    ui->labelHValue->setGeometry(44,130,116,32);
    ui->labelC->setGeometry(10,170,32,32);
    ui->labelCValue->setGeometry(44,170,116,32);
    ui->labelN->setGeometry(10,210,32,32);
    ui->labelNValue->setGeometry(44,210,116,32);

    //右上方花样信息
    ui->frameEmbInfo->setGeometry(1544,64,344,456);
    ui->buttonWorkingTime->setGeometry(24,20,32,32);
    ui->labelWorkingTime->setGeometry(70,20,220,32);
    ui->buttonNeedleNum->setGeometry(24,80,32,32);
    ui->labelNeedleNum->setGeometry(70,78,220,32);
    ui->buttonSpindleAngle->setGeometry(24,140,32,32);
    ui->labelSpindleAngle->setGeometry(70,134,220,44);
    ui->buttonColorOrder->setGeometry(27,196,24,32);
    ui->labelColorOrder->setGeometry(70,190,220,44);
    ui->buttonNeedleIdx->setGeometry(33,254,16,43);
    ui->labelNeedleIdx->setGeometry(70,248,220,44);
    ui->buttonCoorXY->setGeometry(24,312,32,32);
    ui->labelCoorXY->setGeometry(70,306,250,44);
    ui->buttonRelativeCoorXY->setGeometry(24,376,32,32);
    ui->labelRelativeCoorXY->setGeometry(70,370,250,44);

    //九宫格
    ui->frameFunctionBtn->setGeometry(1544,534,344,468);
    ui->frameSpeed->setGeometry(0,0,344,102);
    ui->buttonSpeedAdd->setGeometry(228,-8,128,128);
    ui->lcdNumberSpeed->setGeometry(106,14,128,88);
    ui->buttonSpeedDec->setGeometry(-8,-8,128,128);
    ui->frameNineBtn->setGeometry(0,122,344,344);
    ui->buttonNineBtn1->setGeometry(0,0,106,106);
    ui->buttonNineBtnUp->setGeometry(122,0,106,106);
    ui->buttonNineBtn2->setGeometry(238,0,106,106);
    ui->buttonNineBtnLeft->setGeometry(0,118,106,106);
    ui->buttonNineBtnMiddle->setGeometry(117,118,106,106);
    ui->buttonNineBtnRight->setGeometry(238,118,106,106);
    ui->buttonNineBtn3->setGeometry(0,238,106,106);
    ui->buttonNineBtnDown->setGeometry(122,236,106,106);
    ui->buttonNineBtn4->setGeometry(238,238,106,106);

    //下方状态栏
    ui->frameDown->setGeometry(0,1016,1920,64);
    ui->progressBar->setGeometry(4,62,1912,2);
    ui->labelState->setGeometry(32,0,600,64);
    ui->labelWorkState->setGeometry(1396,15,32,34);//模拟工作
    ui->labelEnableWorkState->setGeometry(1436,16,32,32);//显示工作状态
    ui->frameMenuBack->setGeometry(192,65,1323,920);
    ui->buttonConnect->setGeometry(1476,16,32,32);//链接状态
    ui->buttonUser->setGeometry(1516,16,32,31);//用户
    ui->labelTime->setGeometry(1556,16,340,32);//时间

    //辅助功能
    ui->frameAccessFunction->setGeometry(190,65,1320,934);
    u16 hNum = 7;//每行7个
    u16 vNum = 4;//总共4行
    for(int i = 0; i < vNum; i++)
    {
        for(int j = 0; j < hNum; j++)
        {
            m_assistBtnList[i*hNum+j]->setGeometry(59+183*j,48+202*i,106,106);
            m_assistLabelList[i*hNum+j]->setGeometry(29+183*j,154+202*i,165,66);
        }
    }
    ui->buttonAssistPgUp->setGeometry(956,836,164,64);
    ui->buttonAssistPgDn->setGeometry(1136,836,164,64);
    ui->labelAssistPage->setGeometry(790,836,150,64);

    //花样设置
    ui->framePatternSet->setGeometry(190,65,1320,934);
    hNum = 7;//每行7个
    vNum = 2;//总共2行
    for(int i = 0; i < vNum; i++)
    {
        for(int j = 0; j < hNum; j++)
        {
            m_patternSetBtnList[i*hNum+j]->setGeometry(59+183*j,48+202*i,106,106);
            m_patternSetLabelList[i*hNum+j]->setGeometry(29+183*j,154+202*i,165,66);//1920x1080 英文显示不全 -rq
        }
    }

    //参数设置
    ui->frameParaSet->setGeometry(190,65,1320,934);
    hNum = 7;//每行7个
    vNum = 2;//总共2行
    for(int i = 0; i < vNum; i++)
    {
        for(int j = 0; j < hNum; j++)
        {
            m_paraSetBtnList[i*hNum+j]->setGeometry(59+183*j,48+202*i,106,106);
            m_paraSetLabelList[i*hNum+j]->setGeometry(29+183*j,154+202*i,165,66);
        }
    }

    //调试功能
    ui->frameDebugFunction->setGeometry(190,65,1320,934);
    hNum = 7;//每行7个
    vNum = 4;//总共4行
    for(int i = 0; i < vNum; i++)
    {
        for(int j = 0; j < hNum; j++)
        {
            m_debugBtnList[i*hNum+j]->setGeometry(59+183*j,48+202*i,106,106);
            m_debugLabelList[i*hNum+j]->setGeometry(29+183*j,154+202*i,165,66);
        }
    }
    ui->buttonDebugClose->setGeometry(1136,836,164,64);

    //快捷功能
    ui->frameShortcutFunction->setGeometry(190,65,1320,934);
    hNum = 7;//每行7个
    vNum = 4;//总共4行
    for(int i = 0; i < vNum; i++)
    {
        for(int j = 0; j < hNum; j++)
        {
            m_quickBtnList[i*hNum+j]->setGeometry(59+183*j,48+202*i,106,106);
            m_quickLabelList[i*hNum+j]->setGeometry(29+183*j,154+202*i,165,66);
        }
    }
    ui->buttonShortCutPgUp->setGeometry(956,836,164,64);
    ui->buttonShortCutPgDn->setGeometry(1136,836,164,64);
    ui->labelShortCutPage->setGeometry(790,836,150,64);

    //快进回退
    ui->frameForwardBack->setGeometry(1534,55,368,951);
    ui->frameForwardBackBack->setGeometry(0,0,368,951);
    ui->labelForwardBackTitle->setGeometry(0,20,368,40);
    ui->buttonNeedleIdxImage->setGeometry(38,80,16,40);
    ui->labelNeedleCurAndTotal->setGeometry(80,80,220,32);
    ui->buttonColorIdxImage->setGeometry(34,140,24,32);
    ui->labelColorCurAndTotal->setGeometry(80,140,220,32);
    ui->buttonNeedleBegin->setGeometry(34,240,132,66);
    ui->buttonNeedleDec1->setGeometry(34,320,132,66);
    ui->buttonNeedleDec10->setGeometry(34,400,132,66);
    ui->buttonNeedleDec100->setGeometry(34,480,132,66);
    ui->buttonNeedleDec1000->setGeometry(34,560,132,66);
    ui->buttonNeedleDec10000->setGeometry(34,640,132,66);
    ui->buttonColorDec->setGeometry(34,720,132,66);
    ui->buttonForwardBackOk->setGeometry(34,860,132,66);
    ui->buttonNeedleEnd->setGeometry(202,240,132,66);
    ui->buttonNeedleAdd1->setGeometry(202,320,132,66);
    ui->buttonNeedleAdd10->setGeometry(202,400,132,66);
    ui->buttonNeedleAdd100->setGeometry(202,480,132,66);
    ui->buttonNeedleAdd1000->setGeometry(202,560,132,66);
    ui->buttonNeedleAdd10000->setGeometry(202,640,132,66);
    ui->buttonColorAdd->setGeometry(202,720,132,66);
    ui->buttonForwardBackCancel->setGeometry(202,860,132,66);
}

void MainWidget::initResolution1006()
{
    this->resize(1024,600);
    ui->frameBack->setGeometry(0,0,1024,600);
    ui->frameUp->setGeometry(0,0,1024,30);
    ui->labelTitle->setGeometry(15,2,360,30);
    ui->labelHMIVersion->setGeometry(555,2,440,30);
    ui->buttonWifi->setGeometry(1000,11,15,15);

    //左侧主按钮
    ui->frameMainFunction->setGeometry(0,36,98,532);// x坐标 y坐标  宽高
    ui->buttonPatternSet->setGeometry(13,0,58,58);
    ui->buttonParaSet->setGeometry(13,90,58,58);
    ui->buttonShortcutFunction->setGeometry(13,180,58,58);
    ui->buttonAccessFunction->setGeometry(13,270,58,58);
    ui->buttonMainMenu->setGeometry(13,360,58,58);
    ui->labelPatternSet->setGeometry(8,59,70,20);
    ui->labelParaSet->setGeometry(8,149,70,20);
    ui->labelShortcutFunction->setGeometry(8,239,70,20);
    ui->labelAccessFunction->setGeometry(8,329,70,20);
    ui->labelMainMenu->setGeometry(8,419,70,20);

    //下方的10个快捷按钮
    ui->frameShortcutBtn->setGeometry(102,490,709,71);
    for(int i = 0; i < m_shortCutBtnList.size(); i++)
    {
        m_shortCutBtnList[i]->setGeometry(10+70*i,9,58,58);
    }

    //九宫格
    ui->frameFunctionBtn->setGeometry(820,292,200,268);// x y w h
    ui->frameSpeed->setGeometry(0,0,185,200);
    ui->buttonSpeedAdd->setGeometry(123,0,70,71);
    ui->lcdNumberSpeed->setGeometry(64,14,60,44);
    ui->buttonSpeedDec->setGeometry(0,0,70,71);
    ui->frameNineBtn->setGeometry(5,75,184,185);
    ui->buttonNineBtn1->setGeometry(0,0,58,58);
    ui->buttonNineBtnUp->setGeometry(60,0,58,58);
    ui->buttonNineBtn2->setGeometry(126,0,58,58);
    ui->buttonNineBtnLeft->setGeometry(0,56,58,58);
    ui->buttonNineBtnMiddle->setGeometry(61,65,58,58);
    ui->buttonNineBtnRight->setGeometry(120,56,58,58);
    ui->buttonNineBtn3->setGeometry(0,126,58,58);
    ui->buttonNineBtnDown->setGeometry(60,115,58,58);
    ui->buttonNineBtn4->setGeometry(126,126,58,58);

    //下方状态栏
    ui->frameDown->setGeometry(0,564,1024,36);
    ui->progressBar->setGeometry(4,28,1016,2);
    ui->labelState->setGeometry(15,0,200,36);
    ui->labelWorkState->setGeometry(748,10,16,17);//模拟工作
    ui->labelEnableWorkState->setGeometry(772,11,15,15);//显示工作状态
    ui->buttonConnect->setGeometry(800,11,15,15);//链接状态
    ui->buttonUser->setGeometry(822,11,15,15);//用户
    ui->frameMenuBack->setGeometry(101,36,707,513);//二级菜单的白色背景显示不齐  -rq
    ui->labelTime->setGeometry(842,0,200,36);//时间

    //右上方花样信息
    ui->frameEmbInfo->setGeometry(819,30,188,280);
    ui->buttonWorkingTime->setGeometry(18,20,20,20);
    ui->labelWorkingTime->setGeometry(45,15,110,28);
    ui->buttonNeedleNum->setGeometry(18,55,18,18);
    ui->labelNeedleNum->setGeometry(45,50,120,28);
    ui->buttonSpindleAngle->setGeometry(18,90,19,19);
    ui->labelSpindleAngle->setGeometry(45,85,110,28);
    ui->buttonColorOrder->setGeometry(18,125,15,20);
    ui->labelColorOrder->setGeometry(45,120,110,28);
    ui->buttonNeedleIdx->setGeometry(23,160,8,25);
    ui->labelNeedleIdx->setGeometry(45,155,110,28);
    ui->buttonCoorXY->setGeometry(18,195,20,20);
    ui->labelCoorXY->setGeometry(45,190,170,28);
    ui->buttonRelativeCoorXY->setGeometry(19,230,20,20);
    ui->labelRelativeCoorXY->setGeometry(45,225,170,28);

    //花样显示区域
    ui->framePatternView->setGeometry(104,36,707,452);
    ui->labelPatternView->setGeometry(58,30,541,411);//灰色花样图
    ui->progressBarProgress->setGeometry(600,282,88,26);
    ui->labelFilename->setGeometry(6,5,500,24);
    ui->frameColor->setGeometry(620,0,68,311);
    QRect rectImage(9,3,12,31);
    QRect rectName(26,10,20,29);
    ui->buttonNeedle->setGeometry(16,14,52,40);
    ui->buttonNeedle->initLeftImageRightName(rectImage,rectName);
    for(int i = 0; i < m_colorBtnList.size(); i++)
    {
        m_colorBtnList.at(i)->setGeometry(16,58+i*24,52,22);//两位数字显示不全   -rq
    }

    ui->framePatternInfo->setGeometry(600,310,88,134);
    ui->framePatternInfoImage->setGeometry(0,0,88,134);
    ui->buttonPatternInfo->setGeometry(0,0,88,134);
    ui->labelX->setGeometry(8,10,20,16);
    ui->labelXValue->setGeometry(10,10,72,16);
    ui->labelY->setGeometry(8,30,20,16);
    ui->labelYValue->setGeometry(10,30,72,16);
    ui->labelW->setGeometry(8,50,20,16);
    ui->labelWValue->setGeometry(10,50,72,16);
    ui->labelH->setGeometry(8,70,20,16);
    ui->labelHValue->setGeometry(10,70,72,16);
    ui->labelC->setGeometry(8,90,20,16);
    ui->labelCValue->setGeometry(10,90,72,16);
    ui->labelN->setGeometry(8,110,20,16);
    ui->labelNValue->setGeometry(10,110,72,16);

    //辅助功能
    ui->frameAccessFunction->setGeometry(108,36,707,513);
    u16 hNum = 7;//每行7个
    u16 vNum = 4;//总共4行
    for(int i = 0; i < vNum; i++)
    {
        for(int j = 0; j < hNum; j++)
        {
            m_assistBtnList[i*hNum+j]->setGeometry(24+98*j,24+106*i,58,58);
            m_assistLabelList[i*hNum+j]->setGeometry(6+98*j,84+106*i,95,40);//字体显示不全  -rq
        }
    }
    ui->buttonAssistPgUp->setGeometry(476,460,100,40);
    ui->buttonAssistPgDn->setGeometry(586,460,100,40);
    ui->labelAssistPage->setGeometry(376,460,100,40);

    //花样设置
    ui->framePatternSet->setGeometry(108,36,707,513);
    hNum = 7;//每行7个
    vNum = 2;//总共2行
    for(int i = 0; i < vNum; i++)
    {
        for(int j = 0; j < hNum; j++)
        {
            m_patternSetBtnList[i*hNum+j]->setGeometry(24+98*j,24+106*i,58,58);
            m_patternSetLabelList[i*hNum+j]->setGeometry(14+98*j,84+106*i,81,40);
        }
    }

    //参数设置
    ui->frameParaSet->setGeometry(108,36,707,513);
    hNum = 7;//每行7个
    vNum = 2;//总共2行
    for(int i = 0; i < vNum; i++)
    {
        for(int j = 0; j < hNum; j++)
        {
            m_paraSetBtnList[i*hNum+j]->setGeometry(24+98*j,24+106*i,58,58);
            m_paraSetLabelList[i*hNum+j]->setGeometry(14+98*j,84+106*i,81,40);
        }
    }

    //调试
    ui->frameDebugFunction->setGeometry(108,36,707,513);
    hNum = 7;//每行7个
    vNum = 2;//总共2行
    for(int i = 0; i < vNum; i++)
    {
        for(int j = 0; j < hNum; j++)
        {
            m_debugBtnList[i*hNum+j]->setGeometry(24+98*j,24+106*i,58,58);
            m_debugLabelList[i*hNum+j]->setGeometry(14+98*j,84+106*i,81,40);
        }
    }
    ui->buttonDebugClose->setGeometry(586,460,100,40);

    //快进回退
    ui->frameForwardBack->setGeometry(816,30,194,530);
    ui->frameForwardBackBack->setGeometry(0,0,194,530);
    ui->labelForwardBackTitle->setGeometry(48,13,110,28);
    ui->buttonNeedleIdxImage->setGeometry(23,45,8,25);
    ui->labelNeedleCurAndTotal->setGeometry(50,45,105,28);
    ui->buttonColorIdxImage->setGeometry(20,80,15,20);
    ui->labelColorCurAndTotal->setGeometry(50,75,110,28);
    ui->buttonNeedleBegin->setGeometry(15,120,80,36);
    ui->buttonNeedleDec1->setGeometry(15,170,80,36);
    ui->buttonNeedleDec10->setGeometry(15,220,80,36);
    ui->buttonNeedleDec100->setGeometry(15,270,80,36);
    ui->buttonNeedleDec1000->setGeometry(15,320,80,36);
    ui->buttonNeedleDec10000->setGeometry(15,370,80,36);
    ui->buttonColorDec->setGeometry(15,420,80,36);
    ui->buttonForwardBackOk->setGeometry(16,480,80,36);
    ui->buttonNeedleEnd->setGeometry(102,120,80,36);
    ui->buttonNeedleAdd1->setGeometry(102,170,80,36);
    ui->buttonNeedleAdd10->setGeometry(102,220,80,36);
    ui->buttonNeedleAdd100->setGeometry(102,270,80,36);
    ui->buttonNeedleAdd1000->setGeometry(102,320,80,36);
    ui->buttonNeedleAdd10000->setGeometry(102,370,80,36);
    ui->buttonColorAdd->setGeometry(102,420,80,36);
    ui->buttonForwardBackCancel->setGeometry(102,480,80,36);

    //快捷功能
    ui->frameShortcutFunction->setGeometry(108,36,707,513);
    hNum = 7;//每行7个
    vNum = 4;//总共4行
    for(int i = 0; i < vNum; i++)
    {
        for(int j = 0; j < hNum; j++)
        {
            m_quickBtnList[i*hNum+j]->setGeometry(24+98*j,24+106*i,58,58);
            m_quickLabelList[i*hNum+j]->setGeometry(6+98*j,84+106*i,95,40);//字体显示不全  -rq
        }
    }
    ui->buttonShortCutPgUp->setGeometry(476,460,100,40);
    ui->buttonShortCutPgDn->setGeometry(586,460,100,40);
    ui->labelShortCutPage->setGeometry(376,460,100,40);
}

//初始化窗体控件样式
void MainWidget::initControlStyle()
{
    //上状态栏时间
    ui->labelTime->setFont(fontNormal_6);
    ui->labelTime->setStyleSheet(LABELWHITESTYLE);
    ui->buttonWifi->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonWifi->objectName()+"Unconnect"));

    //背景透明
    ui->frameUp->setStyleSheet(TRANSPARENTSTYLE);
    ui->frameMainFunction->setStyleSheet(TRANSPARENTSTYLE);
    ui->frameAccessFunction->setStyleSheet(TRANSPARENTSTYLE);
    ui->frameDebugFunction->setStyleSheet(TRANSPARENTSTYLE);
    ui->framePatternSet->setStyleSheet(TRANSPARENTSTYLE);
    ui->frameShortcutFunction->setStyleSheet(TRANSPARENTSTYLE);
    ui->frameParaSet->setStyleSheet(TRANSPARENTSTYLE);
    ui->frameDown->setStyleSheet(TRANSPARENTSTYLE);
    ui->frameEmbInfo->setStyleSheet(TRANSPARENTSTYLE);

    ui->framePatternView->setStyleSheet(TRANSPARENTSTYLE);
    ui->frameFunctionBtn->setStyleSheet(TRANSPARENTSTYLE);
    QString style = "background-color: rgb(246, 242, 239);outline:none;border:0px;border-radius:10px;";
    ui->frameMenuBack->setStyleSheet(style);

    //设置控件图标
    //背景图
    int waterMark = g_pSettings->readFromIniFile("HMI/waterMark").toInt();//是否带水印
    QString backGroundImgPath;
    if(waterMark == 1)
    {
        backGroundImgPath = m_setControlStyle.getBorderImageStyleSheet(this->objectName());
    }
    else if(waterMark == 0)
    {
        backGroundImgPath = m_setControlStyle.getBorderImageStyleSheet(this->objectName() + "_NoWaterMark");
        qDebug()<<backGroundImgPath;
    }
    ui->frameBack->setStyleSheet(backGroundImgPath);
    if(g_emDebugMode == debugMode)
    {
        ui->labelTitle->setStyleSheet(LABELREDSTYLE);
    }
    else
    {
        ui->labelTitle->setStyleSheet(LABELWHITESTYLE);
    }
    ui->labelTitle->setFont(fontBold_1);

    //获得绘制区域的背景图，用于embdata绘制刷新图形时的背景
    int x = ui->labelPatternView->x() + ui->framePatternView->x();
    int y = ui->labelPatternView->y() + ui->framePatternView->y();
    QImage MainWidgetPix;
    MainWidgetPix.load(getBackImagePath(waterMark));//主界面背景图

    //从主界面背景图截取等于labelPatternView的背景图
    m_embBackPix = QPixmap(ui->labelPatternView->width(),ui->labelPatternView->height());
    m_embBackPix = QPixmap::fromImage(MainWidgetPix.copy(x,y,m_embBackPix.width(),m_embBackPix.height()));

    //状态图标
    ui->buttonConnect->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonConnect->objectName()+"Unconnected"));
    ui->buttonUser->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonUser->objectName()));

    //主功能键图标
    ui->labelMainMenu->setFont(fontNormal_6);
    ui->labelMainMenu->setStyleSheet(LABELWHITESTYLE);
    ui->labelPatternSet->setFont(fontNormal_6);
    ui->labelPatternSet->setStyleSheet(LABELWHITESTYLE);
    ui->labelAccessFunction->setFont(fontNormal_6);
    ui->labelAccessFunction->setStyleSheet(LABELWHITESTYLE);
    ui->labelParaSet->setFont(fontNormal_6);
    ui->labelParaSet->setStyleSheet(LABELWHITESTYLE);
    ui->labelShortcutFunction->setFont(fontNormal_6);
    ui->labelShortcutFunction->setStyleSheet(LABELWHITESTYLE);
    //ui->buttonMainMenu->setCheckedBottomImage(m_setControlStyle.getBottomStyleSheet(ui->buttonMainMenu->parent()->objectName()));
    ui->buttonMainMenu->setMainBtnBottomStyle();
    ui->buttonMainMenu->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonMainMenu->objectName()));
    ui->buttonPatternSet->setMainBtnBottomStyle();
    ui->buttonPatternSet->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonPatternSet->objectName()));
    ui->buttonAccessFunction->setMainBtnBottomStyle();
    ui->buttonAccessFunction->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonAccessFunction->objectName()));
    ui->buttonParaSet->setMainBtnBottomStyle();
    ui->buttonParaSet->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonParaSet->objectName()));
    ui->buttonShortcutFunction->setMainBtnBottomStyle();
    ui->buttonShortcutFunction->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonShortcutFunction->objectName()));

    //速度加减图标
    ui->lcdNumberSpeed->setFont(fontBold_1);
    ui->lcdNumberSpeed->setStyleSheet(LABELWHITESTYLE);
    ui->buttonSpeedAdd->setBottomImage(m_setControlStyle.getBottomStyleSheet(ui->buttonSpeedAdd->objectName()));
    ui->buttonSpeedDec->setBottomImage(m_setControlStyle.getBottomStyleSheet(ui->buttonSpeedDec->objectName()));

    //针杆图标
    ui->buttonNeedle->setLabelImage(m_setControlStyle.getStyleSheet(ui->buttonNeedle->objectName()));
    ui->buttonNeedle->setLabelNameFont(fontNormal_6);
    for(int i = 0; i < m_colorBtnList.size(); i++)
    {
        m_colorBtnList.at(i)->setFont(fontNormal_6);
        m_colorBtnList.at(i)->setEnabled(false);
    }

    ui->labelFilename->setFont(fontNormal_6);
    ui->labelFilename->setStyleSheet(LABELGREYSTYLE);
    ui->framePatternInfoImage->setStyleSheet(m_setControlStyle.getStyleSheet(ui->framePatternInfoImage->objectName()));
    ui->buttonPatternInfo->setStyleSheet(TRANSPARENTSTYLE);
    ui->labelX->setFont(fontNormal_6);
    ui->labelX->setStyleSheet(LABELWHITESTYLE);
    ui->labelXValue->setFont(fontNormal_6);
    ui->labelXValue->setStyleSheet(LABELWHITESTYLE);
    ui->labelY->setFont(fontNormal_6);
    ui->labelY->setStyleSheet(LABELWHITESTYLE);
    ui->labelYValue->setFont(fontNormal_6);
    ui->labelYValue->setStyleSheet(LABELWHITESTYLE);

    ui->labelW->setFont(fontNormal_6);
    ui->labelW->setStyleSheet(LABELWHITESTYLE);
    ui->labelWValue->setFont(fontNormal_6);
    ui->labelWValue->setStyleSheet(LABELWHITESTYLE);
    ui->labelH->setFont(fontNormal_6);
    ui->labelH->setStyleSheet(LABELWHITESTYLE);
    ui->labelHValue->setFont(fontNormal_6);
    ui->labelHValue->setStyleSheet(LABELWHITESTYLE);
        ui->labelC->setFont(fontNormal_6);
        ui->labelC->setStyleSheet(LABELWHITESTYLE);
        ui->labelCValue->setFont(fontNormal_6);
        ui->labelCValue->setStyleSheet(LABELWHITESTYLE);
    ui->labelN->setFont(fontNormal_6);
    ui->labelN->setStyleSheet(LABELWHITESTYLE);
    ui->labelNValue->setFont(fontNormal_6);
    ui->labelNValue->setStyleSheet(LABELWHITESTYLE);

    //绣作信息图标
    ui->labelWorkingTime->setFont(fontNormal_6);
    ui->labelWorkingTime->setStyleSheet(LABELWHITESTYLE);
    ui->buttonWorkingTime->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonWorkingTime->objectName()));
    ui->labelNeedleNum->setFont(fontNormal_6);
    ui->labelNeedleNum->setStyleSheet(LABELWHITESTYLE);
    ui->buttonNeedleNum->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonNeedleNum->objectName()));
    ui->labelSpindleAngle->setFont(fontNormal_6);
    ui->labelSpindleAngle->setStyleSheet(LABELWHITESTYLE);
    ui->buttonSpindleAngle->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonSpindleAngle->objectName()));
    ui->labelColorOrder->setFont(fontNormal_6);
    ui->labelColorOrder->setStyleSheet(LABELWHITESTYLE);
    ui->buttonColorOrder->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonColorOrder->objectName()));
    ui->labelNeedleIdx->setFont(fontNormal_6);
    ui->labelNeedleIdx->setStyleSheet(LABELWHITESTYLE);
    ui->progressBarProgress->setAlignment(Qt::AlignCenter);
    ui->progressBarProgress->setStyleSheet(PROGRESSBARSTYLE2);
    ui->progressBarProgress->setFont(fontNormal_6);
    ui->buttonNeedleIdx->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonNeedleIdx->objectName()));
    ui->labelCoorXY->setFont(fontNormal_6);
    ui->labelCoorXY->setStyleSheet(LABELWHITESTYLE);
    ui->labelRelativeCoorXY->setFont(fontNormal_6);
    ui->labelRelativeCoorXY->setStyleSheet(LABELWHITESTYLE);
    ui->buttonCoorXY->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonCoorXY->objectName()));
    ui->buttonRelativeCoorXY->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonRelativeCoorXY->objectName()));

    //10个常用快捷按钮
    ui->frameShortcutBtn->setStyleSheet(TRANSPARENTSTYLE);
    for(int i = 0; i < m_shortCutBtnList.size(); i++)
    {
        //界面下方快捷按钮的底图设置，底图和九宫格按钮的底图相同
        m_shortCutBtnList[i]->setBlueBorderBottomStyle();
        if(g_emMacType == MACHINE_ADHESIVE)
        {
            m_shortCutBtnList[i]->hide();
        }
    }

    //九宫格图标
    ui->frameNineBtn->setStyleSheet(m_setControlStyle.getBorderImageStyleSheet(ui->frameNineBtn->objectName()));
    ui->buttonNineBtn1->setBlueBorderBottomStyle();
    ui->buttonNineBtn1->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNineBtn1->objectName()));
    ui->buttonNineBtn2->setBlueBorderBottomStyle();
    ui->buttonNineBtn2->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNineBtn2->objectName()));
    ui->buttonNineBtnMiddle->setTopImage(m_setControlStyle.getTopStyleSheet("frameNineBtnMiddle_2"));//默认速度等级为2
    ui->buttonNineBtn3->setBlueBorderBottomStyle();
    ui->buttonNineBtn3->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNineBtn3->objectName()));
    ui->buttonNineBtn4->setBlueBorderBottomStyle();
    ui->buttonNineBtn4->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNineBtn4->objectName()));

    //压胶机隐藏按钮
    if(g_emMacType == MACHINE_ADHESIVE)
    {
        ui->buttonNineBtn2->hide();
        ui->buttonSpeedAdd->hide();
        ui->buttonSpeedDec->hide();
    }

    //快进快退
    ui->frameForwardBack->setStyleSheet(TRANSPARENTSTYLE);
    QString frameForwardBackBackImgPath = m_setControlStyle.getStyleSheet(ui->frameForwardBackBack->objectName());

    ui->frameForwardBackBack->setStyleSheet(frameForwardBackBackImgPath);
    ui->labelForwardBackTitle->setFont(fontNormal_6);
    ui->labelForwardBackTitle->setStyleSheet(LABELWHITESTYLE);
    ui->labelColorCurAndTotal->setFont(fontNormal_6);
    ui->labelColorCurAndTotal->setStyleSheet(LABELWHITESTYLE);
    ui->buttonColorIdxImage->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonColorIdxImage->objectName()));
    ui->labelNeedleCurAndTotal->setFont(fontNormal_6);
    ui->labelNeedleCurAndTotal->setStyleSheet(LABELWHITESTYLE);
    ui->buttonNeedleIdxImage->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonNeedleIdx->objectName()));
    ui->buttonNeedleBegin->setWhiteBlueBottomStyle();
    ui->buttonNeedleBegin->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNeedleBegin->objectName()),4);
    ui->buttonNeedleEnd->setWhiteBlueBottomStyle();
    ui->buttonNeedleEnd->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNeedleEnd->objectName()),4);
    ui->buttonNeedleAdd1->setWhiteBlueBottomStyle();
    ui->buttonNeedleAdd1->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNeedleAdd1->objectName()),4);
    ui->buttonNeedleAdd10->setWhiteBlueBottomStyle();
    ui->buttonNeedleAdd10->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNeedleAdd10->objectName()),4);
    ui->buttonNeedleAdd100->setWhiteBlueBottomStyle();
    ui->buttonNeedleAdd100->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNeedleAdd100->objectName()),4);
    ui->buttonNeedleAdd1000->setWhiteBlueBottomStyle();
    ui->buttonNeedleAdd1000->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNeedleAdd1000->objectName()),4);
    ui->buttonNeedleAdd10000->setWhiteBlueBottomStyle();
    ui->buttonNeedleAdd10000->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNeedleAdd10000->objectName()),4);
    ui->buttonColorAdd->setWhiteBlueBottomStyle();
    ui->buttonColorAdd->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonColorAdd->objectName()),4);
    ui->buttonNeedleDec1->setWhiteBlueBottomStyle();
    ui->buttonNeedleDec1->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNeedleDec1->objectName()),4);
    ui->buttonNeedleDec10->setWhiteBlueBottomStyle();
    ui->buttonNeedleDec10->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNeedleDec10->objectName()),4);
    ui->buttonNeedleDec100->setWhiteBlueBottomStyle();
    ui->buttonNeedleDec100->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNeedleDec100->objectName()),4);
    ui->buttonNeedleDec1000->setWhiteBlueBottomStyle();
    ui->buttonNeedleDec1000->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNeedleDec1000->objectName()),4);
    ui->buttonNeedleDec10000->setWhiteBlueBottomStyle();
    ui->buttonNeedleDec10000->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNeedleDec10000->objectName()),4);
    ui->buttonColorDec->setWhiteBlueBottomStyle();
    ui->buttonColorDec->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonColorDec->objectName()),4);
    ui->buttonForwardBackOk->setWhiteBlueBottomStyle();
    ui->buttonForwardBackOk->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonForwardBackOk->objectName()),4);
    ui->buttonForwardBackCancel->setWhiteBlueBottomStyle();
    ui->buttonForwardBackCancel->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonForwardBackCancel->objectName()),4);

    //快捷功能图标
    for(int i = 0; i < m_quickLabelList.size(); i++)
    {
        m_quickLabelList[i]->setFont(fontNormal_6);
        //28个快捷按钮的底图相同
        m_quickBtnList[i]->setOrangeGradientBottomStyle(BORDER_RADIUS1);
    }
    ui->buttonShortCutPgUp->setBlueBorderBottomStyle();
    ui->buttonShortCutPgDn->setBlueBorderBottomStyle();
    ui->buttonShortCutPgUp->setFont(fontNormal_6);
    ui->buttonShortCutPgDn->setFont(fontNormal_6);
    ui->labelShortCutPage->setFont(fontNormal_6);
    ui->labelShortCutPage->setStyleSheet(LABELBLACKSTYLE);

    //辅助功能图标
    for(int i = 0; i < m_assistLabelList.size(); i++)
    {
        m_assistLabelList[i]->setFont(fontNormal_6);
        //28个快捷按钮的底图相同
        m_assistBtnList[i]->setOrangeGradientBottomStyle(BORDER_RADIUS1);
    }
    ui->buttonAssistPgUp->setBlueBorderBottomStyle();
    ui->buttonAssistPgDn->setBlueBorderBottomStyle();
    ui->buttonAssistPgUp->setFont(fontNormal_6);
    ui->buttonAssistPgDn->setFont(fontNormal_6);
    ui->labelAssistPage->setFont(fontNormal_6);
    ui->labelAssistPage->setStyleSheet(LABELBLACKSTYLE);

    //花样设置功能图标
    for(int i = 0; i < m_patternSetLabelList.size(); i++)
    {
        m_patternSetLabelList[i]->setFont(fontNormal_6);
        //底图相同
        m_patternSetBtnList[i]->setOrangeGradientBottomStyle(BORDER_RADIUS1);
    }

    //参数设置功能图标
    for(int i = 0; i < m_paraSetLabelList.size(); i++)
    {
        m_paraSetLabelList[i]->setFont(fontNormal_6);
        //底图相同
        m_paraSetBtnList[i]->setOrangeGradientBottomStyle(BORDER_RADIUS1);
    }


    //调试功能图标
    for(int i = 0; i < m_debugLabelList.size(); i++)
    {
        m_debugLabelList[i]->setFont(fontNormal_6);
        //28个快捷按钮的底图相同
        m_debugBtnList[i]->setOrangeGradientBottomStyle(BORDER_RADIUS1);
    }
    ui->buttonDebugClose->setBlueBorderBottomStyle();
    ui->buttonDebugClose->setFont(fontNormal_6);

    //下方状态及版本
    ui->progressBar->setStyleSheet(PROGRESSBARSTYLE);
    ui->progressBar->setValue(0);
    ui->labelState->setFont(fontNormal_6);
    ui->labelState->setStyleSheet(LABELREDSTYLE);
    ui->labelHMIVersion->setFont(fontNormal_6);
    ui->labelHMIVersion->setStyleSheet(LABELWHITESTYLE);
}

//获取背景图的加载路径
QString MainWidget::getBackImagePath(s16 waterMark)
{
    //<分辨率><主题><窗体名称><图片名称>
    QString path = ":/images/";

    //分辨率
    QString str;
    str.clear();
    switch (g_emResolut)
    {
    case resolution1910:
        str = "_1910_logo.png";
        break;
    case resolution1006:
        str = "_1006_logo.png";
        break;
    default:
        break;
    }

    path += this->objectName() + "/" + this->objectName();
    if(waterMark == 0)//无水印
    {
        path += "_NoWaterMark" + str;
    }
    else
    {
        path += str;
    }

    //qDebug()<<path;
    return path;
}

//发送初始化字符串
void MainWidget::sendInitString(QString str)
{
    Qt::Alignment alignment = Qt::AlignHCenter|Qt::AlignBottom; // 设置一个格式
    emit(siSendLoadingMessage(str, alignment, Qt::red));
}

//刷新连接状态(1秒)
void MainWidget::refConnectUi(int alive)
{
    alive = 0;
    refConnectUi(g_pMachine, m_linkSta, alive);
}

//刷新连接状态
void MainWidget::refConnectUi(Machine *pMachine, int &linkSta, int alive)
{
//    if(m_ifHMIDecrypt == 0)
//    {
//        return;
//    }

    if(m_connectMode == USE_SERIAL_COMM)//串口连接方式
    {
        if(linkSta != pMachine->isConnected())
        {
            linkSta = pMachine->isConnected();
            if(linkSta == Connected)
            {
                if (pMachine != NULL)
                {
                    //连接后获取机器信息，用于获得剩余可用时间，小于5天主动提示用户
                    //此条语句需放在前面
                    pMachine->getInfoFromMachine();

                    pMachine->getSensorEnBmpFromMachine();//读取传感器信号
                    pMachine->getParasFromMachine();//获取参数
                    m_pMinTimer->start();//1分钟记录一次当前系统时间 ,连接成功以后开启计时器，记录时间 -rq
                    m_pMainWidgetFunction->setShutDownTime();//计算关机时间

                    ui->buttonConnect->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonConnect->objectName()));
                    ui->labelState->setText(tr("Connected"));//状态：已连接
                }
            }
            else
            {
                ui->buttonConnect->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonConnect->objectName()+"Unconnected"));
                ui->labelState->setText(tr("Not connected"));//状态：未连接
            }
        }
    }
    else
    {
        if (pMachine != NULL)
        {
            if (linkSta != pMachine->isConnected() ||
                    pMachine->isConnected() == Connectting ||
                    alive == -1)
            {
                if (alive == -1)
                {
                    linkSta = 0;
                }
                else
                {
                    linkSta = pMachine->isConnected();//获取连接状态
                }

                if (linkSta == Connectting)//连接中...
                {
                    ui->buttonConnect->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonConnect->objectName()+"Connecting"));
                    ui->labelState->setText(tr("Connnecting..."));//状态：连接中...
                }
                else if (linkSta == Connected)//已连接
                {
                    //连接后获取机器信息，用于获得剩余可用时间，小于5天主动提示用户
                    //此条语句需放在前面
                    pMachine->getInfoFromMachine();

                    pMachine->getSensorEnBmpFromMachine();//读取传感器信号
                    pMachine->getParasFromMachine();//获取参数
                    m_pMinTimer->start();//1分钟记录一次当前系统时间 ,连接成功以后开启计时器，记录时间 -rq
                    m_pMainWidgetFunction->setShutDownTime();//计算关机时间

                    ui->buttonConnect->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonConnect->objectName()));
                    ui->labelState->setText(tr("Connected"));//状态：已连接

                    /***
                界面启动时也会发送最后绣作的花样文件，
                连接成功后也会发送，但连接速度快，此时ds数据可能还没转换完成，
                所以连接成功后发送文件可能不成功，只是界面加载时会发送文件，
                因此二者不会重复发送文件；若断开连接再连接时此段代码会发送文件，
                界面加载部分不会发送；
                ***/
                    QByteArray ds16dat = g_pCurEmbData->getDsDat();//获得ds16数据
                    //如果当前所选文件路径不为空与ds16数据不为空时
                    if(m_curFilePath.length() > 0 && ds16dat.size() > 0)
                    {
                        //m_pMainWidgetFunction->sendPatternData(m_curFilePath);//发送花样数据
                        //设置为按进度执行模式
                        //g_pCurEmbData->setExecIndex(m_curDatIdx);     // 设置进度
                    }
                }
                else//未连接
                {
                    ui->buttonConnect->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonConnect->objectName()+"Unconnected"));
                    ui->labelState->setText(tr("Not connected"));//状态：未连接
                }
            }
        }
    }
}

//隐藏菜单栏(frame)
void MainWidget::hideMenuFrame()
{
    ui->frameMenuBack->setVisible(false);
    ui->framePatternView->setVisible(false);
    ui->frameShortcutBtn->setVisible(false);
    ui->framePatternSet->setVisible(false);
    ui->frameParaSet->setVisible(false);
    ui->frameAccessFunction->setVisible(false);
    ui->frameShortcutFunction->setVisible(false);
    ui->frameDebugFunction->setVisible(false);

    //设置按钮为非选中状态
    ui->buttonPatternSet->setChecked(false);
    ui->buttonPatternSet->setCheckable(false);
    ui->buttonAccessFunction->setChecked(false);
    ui->buttonAccessFunction->setCheckable(false);
    ui->buttonParaSet->setChecked(false);
    ui->buttonParaSet->setCheckable(false);
    ui->buttonShortcutFunction->setChecked(false);
    ui->buttonShortcutFunction->setCheckable(false);
    ui->buttonMainMenu->setChecked(false);
    ui->buttonMainMenu->setCheckable(false);
}

void MainWidget::resetAllData()
{
    m_forwardBackNeedleIdx = 0;
    m_forwardBackColorIdx = 0;
    ui->frameForwardBack->setVisible(false);

    g_pCurEmbData->getDsDat();

    //转换为ds16数据后设置色序表
    g_pCurEmbData->setDs16ColorOfTable(m_fileHead.switchTable);
    g_pCurEmbData->setEmbData();// ds16数据转换为画图数据

    //加载图片的进度条显示
    ui->progressBar->setVisible(true);
    int value = g_pCurEmbData->getStitchNums() / TENTHOUSANDNEEDLE;
    ui->progressBar->setRange(1,value);
    ui->progressBar->setValue(1);

    m_dispMode = EmbData::DISP_ALL_EXEC;
    g_pCurEmbData->setDispMode(m_dispMode, 1);    // 重新画图
    m_dispMode = EmbData::DISP_EXECING;           // 设置为执行模式
    g_pCurEmbData->setDispMode(m_dispMode, 0);    // 设置为按进度执行模式

    m_curColorIdx = 0;//当前色序
    m_curDatIdx = 0;
    ui->buttonNeedle->setLabelName(QString("%1").arg(0));  // 当前色序显示置为0
    refreshShowColorUi();

    ui->framePatternView->setVisible(true);
    QPixmap patternPix = g_pCurEmbData->getPreviewImage();
    ui->labelPatternView->setPixmap(patternPix);

    //刷新花样信息
    double width = g_pCurEmbData->getDatWidth()*0.01;
    ui->labelWValue->setText(QString("%1").arg(width));

    double height = g_pCurEmbData->getDatHeight()*0.01;
    ui->labelHValue->setText(QString("%1").arg(height));

    ui->labelCValue->setText(QString::number(g_pCurEmbData->getColorNums()));
    if(g_emMacType == MACHINE_PUNCH || g_emMacType == MACHINE_PUNCH_AUTOPOS)
    {
        ui->labelNValue->setText(QString::number(g_pCurEmbData->getPunchNum()));//冲孔个数
    }
    else
    {
        ui->labelNValue->setText(QString::number(g_pCurEmbData->getStitchNums()));
    }

    ui->labelWorkingTime->setText("0:0");
    QTextCodec *cod = QTextCodec::codecForLocale();
    ui->labelSpindleAngle->setText(cod->toUnicode("0°"));
    ui->labelColorOrder->setText(QString::number(m_curColorIdx+1));
    ui->labelNeedleIdx->setText(QString::number(m_curDatIdx));
    ui->progressBarProgress->setMaximum(g_pCurEmbData->getStitchNums());//进度条最大值
    ui->progressBarProgress->setMinimum(0);
    ui->progressBarProgress->setValue(m_curDatIdx);
    ui->labelCoorXY->setText("(0,0)");
    ui->labelRelativeCoorXY->setText("(0,0)");

    ui->progressBar->setVisible(false);
}

void MainWidget::refreshShowColorUi()
{
    QString btnStyle1 = "QPushButton{border:0px solid rgb(80,80,80);border-style:inset;border-radius:5px;";
    QString btnStyle2 = "QPushButton:checked{border:2px solid rgb(80,80,80);}";

    QString str;

    QRgb *pColorBuf;
    pColorBuf = (QRgb *)(g_pSettings->getColorRgbArray().data());

    QByteArray colorTable = g_pCurEmbData->getColorTable();
    int colorNum = colorTable.size();

    int colorIdx  = m_showColorIdxBegin;
    if(colorIdx < 0)
    {
        colorIdx = 0;
    }

    for (int i = 0; i < m_colorBtnList.size(); i++)
    {
        // 颜色显示
        if (colorIdx < colorNum)
        {
            int needleIdx = colorTable.at(colorIdx);
            QString idxStr;

            if(needleIdx > EMB_NEEDLE_NUM + PUNCH_NEEDLE_NUM)//缝纫针杆
            {
                needleIdx -= (EMB_NEEDLE_NUM + PUNCH_NEEDLE_NUM);
                idxStr = "SewNeedle/"+QString::number(needleIdx)+"_coloridx";
            }
            else if(needleIdx > EMB_NEEDLE_NUM)//冲孔针杆
            {
                needleIdx -= EMB_NEEDLE_NUM;
                idxStr = "PunchNeedle/"+QString::number(needleIdx)+"_coloridx";
            }
            else//绣花针杆
            {
                idxStr = "EmbNeedle/"+QString::number(needleIdx)+"_coloridx";
            }

            int colorInTab;
            if(g_pSettings->ifKeyExists(idxStr) == true)
            {
                colorInTab = g_pSettings->readFromIniFile(idxStr).toInt();
            }
            else
            {
                colorInTab = colorTable.at(colorIdx);
                if(colorInTab > EMB_NEEDLE_NUM + PUNCH_NEEDLE_NUM)//缝纫针杆
                {
                    colorInTab -= (EMB_NEEDLE_NUM + PUNCH_NEEDLE_NUM);
                }
                else if(colorInTab > EMB_NEEDLE_NUM)//冲孔针杆
                {
                    colorInTab -= EMB_NEEDLE_NUM;
                }
                colorInTab -= 1;
                if(colorInTab < 0){colorInTab = 0;}
            }

            if(g_emMacType == MACHINE_ADHESIVE)
            {
                colorInTab = colorTable.at(colorIdx);
            }

            // 文件中的色序
            QRgb rgb = pColorBuf[(colorInTab % BF_SW_ND)];
            rgb |= 0xff000000;
            QColor bkcolor(rgb);
            QColor tcolor = QColor(255-bkcolor.red(), 255-bkcolor.green(), 255-bkcolor.blue()).lighter(168);
            QString cstyle = btnStyle1 + "background-color:" + bkcolor.name() + ";"
                    + " color:" + tcolor.name() + ";}" + btnStyle2;

            m_colorBtnList.at(i)->setStyleSheet(cstyle);

            str.sprintf("%d", colorIdx+1);
            m_colorBtnList.at(i)->setText(str);
            m_colorBtnList.at(i)->show();

            //选择显示
            if (colorIdx == m_curColorIdx || colorIdx == 0)//等于当前正在绣作的颜色
            {
                QString buttonStyle = "background-color:" + bkcolor.name() + ";" + "border-radius:10px;";
                ui->buttonNeedle->setBtnBackColor(buttonStyle);
                QString labelStyle = "color:" + tcolor.name() + ";";
                ui->buttonNeedle->setLabelNameStyle(labelStyle);
                m_colorBtnList.at(i)->setCheckable(true);
                m_colorBtnList.at(i)->setChecked(true);
            }
        }
        else
        {
            m_colorBtnList.at(i)->hide();
        }

        colorIdx++;
    }
}

//花样选择
void MainWidget::patternSelect(int station)
{
    m_patternSelectStation = station;
    //选择新花样前将上一花样的断线次数保存到参数配置文件中
    if(m_curFilePath.length() > 0)
    {
        m_pMainWidgetFunction->setPatternHeadConfig(m_curFilePath,m_fileHead);
    }

    //获得花样选择的图标字符
    QString tStyle;
    for(int i = 0; i < m_patternSetItemList.size(); i++)
    {
        if(m_patternSetItemList[i].m_enumFunction == PATTERNSET_PATTERNSELECT ||
                m_patternSetItemList[i].m_enumFunction == PATTERNSET_PATTERNSELECT_STATION1||
                m_patternSetItemList[i].m_enumFunction == PATTERNSET_PATTERNSELECT_STATION2 )
        {
            QString topImageName = m_patternSetItemList[i].m_topImageName;
            //加载按钮顶图图标
            tStyle = m_setControlStyle.getTopStyleSheet(topImageName);

            break;
        }
    }

    m_pPatternSelectWi->setTypeLogo(tStyle);
    m_pPatternSelectWi->setMainTitle(tr("Pattern selection"));
    m_pPatternSelectWi->setSubTitle(tr("Pattern setting > Pattern selection"));

    m_pPatternSelectWi->createCurDirPatterns();
    m_pPatternSelectWi->refreshSettingInfo(m_curFilePath);
    m_pPatternSelectWi->show();
}

void MainWidget::patternColorSet()
{
    if(m_curFilePath.length() <= 0){return;}

    //获得花样色序设定的图标字符
    QString tStyle,bStyle;
    for(int i = 0; i < m_patternSetItemList.size(); i++)
    {
        if(m_patternSetItemList[i].m_enumFunction == PATTERNSET_PATTERNCOLOR)
        {
            QString topImageName = m_patternSetItemList[i].m_topImageName;
            //加载按钮顶图图标
            tStyle = m_setControlStyle.getTopStyleSheet(topImageName);
            bStyle = m_setControlStyle.getBottomStyleSheet(ui->buttonPatternSet1->parent()->objectName());

            break;
        }
    }

    m_pColorOrderSetWi->setTypeLogo(tStyle);

    //等于定位冲孔机-用文件中的色序
    if(g_emMacType == MACHINE_PUNCH_AUTOPOS)
    {
        memcpy(m_fileHead.switchTable,m_fileColorTable,sizeof(m_fileColorTable));
        m_pColorOrderSetWi->setMainTitle(tr("Color order set"));//色序设定
        m_pColorOrderSetWi->setSubTitle(tr("Pattern setting > Color order set"));//花样设置 > 色序设定
    }

    //等于压胶机-速度档位赋默认值
    if(g_emMacType == MACHINE_ADHESIVE)
    {
        m_pColorOrderSetWi->setMainTitle(tr("Speed gear"));//速度档位
        m_pColorOrderSetWi->setSubTitle(tr("Pattern setting > Speed gear"));//花样设置 > 速度档位

        for(u32 i = 0; i < sizeof(m_fileHead.switchTable)/sizeof(m_fileHead.switchTable[0]); i++)
        {
            //色序为0时赋一个默认值60
            if(i < g_pCurEmbData->getColorNums() && m_fileHead.switchTable[i] == 0)
            {
                m_fileHead.switchTable[i] = 60;
            }
        }
    }

    QByteArray colortab;
    colortab.clear();
    colortab.append((char*)(m_fileHead.switchTable),sizeof(m_fileHead.switchTable));//头文件的色序表

    m_pColorOrderSetWi->setColorTable(colortab,TYPE_COLORSET);//设置色序表
    m_pColorOrderSetWi->show(m_curFilePath);
}

void MainWidget::patternColorSetHeadHight()
{
    //获得花样色序设定的图标字符
    QString tStyle,bStyle;
    for(int i = 0; i < m_patternSetItemList.size(); i++)
    {
        if(m_patternSetItemList[i].m_enumFunction == PATTERNSET_PATTERNCOLOR)
        {
            QString topImageName = m_patternSetItemList[i].m_topImageName;
            //加载按钮顶图图标
            tStyle = m_setControlStyle.getTopStyleSheet(topImageName);
            bStyle = m_setControlStyle.getBottomStyleSheet(ui->buttonPatternSet1->parent()->objectName());

            break;
        }
    }

    m_pColorOrderSetWi->setTypeLogo(tStyle);
    m_pColorOrderSetWi->setMainTitle(tr("Head height"));//机头高度
    m_pColorOrderSetWi->setSubTitle(tr("Pattern setting > Head height"));//花样设置 > 机头高度

    QByteArray colortab;
    colortab.clear();
    colortab.append((char*)(m_fileHead.switchTable),sizeof(m_fileHead.switchTable));//头文件的色序表

    m_pColorOrderSetWi->setColorTable(colortab,TYPE_HIGHSET);//设置色序表
    m_pColorOrderSetWi->show(m_curFilePath);
}

void MainWidget::patternSwitching(QString fileid)
{
    if(fileid.length() != 4)
    {
        return;
    }

    QDir apppath(qApp->applicationDirPath());
    QString targetDir = apppath.absolutePath() + apppath.separator();
    QString tPath = targetDir + PATTERNPATH;
    QDir dir(tPath);//项目中所保存的路径
    dir.setFilter(QDir::AllEntries | QDir::NoDotAndDotDot);//设置过滤
    QFileInfoList fileList = dir.entryInfoList(QStringList()<<"*.dsr");// 获取.dsr的文件列表
    foreach (QFileInfo file,fileList)//遍历文件信息
    {
        if (file.isFile()) //是文件
        {
            QString fileName = file.filePath().right(file.filePath().length() - tPath.length() - 1);
            if(fileName.left(4) == fileid)
            {
                slotShowPatternPara(file.filePath(),-1);//不显示花样设置窗体，直接加载花样参数
            }
        }
        else //递归
        {
        }
    }
}

//显示机器运行状态中的信息
void MainWidget::showExecInfo()
{
    // 速度
    if (m_curRpm != (int)m_mcStatus.runSpeed)        // 运行速度
    {
        m_curRpm = (int)m_mcStatus.runSpeed;
        QString str;
        str.sprintf("%d", m_curRpm);
        ui->lcdNumberSpeed->display(str);
    }

    // 色序
    if (m_curColorIdx != (int)m_mcStatus.colorIdx)    // 当前色序(从0开始)
    {
        m_curColorIdx = (int)m_mcStatus.colorIdx;	 // 色序编码
        ui->labelColorOrder->setText(QString("%1").arg(m_curColorIdx + 1));
        m_showColorIdxBegin = m_curColorIdx;
        refreshShowColorUi();
    }

    // 文件执行进度(当前针数) labelNeedleIdx
    if (m_curDatIdx != (int)m_mcStatus.dataIdx)
    {
        m_curDatIdx = (int)m_mcStatus.dataIdx;
        reSetDatIdx(m_curDatIdx);
        QPixmap patternPix = g_pCurEmbData->getPreviewImage();
        ui->labelPatternView->setPixmap(patternPix);
    }

    // 当前xy绝对坐标
    double xPos = m_mcStatus.xPos*0.01;
    double yPos = m_mcStatus.yPos*0.01;
    QString xyStr = QString("(%1, %2)").arg(xPos).arg(yPos);
    ui->labelCoorXY->setText(xyStr);

    // 当前xy相对坐标
    double xRelPos = (m_mcStatus.xPos - m_pMainWidgetFunction->getBeginX())*0.01;
    double yRelPos = (m_mcStatus.yPos - m_pMainWidgetFunction->getBeginY())*0.01;
    QString xyRelStr = QString("(%1, %2)").arg(xRelPos).arg(yRelPos);
    ui->labelRelativeCoorXY->setText(xyRelStr);


    // 主轴角度
    QTextCodec *cod = QTextCodec::codecForLocale();
    QString angleStr;
    angleStr.sprintf("%.2f",(float)(m_mcStatus.embSpindleAngle*0.01));
    angleStr += cod->toUnicode("°");
    ui->labelSpindleAngle->setText(angleStr);

    // 机器运行总时长
    int totalTime = m_mcStatus.workTimer;
    int hour,min;
    if(totalTime > 60) //大于60分钟
    {
        hour = totalTime / 60;
        min = totalTime % 60;
    }
    else
    {
        hour = 0;
        min = totalTime;
    }
    //等于冲孔机、定位冲孔机
    if(g_emMacType == MACHINE_PUNCH || g_emMacType == MACHINE_PUNCH_AUTOPOS)
    {

        //start 单片工作时间  xcy 0926
        u32 thetimer = 0;
        thetimer = m_mcStatus.workTimeRecord;
        u32 theMinute = thetimer / (60 * 1000 ) ;//分钟
        u32 theSecond = (thetimer / 1000) % 60 ;//秒
        QString theMinuteRecord = QString::number(theMinute);
        QString theSecondRecord = QString::number(theSecond);
        QString theText = theMinuteRecord + ":" + theSecondRecord;
        ui->labelWorkingTime->setText(theText);

//        int theshow = g_pSettings->readFromInHMIiFile("AUFUS/closeshow").toInt();
//        if(theshow == 0)
//        {
//            ui->labelWorkingTime->setText(theText);
//        }
//        else if(theshow == 1)
//        {
//            ui->labelWorkingTime->setText("0:0");
//        }
        //end
    }
    //等于冲孔机、定位冲孔机end
    else
    {
        ui->labelWorkingTime->setText(QString("%1:%2").arg(hour).arg(min));
    }

    // 当前针杆
    if(m_mcStatus.needleIdx > 0)
    {
        ui->labelNeedleNum->setText(QString("%1").arg(m_mcStatus.needleIdx));
        ui->buttonNeedle->setLabelName(QString("%1").arg(m_mcStatus.needleIdx));
    }

//主轴角度
if((m_mcStatus.showSta & 1) == 0)//在位
{
    ui->buttonSpindleAngle->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonSpindleAngle->objectName()+"ZP"));
}
else//不在位
{
    ui->buttonSpindleAngle->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonSpindleAngle->objectName()));
}
}

void MainWidget::showPatternPreview()
{
    hideMenuFrame();
    QFile curfile(m_curFilePath);
    if(m_curFilePath.length() <= 0 ||
            (!curfile.exists()))//未选择文件时不显示颜色和花样信息
    {
        ui->framePatternView->setVisible(false);
    }
    else
    {
        ui->framePatternView->setVisible(true);
        ui->labelPatternView->setVisible(true);//非预览模式绘制区域
    }
    ui->frameShortcutBtn->setVisible(true);//下方的12个快捷常用按钮

    //主界面按钮选中
    ui->buttonMainMenu->setCheckable(true);
    ui->buttonMainMenu->setChecked(true);
}

//设置常用按钮
void MainWidget::setCommonBtn()
{
    QPoint point;
    point.setX(0);
    point.setY(0);

    for(int i = 0; i < m_shortCutBtnList.size(); i++)//窗体下方的快捷按钮列表 10个
    {
        int commonBtnIdx = g_pSettings->readFromIniFile("HMI/commonbtn"+QString::number(i+1)).toInt();
        QString btnStyle;
        btnStyle.clear();
        if(commonBtnIdx == FUN_NULL)
        {
            btnStyle = "buttonAddCommonFunctions";
        }
        else
        {
            btnStyle = getCommonBtnStyle(commonBtnIdx);//根据按钮索引找到对应按钮的图片名称
        }
        if(btnStyle.length() <= 0)
        {
            btnStyle = "buttonAddCommonFunctions";
        }
        m_shortCutBtnList[i]->setShortCutTopImage(m_setControlStyle.getTopStyleSheet(btnStyle),point);
    }
}

//设置UI界面按钮的使能
void MainWidget::setUiBtnEnable(bool bValue)
{
    ui->buttonNeedle->setEnabled(bValue);
    ui->frameMainFunction->setEnabled(bValue);
    ui->frameShortcutBtn->setEnabled(bValue);
    ui->buttonPatternInfo->setEnabled(bValue);
    ui->buttonNineBtn1->setEnabled(bValue);
    ui->buttonNineBtn2->setEnabled(bValue);
    ui->buttonNineBtn3->setEnabled(bValue);
    ui->buttonNineBtnUp->setEnabled(bValue);
    ui->buttonNineBtnDown->setEnabled(bValue);
    ui->buttonNineBtnLeft->setEnabled(bValue);
    ui->buttonNineBtnRight->setEnabled(bValue);
    //ui->buttonNineBtnMiddle->setEnabled(bValue);
}

void MainWidget::reSetDatIdx(int newidx)
{
    int totalStitchNum = g_pCurEmbData->getStitchNums();

    if (newidx <= 0)
    {
        m_curDatIdx = 0;         // 当前执行进度
    }
    else if (newidx >= totalStitchNum)
    {
        m_curDatIdx = m_curDatIdx - 1;         // 当前执行进度
    }

    // 文件idx信息
    QString str;
    str.sprintf("%d", m_curDatIdx);
    ui->labelNeedleIdx->setText(str);
    ui->progressBarProgress->setValue(m_curDatIdx+1);//最后一针是结束码

    // 更新进度显示
    g_pCurEmbData->setExecIndex(m_curDatIdx);
}

//前进回退
void MainWidget::funForwardOrBack()
{
    //显示主界面
    hideMenuFrame();
    setUiBtnEnable(false);
    showPatternPreview();
    m_forwardBackNeedleIdx = m_curDatIdx;
    addOrDecNeedleIdx(m_curDatIdx);
    m_forwardBackColorIdx = m_expara.newColorIdx;

    g_pCurEmbData->setExecIndex(m_forwardBackNeedleIdx);// 更新进度显示

    QPixmap patternPix = g_pCurEmbData->getPreviewImage();
    ui->labelPatternView->setPixmap(patternPix);

    int totalStitchNum = g_pCurEmbData->getStitchNums();
    QString strNeedle;
    strNeedle.sprintf("%d/%d",m_forwardBackNeedleIdx,totalStitchNum);
    ui->labelNeedleCurAndTotal->setText(strNeedle);

    int totalColorNum = g_pCurEmbData->getColorNums();
    QString strColor;
    if(m_forwardBackNeedleIdx == 0)
    {
        strColor.sprintf("%d/%d",0,totalColorNum);
    }
    else
    {
        strColor.sprintf("%d/%d",m_forwardBackColorIdx,totalColorNum);
    }
    ui->labelColorCurAndTotal->setText(strColor);

    ui->frameForwardBack->setVisible(true);
    ui->frameForwardBack->raise();
}

void MainWidget::addOrDecNeedleIdx(int &idx)
{
    if( g_pMachine == NULL || 0 )
    {
        return;
    }

    if(idx < 0)
    {
        idx = 0;
    }

    int totalColorNum = g_pCurEmbData->getColorNums();//总颜色数
    int totalStitchNum = g_pCurEmbData->getStitchNums();//总针数
    if(idx > totalStitchNum)
    {
        idx = totalStitchNum;
    }

    memset(&m_expara,0,sizeof(FileExecPara));

    int posx, posy, posr, cidx;
    posx = posy = cidx = 0;
    g_pCurEmbData->getPosInfoFromNeedleIdx(idx, posx, posy,posr,cidx);

    m_expara.newIdx = idx;
    m_expara.newXPos = posx;
    m_expara.newYPos = posy;
    m_expara.newRPos = posr;
    m_expara.newColorIdx = cidx;

    m_forwardBackColorIdx = cidx;

    QString strNeedle;
    strNeedle.sprintf("%d/%d",idx,totalStitchNum);
    ui->labelNeedleCurAndTotal->setText(strNeedle);

    QString strColor;
    if(idx == 0)
    {
        strColor.sprintf("%d/%d",0,totalColorNum);
    }
    else
    {
        strColor.sprintf("%d/%d",cidx,totalColorNum);
    }
    ui->labelColorCurAndTotal->setText(strColor);

    //画执行进度图
    g_pCurEmbData->setExecIndex(idx);// 更新针数

    QPixmap patternPix = g_pCurEmbData->getPreviewImage();
    ui->labelPatternView->setPixmap(patternPix);
}

void MainWidget::addOrDecColorIdx(int &idx, s16 flag)
{
    if( g_pMachine == NULL || 0 )
    {
        return;
    }

    if(flag == 1)
    {
        if(idx < 1)
        {
            idx = 1;
        }
    }
    else if(flag == -1)
    {
        if(idx < 0)
        {
            idx = 0;
        }
    }

    int totalStitchNum = g_pCurEmbData->getStitchNums();//总针数
    int totalColorNum = g_pCurEmbData->getColorNums();//总颜色数

    if(idx > totalColorNum)
    {
        idx = totalColorNum;
        return;
    }

    memset(&m_expara,0,sizeof(FileExecPara));

    int posx, posy, posr, cidx;
    g_pCurEmbData->getPosInfoFromColorIdx(cidx, posx, posy, posr, idx);

    m_expara.newIdx = cidx;
    m_expara.newXPos = posx;
    m_expara.newYPos = posy;
    m_expara.newRPos = posr;
    m_expara.newColorIdx = idx;

    m_forwardBackNeedleIdx = cidx;

    QString strNeedle;
    strNeedle.sprintf("%d/%d",cidx,totalStitchNum);
    ui->labelNeedleCurAndTotal->setText(strNeedle);

    QString strColor;
    strColor.sprintf("%d/%d",idx,totalColorNum);//显示为颜色索引减1
    ui->labelColorCurAndTotal->setText(strColor);

    //画执行进度图
    g_pCurEmbData->setExecIndex(cidx);// 更新针数

    QPixmap patternPix = g_pCurEmbData->getPreviewImage();
    ui->labelPatternView->setPixmap(patternPix);
}

//获取常用按钮样式
QString MainWidget::getCommonBtnStyle(int idx)
{
    QString styleStr;
    //检测快捷按钮条目
    for(int i = 0; i < m_quickItemList.size(); i++)//快捷功能中的快捷条目列表
    {
        int enumFun = m_quickItemList[i].m_enumFunction;
        if(idx == enumFun)//功能索引等于快捷按钮功能索引
        {
            //获取顶层图标样式表
            styleStr = m_quickItemList[i].m_topImageName;
            break;
        }
    }

    if(idx == FUN_PATTERNSELECT)//功能索引等于花样选择
    {
        //获得花样选择的图标字符
        for(int i = 0; i < m_patternSetItemList.size(); i++)
        {
            if(m_patternSetItemList[i].m_enumFunction == PATTERNSET_PATTERNSELECT)
            {
                styleStr = m_patternSetItemList[i].m_topImageName;
                break;
            }
        }
    }
    return styleStr;
}

void MainWidget::runCommonBtnFunction(int idx)
{
    if(m_pMainWidgetFunction == NULL)
    {
        return;
    }

    switch (idx)
    {
    case FUN_ALLTOZERO://全部归零
        m_pMainWidgetFunction->funAllToZero();
        break;

    case FUN_SPINDLEENABLE://主轴使能
        m_pMainWidgetFunction->funPunchMsSeverOn();
        break;

    case FUN_SPINDLEDISABLE://主轴失能
        m_pMainWidgetFunction->funPunchMsSeverOff();
        break;

    case FUN_BACKWORKPOINT://回工作点
        m_pMainWidgetFunction->funBackWorkPoint();
        break;

    case FUN_BACKANCHORPOINT://回定位点
        m_pMainWidgetFunction->funBackAnchorPoint();
        break;

    case FUN_BACKTHREADPOINT://回穿线点
        m_pMainWidgetFunction->funBackThreadPoint();
        break;

    case FUN_SETOFFSETPOINT://定偏移点
        m_pMainWidgetFunction->funSetOffsetPoint();
        break;

    case FUN_BACKOFFSETPOINT://回偏移点
        m_pMainWidgetFunction->funBackOffsetPoint();
        break;

    case FUN_SPINDLETEST://冲孔主轴研车
        m_pMainWidgetFunction->funPunchMsRun();
        break;

    case FUN_RETURNTOCENTERPOINT://回中心点
        m_pMainWidgetFunction->funBackCenterPoint();
        break;

    case FUN_SETSTARTPOINT://第一机头定起始点
    {
        if(m_curFilePath.length() <= 0)
        {
            return;
        }
        m_pMainWidgetFunction->funFirstHeadSetStartPoint(m_curFilePath);
        double xPos = g_pCurEmbData->getBeginX()*0.01;
        ui->labelXValue->setText(QString("%1").arg(xPos));
        double yPos = g_pCurEmbData->getBeginY()*0.01;
        ui->labelYValue->setText(QString("%1").arg(yPos));
        m_fileHead.beginX = g_pCurEmbData->getBeginX();
        m_fileHead.beginY = g_pCurEmbData->getBeginY();
    }
        break;

    case FUN_SETANCHORPOINT://定定位点
    {
        if(m_curFilePath.length() <= 0)
        {
            return;
        }
        m_pMainWidgetFunction->funFirstHeadSetAnchorPoint(m_curFilePath);
        double xPos = g_pCurEmbData->getAnchorX()*0.01;
        ui->labelXValue->setText(QString("%1").arg(xPos));
        double yPos = g_pCurEmbData->getAnchorY()*0.01;
        ui->labelYValue->setText(QString("%1").arg(yPos));
    }
        break;

    case FUN_SECSETSTARTPOINT://第二机头定起始点
    {
        if(m_curFilePath.length() <= 0)
        {
            return;
        }
        m_pMainWidgetFunction->funSecHeadSetStartPoint(m_curFilePath);
        double xPos = g_pCurEmbData->getBeginX()*0.01;
        ui->labelXValue->setText(QString("%1").arg(xPos));
        double yPos = g_pCurEmbData->getBeginY()*0.01;
        ui->labelYValue->setText(QString("%1").arg(yPos));
    }
        break;

    case FUN_SECSETANCHORPOINT://第二机头定定位点
    {
        if(m_curFilePath.length() <= 0)
        {
            return;
        }
        m_pMainWidgetFunction->funSecHeadSetAnchorPoint(m_curFilePath);
    }
        break;

    case FUN_THRIDSETSTARTPOINT://第三机头定起始点
    {
        if(m_curFilePath.length() <= 0)
        {
            return;
        }
        m_pMainWidgetFunction->funThrHeadSetStartPoint(m_curFilePath);
        double xPos = g_pCurEmbData->getBeginX()*0.01;
        ui->labelXValue->setText(QString("%1").arg(xPos));
        double yPos = g_pCurEmbData->getBeginY()*0.01;
        ui->labelYValue->setText(QString("%1").arg(yPos));
    }
        break;

    case FUN_THRIDSETANCHORPOINT://第三机头定定位点
    {
        if(m_curFilePath.length() <= 0)
        {
            return;
        }
        m_pMainWidgetFunction->funThrHeadSetAnchorPoint(m_curFilePath);
    }
        break;

    case FUN_SEWEMBSPINDLETEST://平绣主轴研车
        m_pMainWidgetFunction->funEmbMsRun();
        break;

    case FUN_SEWEMBSPINDLEJOG://平绣点动
        m_pMainWidgetFunction->funEmbSpindleJog();
        break;
    case FUN_SEWEMBCHANGECOLOR://平绣换色
        m_pMainWidgetFunction->funEmbManualChangeColor();
        break;

    case FUN_SEWEMBCUTLINE://平绣剪线
        m_pMainWidgetFunction->funEmbHeadCutLine();
        break;

    case FUN_BACKSTARTPOINT://回起始点
        m_pMainWidgetFunction-> funBackStartPoint();
        break;

    case FUN_CHECKFRAME://边框检查
    {
        if(m_curFilePath.length() <= 0)
        {
            break;
        }
        g_pMachine->getParasFromMachine();//获取参数，为了获取可工作区域边界
        m_pMainWidgetFunction->funBorderCheck();
    }
        break;

    case FUN_SEWHEADCUTLINEO://机头1剪线
        m_pMainWidgetFunction->funSewHeadCutLine(1);
        break;

    case FUN_SEWHEADCUTLINET://机头2剪线
        m_pMainWidgetFunction->funSewHeadCutLine(2);
        break;

    case FUN_FORWARDORBACK://前进回退
        funForwardOrBack();
        break;

    case FUN_PROCESSRESET://流程复位
        m_pMainWidgetFunction->funProcessReset();
        break;

    case FUN_PATTERNSELECT://花样选择
        patternSelect();
        break;

    case FUN_PUNCHSPINDLEJOG://冲孔主轴点动
        m_pMainWidgetFunction->funPunchSpindleJog();
        break;

    case FUN_PUNCHMANUALCHANGECOLOR://冲孔手动换色
        m_pMainWidgetFunction->funPunchManualChangeColor();
        break;

    case FUN_PUNCHNEEDLEZERO://冲孔换杆归零
        m_pMainWidgetFunction->funPunchRodZero();
        break;

    case FUN_SINGLEPUNCH://单次冲孔
        m_pMainWidgetFunction->funSinglePunch();
        break;

    case FUN_FRAMEZERO://框架归零
        m_pMainWidgetFunction->funGotoZeroPos();
        break;

    case FUN_MOVETORIGHTUP://去右上角
        m_pMainWidgetFunction->funGotoGorner(1);
        break;

    case FUN_MOVETORIGHTDOWN://去右下角
        m_pMainWidgetFunction->funGotoGorner(2);
        break;

    case FUN_MOVETOLEFTUP://去左上角

        m_pMainWidgetFunction->funGotoGorner(3);
        break;

    case FUN_MOVETOLEFTDOWN://去左下角
        m_pMainWidgetFunction->funGotoGorner(4);
        break;

    case FUN_SETWORKRANGE://定工作范围
        m_pMainWidgetFunction->funSetWorkRange();
        break;

    case FUN_TESTPOTENTIOMETER:// 测试电位器
        m_pMainWidgetFunction->funTestADC();
        break;

    case FUN_PUNCHSTOPLOWER://冲头停下位
        m_pMainWidgetFunction->funPunchMsDown();
        break;

    case FUN_DRAWOUTLINE://画轮廓线
        m_pMainWidgetFunction->funDrawOutline();
        break;

    case FUN_AUTOSETSTARTPOINT://自动定起始点
    {
        if(m_curFilePath.length() <= 0)
        {
            return;
        }
        m_pMainWidgetFunction->funAutoSetStartPoint(m_curFilePath);
    }
        break;

    case FUN_OILSUPPLY://连续供油
        m_pMainWidgetFunction->funContinuousOilSupply();
        break;

    case FUN_PUNCH_ROT_TO_ZERO://冲孔旋转去零位
        m_pMainWidgetFunction->funPunchRotToZero();
        break;

    case FUN_ROTATECOMPENSATE://旋转补偿
        if(m_pRotaComWi != NULL)
        {
            m_pRotaComWi->show();
        }
        break;

    case FUN_SEWSPINDLEJOG://缝纫主轴点动
        m_pMainWidgetFunction->funSewSpindleJog();
        break;

    case FUN_SEWHOOKPOSITION://缝纫主轴去勾线位
        m_pMainWidgetFunction->funToHookPosition();
        break;

    case FUN_EMBHOOKPOSITION://平绣主轴去勾线位
        m_pMainWidgetFunction->funEmbToHookPosition();
        break;

    case FUN_ROTATEPROOFREAD://缝纫旋转校对
        m_pMainWidgetFunction->funRotateProofread();
        break;

    case FUN_SEWSPINDLETEST://缝纫主轴研车
        m_pMainWidgetFunction->funSewMsRun();
        break;

    case FUN_SEWMOTORUPDOWN://缝纫机头升降
        m_pMainWidgetFunction->funSewheadUpDown();
        break;

    case FUN_SELECTSEWHEAD://切换缝纫机头
        m_pMainWidgetFunction->switchMachineHead(1);
        break;

    case FUN_NEEDLECONTRAST://针梭校对
        m_pMainWidgetFunction->funNeedleContrast(0);
        break;

    case FUN_BACKSHUTTLEPOS://回换梭位
        m_pMainWidgetFunction->funBackShuttlePos();
        break;

    case FUN_NEEDLESHUTTLERESET://针梭复位
        m_pMainWidgetFunction->funNeedleContrast(4);
        break;

    case FUN_NEEDLERESET://针复位
        m_pMainWidgetFunction->funNeedleContrast(3);
        break;

    case FUN_SHUTTLERESET://梭复位
        m_pMainWidgetFunction->funNeedleContrast(2);
        break;

    case FUN_SEWROTATEUP://缝纫旋转+
        m_pMainWidgetFunction->funSewRotate(1);
        break;

    case FUN_SEWROTATEDOWN://缝纫旋转-
        m_pMainWidgetFunction->funSewRotate(2);
        break;

    case FUN_SELECTPUCNHHEAD://切换冲孔机头
        m_pMainWidgetFunction->switchMachineHead(2);
        break;

    case FUN_SELECTEMBHEAD://切换平绣机头
        m_pMainWidgetFunction->switchMachineHead(3);
        break;

    case FUN_RESETALL://全部复位
        m_pMainWidgetFunction->funResetAll();
        break;

    case FUN_MOTORZEROING://电机归零
        m_pMainWidgetFunction->funMotorZeroing();
        break;

    case FUN_STATION1GLUING://工位1涂胶
        m_pMainWidgetFunction->funStationGluing(1);
        break;

    case FUN_STATION2GLUING://工位2涂胶
        m_pMainWidgetFunction->funStationGluing(2);
        break;

    case FUN_HEADUPDOWN://机头升降
        m_pMainWidgetFunction->funHeadUpDown();
        break;

    case FUN_TOSTATION1APOS://回工位1起始点
        m_pMainWidgetFunction->funToStationApos(1);
        break;

    case FUN_TOSTATION2APOS://回工位2起始点
        m_pMainWidgetFunction->funToStationApos(2);
        break;

    case FUN_TO_WAITTING_POS://回等料点
        m_pMainWidgetFunction->funToWaittingPos();
        break;

    case FUN_TO_REMOVE_GLUE_POS://回排胶点
        m_pMainWidgetFunction->funToRemoveGluePos();
        break;

    case FUN_REMOVE_GLUE_ONCE://排一次胶
        m_pMainWidgetFunction->funRemoveGlueOnce();
        break;

    case FUN_ADJUST_GLUE_HEGHT://校准胶管高度
        m_pMainWidgetFunction->funAdjustGlueHeight();
        break;

    case FUN_WORKPAUSE://暂停工作
        m_pMainWidgetFunction->funWorkPause();
        break;

    default:
        break;
    }
}

//执行辅助按钮功能
void MainWidget::runAssistBtnFunction(int funEnum,int idx)
{
    if(m_pMainWidgetFunction == NULL)
    {
        return;
    }

    QString topImageName = m_assistItemList[idx].m_topImageName;
    //加载按钮顶图图标
    QString tStyle = m_setControlStyle.getTopStyleSheet(topImageName);

    switch (funEnum)
    {
    case ASSIST_SENSOR://传感器信号
    {
        if (m_pSensorInputWi != NULL)
        {
            //注释掉此行代码，因为获取位图下位机会返回全on的状态，
            //会使传感器界面闪一下，在连接后读取了一下，这里不再读取
            //g_pMachine->getSensorEnBmpFromMachine();
            g_pMachine->entrySensorScan();

            m_pSensorInputWi->setTypeLogo(tStyle);
            m_pSensorInputWi->setMainTitle(tr("Sensor signal"));
            m_pSensorInputWi->setSubTitle(tr("Auxiliary function > Sensor signal"));
            m_pSensorInputWi->show();
        }
    }
        break;

    case ASSIST_CONTROLACTION://控制动作
    {
        if (m_pControlActionWi != NULL)
        {
            m_pControlActionWi->setTypeLogo(tStyle);
            m_pControlActionWi->setMainTitle(tr("Control action"));
            m_pControlActionWi->setSubTitle(tr("Auxiliary function > Control action"));

            m_pControlActionWi->refreshUi();
            m_pControlActionWi->show();
        }
    }
        break;

    case ASSIST_HMIUPGRADE://界面升级
    {
        if(g_emDebugMode == nodebugMode)
        {
            if(g_emUser != repair)//权限不够先登录
            {
                m_pMainWidgetFunction->slotUserLogin(repair);
                if(g_emUser != repair)//发送登录信号后，权限如果还没改变就返回
                    return;
            }
            if(m_pMainWidgetFunction != NULL)
            {
                m_pMainWidgetFunction->funHMIUpgrade(tStyle);
            }
        }
        else
        {
            if(m_pMainWidgetFunction != NULL)
            {
                m_pMainWidgetFunction->funHMIUpgrade(tStyle);
            }
        }
    }
        break;

    case ASSIST_MCUPGRADE://主控升级
    {
        if(g_emUser != repair)//权限不够先登录
        {
            m_pMainWidgetFunction->slotUserLogin(repair);
            if(g_emUser != repair)//发送登录信号后，权限如果还没改变就返回
                return;
        }

        if(m_pMainWidgetFunction != NULL)
        {
            m_pMainWidgetFunction->funMCUpgrade(tStyle);
        }
    }
        break;

    case ASSIST_PARAIMPORT://参数导入
    {
        if(g_emUser != repair)//权限不够先登录
        {
            m_pMainWidgetFunction->slotUserLogin(repair);
            if(g_emUser != repair)//发送登录信号后，权限如果还没改变就返回
            {
                return;//就不执行下边的代码，不显示界面
            }
        }
        if(m_pMainWidgetFunction != NULL)
        {
            m_pMainWidgetFunction->funImportParameter(tStyle);
        }
    }
        break;

    case ASSIST_PARAEXPORT://参数导出
    {
        if(g_emUser != repair)//权限不够先登录
        {
            m_pMainWidgetFunction->slotUserLogin(repair);
            if(g_emUser != repair)//发送登录信号后，权限如果还没改变就返回
            {
                return;
            }
        }
        g_pMachine->getInfoFromMachine();
        if(m_pMainWidgetFunction != NULL)
        {
            m_pMainWidgetFunction->funExportParameter();
        }
    }
        break;

    case ASSIST_SOFTWARESET://软件设置
    {
        m_pParameterSetDlg->setTypeLogo(tStyle);
        m_pParameterSetDlg->setMainTitle(tr("Accessibility"));
        m_pParameterSetDlg->setSubTitle(tr("Accessibility > Software setting"));
        //软件设置参数
        m_pParameterSetDlg->setItemList(operate,PARA_TYPE_SOFTWARESET);
        int language = g_pSettings->readFromIniFile("HMI/language").toInt();
        m_pParameterSetDlg->setItemValue(SET_LANGUAGE,language);  //语言

        //        int connectMode = g_pSettings->readFromIniFile("HMI/connectMode").toInt();
        //        m_pParameterSetDlg->setItemValue(SET_CONNECTMODE,connectMode);  //连接通讯方式

        m_pParameterSetDlg->exec();
    }
        break;

    case ASSIST_AUTHORIZATION://软件授权
    {
        m_pMainWidgetFunction->funSoftwareAuthor();
    }
        break;

    case ASSIST_NETWORK://网络管理
    {
        if(g_emUser != factory)//权限不够先登录
        {
            m_pMainWidgetFunction->slotUserLogin(factory);
            if(g_emUser != factory && g_emUser != root)//发送登录信号后，权限如果还没改变就返回
            {
                return;
            }
        }
        m_pParameterSetDlg->setTypeLogo(tStyle);
        m_pParameterSetDlg->setMainTitle(tr("Accessibility"));
        m_pParameterSetDlg->setSubTitle(tr("Accessibility > Network Manage"));

        //网络管理参数
        //添加相应主板数的IP参数
        m_pParameterSetDlg->setNetworkItemList(PARA_TYPE_NETWORKSET);
        m_pParameterSetDlg->exec();
    }
        break;

    case ASSIST_WIFI://WIFI管理
    {
        if(m_pMainWidgetFunction != NULL)
        {
            m_pMainWidgetFunction->funWIFI(tStyle);
        }
    }
        break;

    case ASSIST_NEEDLESET://针杆设置
    {
        if(g_emDebugMode == nodebugMode)
        {
            if(g_emUser != repair)//权限不够先登录
            {
                m_pMainWidgetFunction->slotUserLogin(repair);
                if(g_emUser != repair)//发送登录信号后，权限如果还没改变就返回
                {
                    return;
                }
            }
            m_pNeedleBarSetWi->setTypeLogo(tStyle);
            m_pNeedleBarSetWi->setMainTitle(tr("Needle setting"));
            m_pNeedleBarSetWi->setSubTitle(tr("Accessibility > Needle setting"));
            m_pNeedleBarSetWi->refreshTypeBtnShow();//刷新右上方按钮的显示,包括选中状态
            m_pNeedleBarSetWi->initNeedleBar();
            m_pNeedleBarSetWi->show();
        }
        else
        {
            m_pNeedleBarSetWi->setTypeLogo(tStyle);
            m_pNeedleBarSetWi->setMainTitle(tr("Needle setting"));
            m_pNeedleBarSetWi->setSubTitle(tr("Accessibility > Needle setting"));
            m_pNeedleBarSetWi->refreshTypeBtnShow();//刷新右上方按钮的显示,包括选中状态
            m_pNeedleBarSetWi->initNeedleBar();
            m_pNeedleBarSetWi->show();
        }
    }
        break;

    case ASSIST_TIMESET://时间设置
    {
        //得到当前时间
        QDateTime time;
        time = QDateTime::currentDateTime();//获取系统现在的时间

        QString yearStr = time.currentDateTime().toString("yyyy");
        QString monthStr = time.currentDateTime().toString("MM");
        QString dayStr = time.currentDateTime().toString("dd");
        QString hourStr = time.currentDateTime().toString("hh");
        QString minuteStr = time.currentDateTime().toString("mm");
        QString secondStr = time.currentDateTime().toString("ss");

        m_pParameterSetDlg->setTypeLogo(tStyle);
        m_pParameterSetDlg->setMainTitle(tr("Time setting"));
        m_pParameterSetDlg->setSubTitle(tr("Accessibility > Time setting"));
        //时间设置参数
        m_pParameterSetDlg->setItemList(operate,PARA_TYPE_TIMESET);
        m_pParameterSetDlg->setItemValue(1,yearStr.toInt());   //年
        m_pParameterSetDlg->setItemValue(2,monthStr.toInt());   //月
        m_pParameterSetDlg->setItemValue(3,dayStr.toInt());   //日
        m_pParameterSetDlg->setItemValue(4,hourStr.toInt());   //时
        m_pParameterSetDlg->setItemValue(5,minuteStr.toInt());   //分
        m_pParameterSetDlg->setItemValue(6,secondStr.toInt());   //秒

        m_pParameterSetDlg->exec();
    }
        break;

    case ASSIST_SHORTCUTSET://常用设置
    {
        m_pParameterSetDlg->setTypeLogo(tStyle);
        m_pParameterSetDlg->setMainTitle(tr("Common functions setting"));
        m_pParameterSetDlg->setSubTitle(tr("Accessibility > Common functions setting"));
        //常用功能设置
        m_pParameterSetDlg->setItemList(operate,PARA_TYPE_COMMONFUN);
        for(int i = 0; i < m_shortCutBtnList.size(); i++)//下方按钮
        {
            //读取配置文件获取功能索引
            int commonBtnIdx = g_pSettings->readFromIniFile("HMI/commonbtn"+QString::number(i+1)).toInt();
            m_pParameterSetDlg->setItemValue(i+1,commonBtnIdx);
        }

        if(m_pParameterSetDlg->exec() == 1)//点了 确认
        {
            for(int i = 0; i < m_shortCutBtnList.size(); i++)//窗体下方的快捷按钮列表
            {
                //将功能索引写入配置文件
                int commonBtnIdx = m_pParameterSetDlg->getItemValue(i+1);
                g_pSettings->writeToIniFile("HMI/commonbtn"+QString::number(i+1),commonBtnIdx);

                //1920x1080分辨率下设置图标居中
                QPoint point;
                point.setX(0);
                point.setY(0);

                if(g_emResolut == resolution1910)
                {
                    point.setX(5);
                    point.setY(5);
                }

                if(commonBtnIdx == FUN_NULL)//无功能
                {
                    QString btnStyle = "buttonAddCommonFunctions";
                    m_shortCutBtnList[i]->setShortCutTopImage(m_setControlStyle.getTopStyleSheet(btnStyle),point);
                    m_shortCutBtnList[i]->setVisible(true);
                }
                else
                {
                    //设置常用功能按钮顶图图标
                    QString btnStyle = getCommonBtnStyle(commonBtnIdx);
                    m_shortCutBtnList[i]->setShortCutTopImage(m_setControlStyle.getTopStyleSheet(btnStyle),point);
                    m_shortCutBtnList[i]->setVisible(true);
                }
            }
        }
    }
        break;

    case ASSIST_PRODUCTSTATICS://生产统计
    {
        int patternBreakLineNum = m_fileHead.breakLineParkNum;//花样断线停车次数
        m_pMainWidgetFunction->funProductStatistics(tStyle,m_curFilePath,patternBreakLineNum);
    }
        break;


    case ASSIST_ERRORLOG://错误日志
    {
        if(g_emDebugMode == nodebugMode)
        {
            if(g_emUser != repair)//权限不够先登录
            {
                m_pMainWidgetFunction->slotUserLogin(repair);
                if(g_emUser != repair)//发送登录信号后，权限如果还没改变就返回
                    return;
            }
            if(m_pMainWidgetFunction != NULL)
            {
                m_pMainWidgetFunction->funJournalError(tStyle);
            }
        }
        else
        {
            if(m_pMainWidgetFunction != NULL)
            {
                m_pMainWidgetFunction->funJournalError(tStyle);
            }
        }
    }
        break;

    case ASSIST_MCVERSION://N1版本信息
    {
        g_pMachine->getInfoFromMachine();
        m_pMainWidgetFunction->funGetMCVersionInfo();
    }
        break;

    case ASSIST_FACELINEDETECT://面线检测
    {
        m_pMainWidgetFunction->funFaceDetect();
    }
        break;

    case ASSIST_DEBUG:    //调试功能
        ui->framePatternView->setVisible(false);
        ui->frameShortcutBtn->setVisible(false);
        ui->framePatternSet->setVisible(false);
        ui->frameParaSet->setVisible(false);
        ui->frameAccessFunction->setVisible(false);
        ui->frameShortcutFunction->setVisible(false);
        //设置按钮为非选中状态
        ui->buttonPatternSet->setChecked(false);
        ui->buttonPatternSet->setCheckable(false);
        ui->buttonParaSet->setChecked(false);
        ui->buttonParaSet->setCheckable(false);
        ui->buttonShortcutFunction->setChecked(false);
        ui->buttonShortcutFunction->setCheckable(false);
        ui->buttonMainMenu->setChecked(false);
        ui->buttonMainMenu->setCheckable(false);
        ui->frameMenuBack->setVisible(true);
        ui->frameDebugFunction->setVisible(true);

        break;

    case ASSIST_ROOT://超级用户
    {
        if(g_emDebugMode == nodebugMode)
        {
            if(g_emUser != factory && g_emUser != root)//超级用户
            {
                m_pMainWidgetFunction->slotUserLogin(factory);
            }
            if(g_emUser == factory)
            {
                m_pParameterSetDlg->setTypeLogo(tStyle);
                m_pParameterSetDlg->setMainTitle(tr("Root"));
                m_pParameterSetDlg->setSubTitle(tr("Accessibility > Root"));
                //超级用户参数
                m_pParameterSetDlg->setItemList(factory,PARA_TYPE_ROOT);
                m_pParameterSetDlg->exec();
            }
            else if (g_emUser == root)
            {
                m_pParameterSetDlg->setTypeLogo(tStyle);
                m_pParameterSetDlg->setMainTitle(tr("Root"));
                m_pParameterSetDlg->setSubTitle(tr("Accessibility > Root"));
                //超级用户参数
                m_pParameterSetDlg->setItemList(root,PARA_TYPE_ROOT);
                m_pParameterSetDlg->exec();
            }
        }
        else
        {
            m_pParameterSetDlg->setTypeLogo(tStyle);
            m_pParameterSetDlg->setMainTitle(tr("Root"));
            m_pParameterSetDlg->setSubTitle(tr("Accessibility > Root"));
            //超级用户参数
            m_pParameterSetDlg->setItemList(root,PARA_TYPE_ROOT);
            m_pParameterSetDlg->exec();
        }
    }
        break;

    case ASSIST_BOTTOMLINECOUNTRESET://底线计数复位
    {
        if(m_pMainWidgetFunction != NULL)
        {
            m_pMainWidgetFunction->funBottomLineCountReset();
        }
    }
        break;

    case ASSIST_SHUTDOWN:    //关机
        m_pMainWidgetFunction->funShutDown();
        break;

    default:
        break;
    }
}
void MainWidget::runDebugBtnFunction(int funEnum)
{
    if(m_pMainWidgetFunction == NULL)
    {
        return;
    }

    switch (funEnum)
    {

    case DEBUG_NEEDLESHUTTLE: // 缝纫针梭调试
    {
        DialogNeedleShuttle dialogNeedleShuttle;
        connect(g_pMachine, SIGNAL(siParaChange(int, int)),
                &dialogNeedleShuttle, SLOT(paraChange(int, int)));// 参数改变
        dialogNeedleShuttle.setFunType(DialogNeedleShuttle::DEBUG_NEEDLESHUTTLE);
        dialogNeedleShuttle.exec();
    }
        break;
    case DEBUG_TRIM: // 剪线调试
    {
        DialogCutLine dialogCutLine;
        connect(g_pMachine, SIGNAL(siParaChange(int, int)),
                &dialogCutLine, SLOT(paraChange(int, int)));// 参数改变
        dialogCutLine.setFunType(DialogCutLine::DEBUG_TRIM);
        dialogCutLine.exec();
    }
        break;
    case DEBUG_DIECUTTER: // 冲刀调试
    {
        DialogDieCutter dialogDieCutter;
        dialogDieCutter.setFunType(DialogDieCutter::DEBUG_DIECUTTER);
        dialogDieCutter.exec();
    }
        break;
    default:
        break;
    }
}
//执行花样设置按钮功能
void MainWidget::runPatternSetBtnFunction(int funEnum, int idx)
{
    if(m_pMainWidgetFunction == NULL)
    {
        return;
    }

    QString topImageName = m_patternSetItemList[idx].m_topImageName;
    //加载按钮顶图图标
    QString tStyle = m_setControlStyle.getTopStyleSheet(topImageName);

    switch (funEnum)
    {
    case PATTERNSET_PATTERNSELECT://花样选择
        patternSelect();
        break;

    case PATTERNSET_PATTERNSELECT_STATION1://工位1花样选择
        patternSelect(1);
        break;

    case PATTERNSET_PATTERNSELECT_STATION2://工位2花样选择
        patternSelect(2);
        break;

    case PATTERNSET_PATTERNPARA://花样参数
        //showPatternPreview();
        slotShowPatternPara(m_curFilePath);
        break;

    case PATTERNSET_PATTERNCOLOR://花样色序
        patternColorSet();
        break;

    case PATTERNSET_PATTERNCOLOR_HEADHIGHT://机头高度
        patternColorSetHeadHight();
        break;

    case PATTERNSET_PATTERNIMPORT://花样导入
    {
        m_pPatternManageWi->setTypeLogo(tStyle);
        m_pPatternManageWi->setMainTitle(tr("Pattern import"));
        m_pPatternManageWi->setSubTitle(tr("Pattern setting > Pattern import"));

        PatternManageWidget::MANAGE_MODE mode = PatternManageWidget::MANAGE_IMPORT;

        QSize size = m_pPatternSelectWi->getImageSize();
        m_pPatternManageWi->setImportImageSize(size);
        m_pPatternManageWi->patternManage(mode);
    }
        break;

    case PATTERNSET_PATTERNEXPORT://花样导出
    {
        m_pPatternManageWi->setTypeLogo(tStyle);
        m_pPatternManageWi->setMainTitle(tr("Pattern export"));
        m_pPatternManageWi->setSubTitle(tr("Pattern setting > Pattern export"));

        PatternManageWidget::MANAGE_MODE mode = PatternManageWidget::MANAGE_EXPORT;
        m_pPatternManageWi->patternManage(mode);
    }
        break;

    case PATTERNSET_PATTERNDELETE://花样删除
    {
        if(g_emUser != repair)//权限不够先登录
        {
            m_pMainWidgetFunction->slotUserLogin(repair);
            if(g_emUser != repair)//发送登录信号后，权限如果还没改变就返回
            {
                return;
            }
        }
        m_pPatternManageWi->setTypeLogo(tStyle);
        m_pPatternManageWi->setMainTitle(tr("Pattern delete"));
        m_pPatternManageWi->setSubTitle(tr("Pattern setting > Pattern delete"));

        PatternManageWidget::MANAGE_MODE mode = PatternManageWidget::MANAGE_DELETE;
        m_pPatternManageWi->patternManage(mode);
    }
        break;

    default:
        break;
    }

}

//等待超时
void MainWidget::slotWaitTimout()
{
    m_timoutflag = 1;
}

//机器状态
void MainWidget::slotMachineStatus(int toggle)
{
    memcpy(&m_mcStatus, &g_pMachine->getMcStatus(), sizeof(MCStatus));

    if(m_pMainWidgetFunction != NULL)
    {
        //收到主控发的机器状态改变的信号，进到这个槽函数里(在MainWidgetFunction.cpp里用于读取电位器值)
        m_pMainWidgetFunction->setMcStates(m_mcStatus);
    }
    m_conFlag = toggle;

    if(m_pParameterSetDlg != NULL)
    {
        //将机器状态发给参数设置界面(用于刷新遍历状态)
        //m_pParameterSetDlg->setMcStates(m_mcStatus);
    }

    showExecInfo();//显示机器运行状态中的信息

    //工作状态，工作中按钮不可按，并显示大图
    if(m_workStatus != m_mcStatus.workStatus)
    {
        m_workStatus = m_mcStatus.workStatus;

        if ((m_workStatus & WORK_STA_SIMULATE) == WORK_STA_SIMULATE) //模拟工作
        {
            ui->labelWorkState->setStyleSheet(m_setControlStyle.getStyleSheet(ui->labelWorkState->objectName()));
            ui->buttonNineBtn3->setBlueBorderBottomStyle();
            ui->buttonNineBtn3->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNineBtn3->objectName()+"Simulate"));
            ui->labelWorkState->setVisible(true);
        }
        else //正常工作
        {
            ui->buttonNineBtn3->setBlueBorderBottomStyle();
            ui->buttonNineBtn3->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNineBtn3->objectName()));
            ui->labelWorkState->setVisible(false);
        }

        if ((m_workStatus & WORK_STA_ENSTATE) == WORK_STA_ENSTATE) //允许状态
        {
            ui->buttonNineBtn2->setBlueBorderBottomStyle();
            ui->buttonNineBtn2->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNineBtn2->objectName()));
            ui->labelEnableWorkState->setVisible(false);
        }
        else //正常工作
        {
            //禁止工作
            ui->labelEnableWorkState->setStyleSheet(m_setControlStyle.getStyleSheet(ui->labelEnableWorkState->objectName()));
            ui->buttonNineBtn2->setBlueBorderBottomStyle();
            ui->buttonNineBtn2->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNineBtn2->objectName()+"NoAllow"));
            ui->labelEnableWorkState->setVisible(true);
        }

        //正在工作,按钮不可按
        if((m_workStatus & WORK_STA_WORKING) == WORK_STA_WORKING)
        {
            ui->buttonNineBtn4->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNineBtn4->objectName()+"Unlock"));
            setUiBtnEnable(false);
            ui->frameNineBtn->setStyleSheet(m_setControlStyle.getBorderImageStyleSheet(ui->frameNineBtn->objectName()+"Disable"));

            ui->frameForwardBack->setVisible(false);
            //工作状态中，
            if(!ui->labelPatternView->isVisible())//不是主图灰图界面
            {
                hideMenuFrame();//隐藏菜单栏
                showPatternPreview();//显示花样显示页面
                ui->buttonMainMenu->setCheckable(true);
                ui->buttonMainMenu->setChecked(true);
            }
            //如果工作中错误提示窗体显示，则自动消失
            m_pMainWidgetFunction->funSetPromptDlgVisibleFalse();
        }
        else
        {
            ui->buttonNineBtn4->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNineBtn4->objectName()));
            setUiBtnEnable(true);

            ui->frameNineBtn->setStyleSheet(m_setControlStyle.getBorderImageStyleSheet(ui->frameNineBtn->objectName()));
        }
    }

    //错误代码
    if (m_mcStatus.errorCode == 0)
    {
        m_errorCode = m_mcStatus.errorCode;
        ui->labelState->setText(tr("Ready"));//状态：已就绪
        if((m_workStatus & WORK_STA_WORKING) == WORK_STA_WORKING)
        {
            ui->labelState->setText(tr("Working"));//状态: 工作中
        }
    }
    else
    {
        u32 errcode = m_mcStatus.errorCode;
        if(errcode != m_errorCode)
        {
            m_errorCode = errcode;

            QString info;
            info.clear();
            info = getErrStr(m_mcStatus.errorCode);
            //如果不是通用错误(即info为空)，就从机型cpp中的错误代码查找
            if(info.length() <= 0)
            {
                for(int i = 0; i < m_errorCodeAndStateItemList.size(); i++)
                {
                    if(m_mcStatus.errorCode == m_errorCodeAndStateItemList[i].m_code)
                    {
                        info = m_errorCodeAndStateItemList[i].m_name;
                        break;
                    }
                }
            }
            //如果不是通用错误也不是机型cpp中的错误代码，就显示未定义错误
            if(info.length() <= 0)
            {
                QString errorCode;
                errorCode.sprintf("CODE 0x%x", m_mcStatus.errorCode);
                info.append(tr("Undefined error,") + errorCode);//未定义错误,
            }

            ui->labelState->setText(info);//状态:

            if ((errcode > 0 && errcode < 0x100) || errcode > 0x200)
            {
                m_pMainWidgetFunction->funErrorPrompt(errcode,info);
                //将报错代码写入csv
                g_pSettings->writeToCsv(info,TYPE_ERROR);//保存
            }
        }
    }

    //等于压胶机
    if(g_emMacType == MACHINE_ADHESIVE)
    {
        if (m_fileIdx != m_mcStatus.fileIdx)  // 文件序号不一样的时候
        {
            m_fileIdx  = m_mcStatus.fileIdx ;

            if(m_fileIdx == 1)
            {
                m_curFilePath = g_pSettings->readFromIniFile("Pattern/station1").toString();
                slotShowPatternPara(m_curFilePath,-1);//不显示花样设置窗体，直接加载花样参数
            }
            else if(m_fileIdx == 2)
            {
                m_curFilePath = g_pSettings->readFromIniFile("Pattern/station2").toString();
                slotShowPatternPara(m_curFilePath,-1);//不显示花样设置窗体，直接加载花样参数
            }
            else if(m_fileIdx == 0)
            {
                qDebug() <<"m_fileIdx" <<m_fileIdx;
            }
            else
            {
                //花样切换
                QString curfileidx = QString::number(m_fileIdx);
                QString usefileidx = QString::number(m_fileIdx);
                if(curfileidx.length() == 1)
                {
                    usefileidx.push_front("00");
                    usefileidx.push_back("-");
                }
                else if(curfileidx.length() == 2)
                {
                    usefileidx.push_front("0");
                    usefileidx.push_back("-");
                }
                else if(curfileidx.length() == 3)
                {
                    usefileidx.push_back("-");
                }
                else
                {
                    usefileidx.push_back("+++++");
                }
                patternSwitching(usefileidx);
            }
        }
    }
}

void MainWidget::slotRefreshWifiIcon(bool bl)
{
    if(bl == true)//已连接
    {
        ui->buttonWifi->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonWifi->objectName()+"Connect"));
    }
    else
    {
        ui->buttonWifi->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonWifi->objectName()+"Unconnect"));
    }
}

void MainWidget::slotShowPatternPara(QString filePath,s16 showFlag)
{
    QString beforeFilePath = m_curFilePath;
    m_curFilePath = filePath;
    if(m_curFilePath.length() <= 0){return;}
    QFile file(m_curFilePath);
    if(!file.exists()){return;}//文件不存在

    //获得花样参数的图标
    QString tStyle;
    for(int i = 0; i < m_patternSetItemList.size(); i++)
    {
        if(m_patternSetItemList[i].m_enumFunction == PATTERNSET_PATTERNPARA)
        {
            QString topImageName = m_patternSetItemList[i].m_topImageName;
            //加载按钮顶图图标
            tStyle = m_setControlStyle.getTopStyleSheet(topImageName);
            break;
        }
    }

    m_pParameterSetDlg->setTypeLogo(tStyle);
    m_pParameterSetDlg->setMainTitle(tr("Pattern para"));//花样参数
    m_pParameterSetDlg->setSubTitle(tr("Pattern setting > Pattern para"));// 花样设置 > 花样参数
    //绣花花样参数-花样设置参数
    m_pParameterSetDlg->setItemList(operate,PARA_TYPE_PATTERN);

    //得到花样参数
    DataFileHead fileHead;
    memset(&fileHead,0,sizeof(DataFileHead));
    memset(fileHead.switchTable,0,sizeof(fileHead.switchTable));
    memset(m_fileColorTable,0,sizeof(m_fileColorTable));

    m_pMainWidgetFunction->getPatternHeadConfig(filePath,fileHead);
    memcpy(m_fileHead.switchTable,fileHead.switchTable,sizeof(fileHead.switchTable));

    //int size = sizeof(m_fileHead);

    //起始点和定位点
    QFileInfo fileInfo(m_curFilePath);
    QString ext = fileInfo.suffix().toUpper();
    int beginX,beginY,anchorX,anchorY;
    beginX = beginY = 0;
    anchorX = anchorY = 0;

    if(ext == "DST")//dst文件
    {
        DataFileDst dst;
        dst.getBeginXYAndAnchorXY(m_curFilePath,beginX,beginY,anchorX,anchorY);
    }
    else if(ext == "DSR")//dsr文件
    {
        DataFileDsr dsr;
        //得到dsr源文件中的起始点和定位点
        dsr.getBeginXYAndAnchorXY(m_curFilePath,beginX,beginY,anchorX,anchorY);
    }
    else
    {
        return;
    }

    //等于垫板冲孔机-自动定位
    if(g_emMacType == MACHINE_PUNCH_AUTOPOS )
    {
        //行程矫正
        if(g_pSettings->readFromIniFile("AUFUS/zeroXcoordinate").toInt() - beginX >= 0)
        {
            fileHead.beginX = g_pSettings->readFromIniFile("AUFUS/zeroXcoordinate").toInt() - beginX;
        }
        else
        {
            fileHead.beginX = beginX;
        }
        fileHead.beginY = beginY;
        fileHead.anchorX = anchorX;
        fileHead.anchorY = anchorY;
    }

    if(g_emMacType == MACHINE_ADHESIVE  || g_emMacType == MACHINE_PUNCH)
    {
        m_pParameterSetDlg->setItemValue(SET_STARTX,fileHead.beginX);     //起始点x
        m_pParameterSetDlg->setItemValue(SET_STARTY,fileHead.beginY);     //起始点y
    }
    else if(g_emMacType == MACHINE_PUNCH_SEW_EMB)
    {
        m_pParameterSetDlg->setItemValue(SET_STARTX,fileHead.beginX);     //起始点x
        m_pParameterSetDlg->setItemValue(SET_STARTY,fileHead.beginY);     //起始点y
        m_pParameterSetDlg->setItemValue(SET_ANCHORX,fileHead.anchorX);     //定位点x
        m_pParameterSetDlg->setItemValue(SET_ANCHORY,fileHead.anchorY);     //定位点y
        m_pParameterSetDlg->setItemValue(SET_CONTINURUNCOMP,fileHead.continuRunComp);     //连续动框补偿
        m_pParameterSetDlg->setItemValue(SET_NEEDLETIPCOMP,fileHead.needleTipComp);     //针尖补偿
    }

    m_pParameterSetDlg->setItemValue(SET_ROTATESTYLE,fileHead.rotateStyle);     //旋转式样
    m_pParameterSetDlg->setItemValue(SET_HORIZONTALSTYLE,fileHead.horizontalStyle);     //水平翻转式样
    m_pParameterSetDlg->setItemValue(SET_VERTICALSTYLE,fileHead.verticalStyle);     //垂直翻转式样
    m_pParameterSetDlg->setItemValue(SET_ROTATEANGLE,fileHead.rotateAngle);     //旋转角度
    m_pParameterSetDlg->setItemValue(SET_SPLITSTITCHLENGTH,fileHead.stitchSplitLength);     //需要分割针步的长度

    m_pParameterSetDlg->setCurPage(1);

    s16 value = 0;
    if(showFlag != 0)//不显示此窗体直接加载花样参数(适用于开机自动加载花样文件)
    {
        value = 1;
    }
    else //显示此窗体
    {
        value = m_pParameterSetDlg->exec();
        m_pPatternSelectWi->hide();
    }

    if(value == 1)//花样参数设置(点击了确定按钮或直接加载文件后加载花样参数)
    {
        memcpy(&m_fileHead,&fileHead,sizeof(DataFileHead));

        //等于压胶机
        if(g_emMacType == MACHINE_ADHESIVE)
        {
            if(m_patternSelectStation == 1)
            {
                g_pSettings->writeToIniFile("Pattern/station1",filePath);
            }
            else if(m_patternSelectStation == 2)
            {
                g_pSettings->writeToIniFile("Pattern/station2",filePath);
            }
        }

        //有花样时花样参数可按
        for(int i = 0; i < m_patternSetItemList.size(); i++)
        {
            if(m_patternSetItemList[i].m_enumFunction == PATTERNSET_PATTERNPARA ||
                    m_patternSetItemList[i].m_enumFunction == PATTERNSET_PATTERNCOLOR ||
                    m_patternSetItemList[i].m_enumFunction == PATTERNSET_PATTERNCOLOR_HEADHIGHT)
            {
                m_patternSetBtnList[i]->setEnabled(true);
            }
        }

        //文件头花样参数
        m_fileHead.rotateStyle = m_pParameterSetDlg->getItemValue(SET_ROTATESTYLE);    //旋转式样
        m_fileHead.horizontalStyle = m_pParameterSetDlg->getItemValue(SET_HORIZONTALSTYLE);    //水平翻转式样
        m_fileHead.verticalStyle = m_pParameterSetDlg->getItemValue(SET_VERTICALSTYLE);    //垂直翻转式样
        m_fileHead.rotateAngle = m_pParameterSetDlg->getItemValue(SET_ROTATEANGLE);    //旋转角度
        m_fileHead.stitchSplitLength = m_pParameterSetDlg->getItemValue(SET_SPLITSTITCHLENGTH);    //需要分割针步的长度
        m_fileHead.continuRunComp = m_pParameterSetDlg->getItemValue(SET_CONTINURUNCOMP);    //连续动框补偿
        m_fileHead.needleTipComp = m_pParameterSetDlg->getItemValue(SET_NEEDLETIPCOMP);    //针尖补偿

        s32 begX,begY,anchorX,anchorY;
        begX = begY = anchorX = anchorY = 0;

        begX = m_pParameterSetDlg->getItemValue(SET_STARTX);    //起始点x
        begY = m_pParameterSetDlg->getItemValue(SET_STARTY);    //起始点y
        anchorX = m_pParameterSetDlg->getItemValue(SET_ANCHORX);
        anchorY = m_pParameterSetDlg->getItemValue(SET_ANCHORY);

        //等于压胶机等机型
        if(g_emMacType == MACHINE_ADHESIVE  || g_emMacType == MACHINE_PUNCH || g_emMacType == MACHINE_PUNCH_SEW_EMB)
        {
            if(m_fileHead.beginX != begX || m_fileHead.beginY != begY || m_fileHead.anchorX != anchorX || m_fileHead.anchorY != anchorY)
            {
                m_fileHead.beginX = begX;
                m_fileHead.beginY = begY;
                m_fileHead.anchorX = anchorX;
                m_fileHead.anchorY = anchorY;
            }
        }

        slotSetPatternData();//设置花样数据并显示

        //花版的定位点为绝对坐标数据点，起始点为相对于定位点的相对坐标点，第一针为相对于起始点的坐标点
        //有的花版起始点有偏移量，第一针偏移量为0，有的花版起始点偏移量为0，第一针有偏移量
        //所以ds16文件头定位点坐标就是花版中的定位点，起始点坐标为花版中的定位点坐标+起始点坐标+第一针的坐标，同时ds16数据的第一针坐标偏移应置为0
        //将起始点设置到ds16数据中-放在发送数据前
//        m_fileHead.beginX = m_fileHead.anchorX + m_fileHead.beginX + g_pCurEmbData->getBeginX();
//        m_fileHead.beginY = m_fileHead.anchorY + m_fileHead.beginY + g_pCurEmbData->getBeginY();
        if(g_emMacType == MACHINE_PUNCH_SEW)
        {
            //冲缝机 定位点和起始点一样
            m_fileHead.beginX= m_fileHead.anchorX;
            m_fileHead.beginY=m_fileHead.anchorY;
        }
       //定位点写回ds16和头文件中
        m_pMainWidgetFunction->funSetStartPoint(filePath,m_fileHead.beginX,m_fileHead.beginY);
        if(g_emMacType == MACHINE_PUNCH_SEW_EMB)
        {
            m_pMainWidgetFunction->funSetAnchorPoint(filePath,m_fileHead.anchorX,m_fileHead.anchorY);
        }
        double xPos = m_fileHead.beginX*0.01;
        ui->labelXValue->setText(QString("%1").arg(xPos));
        double yPos = m_fileHead.beginY*0.01;
        ui->labelYValue->setText(QString("%1").arg(yPos));

        if(m_linkSta == Connected)//已连接
        {
            m_pMainWidgetFunction->sendPatternData(m_curFilePath);//发送花样数据

            //设置为按进度执行模式
            g_pCurEmbData->setExecIndex(m_curDatIdx);     // 设置进度
        }
    }
    else
    {
        //点击取消按钮后花样路径恢复为上次选中的花样
        m_curFilePath = beforeFilePath;
    }
}

//删除文件后判断当前文件是否被删除
void MainWidget::slotIfFileExist()
{
    if(m_curFilePath.length() > 0)//当前选择的花样路径
    {
        QFile file(m_curFilePath);
        if(!file.exists())//不存在
        {
            m_curFilePath.clear();

            //花样参数可按
            for(int i = 0; i < m_patternSetItemList.size(); i++)
            {
                if(m_patternSetItemList[i].m_enumFunction == PATTERNSET_PATTERNPARA ||
                        m_patternSetItemList[i].m_enumFunction == PATTERNSET_PATTERNCOLOR ||
                        m_patternSetItemList[i].m_enumFunction == PATTERNSET_PATTERNCOLOR_HEADHIGHT)
                {
                    m_patternSetBtnList[i]->setEnabled(false);
                }
            }

            ui->buttonNineBtn1->setEnabled(false);

            if(g_pMachine != NULL)
            {
                g_pMachine->invalidateWorkFile();
            }
        }
    }
}

//花样导入替换文件，判断替换文件是否是当前所选的花样
void MainWidget::slotReplacePattrn(QString path)
{
    QFileInfo file(m_curFilePath);
    QFileInfo newfile(path);
    QString pathPattern = file.fileName();
    QString newPathPattern = newfile.fileName();
    if(m_curFilePath.length() > 0)//当前选择的花样路径
    {
        if(pathPattern == newPathPattern)//如果替换的花样等于当前选择的花样
        {
            m_curFilePath.clear();//清空当前的花样，并重新选择

            //花样参数不可按
            for(int i = 0; i < m_patternSetItemList.size(); i++)
            {
                if(m_patternSetItemList[i].m_enumFunction == PATTERNSET_PATTERNPARA)
                {
                    m_patternSetBtnList[i]->setEnabled(false);
                }
            }

            if(g_pMachine != NULL)
            {
                g_pMachine->invalidateWorkFile();
            }
        }
    }
}
void MainWidget::slotClearPatternFcg()
{
    if(m_curFilePath.length() > 0)//当前选择的花样路径
    {
        m_curFilePath.clear();

        //花样参数不可按
        for(int i = 0; i < m_patternSetItemList.size(); i++)
        {
            if(m_patternSetItemList[i].m_enumFunction == PATTERNSET_PATTERNPARA)
            {
                m_patternSetBtnList[i]->setEnabled(false);
            }
        }

        ui->buttonNineBtn1->setEnabled(false);

        if(g_pMachine != NULL)
        {
            g_pMachine->invalidateWorkFile();
        }
    }
}

void MainWidget::slotSetPatternData()
{
    if(m_curFilePath.length() <= 0)//当前选择的花样路径
    {
        return;
    }
    QFile curfile(m_curFilePath);
    if(!curfile.exists())
    {
        return;
    }

    if(m_pParameterSetDlg == NULL){return;}

    g_pCurEmbData->setViewInfo(m_embBackPix);
    g_pCurEmbData->setDrawMode(EmbData::DRAW_VIEW);//非预览模式
    QFileInfo file(m_curFilePath);
    QString ext = file.suffix().toUpper();
    ui->labelFilename->setText(file.fileName());//显示花样名
    g_pCurEmbData->clear();//清空当前选择的花样

    if(ext == "DST")//dst文件
    {
        DataFileDst dst;
        dst.initFile(m_curFilePath);
        dst.loadFile();
        dst.convertDataToAbs();//dsr 转换成中间数据
        g_pCurEmbData->setAbsDat(dst.getEmbAbsData());
        //等于垫板冲孔机-自动定位
        if(g_emMacType == MACHINE_PUNCH_AUTOPOS )
        {
            dst.getSwitchTable(m_fileColorTable);

            for(u32 i = 0 ; i < sizeof(m_fileColorTable)/sizeof(m_fileColorTable[0]) ; i++)
            {
                m_fileColorTable[i] = m_fileColorTable[i] + EMB_NEEDLE_NUM + 1;
            }

            memset(m_fileHead.switchTable,0,sizeof(m_fileHead.switchTable));
            memcpy(m_fileHead.switchTable,m_fileColorTable,sizeof(m_fileColorTable));
        }
    }
    else if(ext == "DSR")//dsr文件
    {
        DataFileDsr dsr;
        dsr.initFile(m_curFilePath);
        dsr.loadFile();//下载dsr的文件
        //花样参数点击了确认按钮
        dsr.convertDataToEmbAbs();// dsr转换为绝对数据（中间数据）
        g_pCurEmbData->setAbsDat(dsr.getEmbAbsData());//得到转换后的绝对坐标数据
        //等于垫板冲孔机
        if(g_emMacType == MACHINE_PUNCH_AUTOPOS  || g_emMacType == MACHINE_PUNCH_SEW)
        {
            int punchNum = g_pSettings->readFromIniFile("PunchNeedle/number").toInt();
            dsr.getSwitchTable(m_fileColorTable);

            for(u32 i = 0 ; i < sizeof(m_fileColorTable)/sizeof(m_fileColorTable[0]) ; i++)
            {
                //冲缝机如果花版中色序大于冲孔针杆数，将此色序设置为缝纫色序
                //因为打版软件自带缝纫色序错误（与冲孔混用），在界面这样临时处理下，后续需要与打版软件商讨修改
                if(m_fileColorTable[i] >= punchNum)
                {
                    m_fileColorTable[i] = EMB_NEEDLE_NUM + PUNCH_NEEDLE_NUM + 1;
                }
                else
                {
                    m_fileColorTable[i] = m_fileColorTable[i] + EMB_NEEDLE_NUM + 1;
                }
            }

            memset(m_fileHead.switchTable,0,sizeof(m_fileHead.switchTable));
            memcpy(m_fileHead.switchTable,m_fileColorTable,sizeof(m_fileColorTable));
        }
    }
    else
    {
        return;
    }

    g_pCurEmbData->appendAbsFile(m_curFilePath, g_pCurEmbData->getAbsDat());//生成文件信息
    g_pCurEmbData->getAbsDatRangeXY();//获得单个图元的宽高范围

    int startMoveFlag = 0;//起始点是否移动的标志
    //旋转式样
    switch (m_fileHead.rotateStyle)
    {
    case 0:
        break;
    case 1:
        g_pCurEmbData->setRotate(-90);
        startMoveFlag = 1;
        break;
    case 2:
        g_pCurEmbData->setRotate(-180);
        startMoveFlag = 1;
        break;
    case 3:
        g_pCurEmbData->setRotate(90);
        startMoveFlag = 1;
        break;
    case 4:
        g_pCurEmbData->setMirror(1);
        startMoveFlag = 1;
        break;
    case 5:
        g_pCurEmbData->setMirror(1);
        g_pCurEmbData->setRotate(90);
        startMoveFlag = 1;
        break;
    case 6:
        g_pCurEmbData->setMirror(2);
        startMoveFlag = 1;
        break;
    case 7:
        g_pCurEmbData->setMirror(1);
        g_pCurEmbData->setRotate(-90);
        startMoveFlag = 1;
        break;
    }

    //水平翻转样式
    switch (m_fileHead.horizontalStyle)
    {
    case 0:
        break;
    case 1:
        g_pCurEmbData->setMirror(1);
        startMoveFlag = 1;
        break;
    }

    //垂直翻转样式
    switch (m_fileHead.verticalStyle)
    {
    case 0:
        break;
    case 1:
        g_pCurEmbData->setMirror(2);
        startMoveFlag = 1;
        break;
    }

    //旋转
    g_pCurEmbData->setRotate(0-m_fileHead.rotateAngle);
    if(m_fileHead.rotateAngle != 0)
    {
        startMoveFlag = 1;
    }

    if(g_emMacType != MACHINE_ADHESIVE  && g_emMacType != MACHINE_PUNCH)
    {
        if(startMoveFlag == 1)
        {
            //变换之前的起始点和图形中心
            s32 bMaxX = g_pCurEmbData->m_maxX;
            s32 bMinX = g_pCurEmbData->m_minX;
            s32 bMaxY = g_pCurEmbData->m_maxY;
            s32 bMinY = g_pCurEmbData->m_minY;
            int bCenterX = (bMaxX + bMinX)/2;
            int bCenterY = (bMaxY + bMinY)/2;

            g_pCurEmbData->getAbsDatRangeXY();//获得单个图元的宽高范围

            //变换之后的起始点
            s32 eMaxX = g_pCurEmbData->m_maxX;
            s32 eMinX = g_pCurEmbData->m_minX;
            s32 eMaxY = g_pCurEmbData->m_maxY;
            s32 eMinY = g_pCurEmbData->m_minY;
            int eCenterX = (eMaxX + eMinX)/2;
            int eCenterY = (eMaxY + eMinY)/2;

            int cx = eCenterX - bCenterX;
            int cy = eCenterY - bCenterY;

            int eBeginX = m_fileHead.beginX - cx;
            int eBeginY = m_fileHead.beginY - cy;

            m_fileHead.beginX = eBeginX;
            m_fileHead.beginY = eBeginY;
        }
    }
    //移动起始点

    g_pCurEmbData->addContinuousRunCompensate(m_fileHead.continuRunComp);//连续动框补偿
    g_pCurEmbData->setNeedleTipCompensation(m_fileHead.needleTipComp);//针尖补偿
    g_pCurEmbData->setSplitStitchLength(m_fileHead.stitchSplitLength);//需要分割针步的针步长度

    //保存参数配置
    m_pMainWidgetFunction->setPatternHeadConfig(m_curFilePath,m_fileHead);//打开fcg或者生成fcg文件，读取和写入

    //qDebug()<<"resetAllData begin";
    resetAllData(); //显示全部花样区域
    //qDebug()<<"showPatternPreview begin";

    //先转换为ds16数据，在把计算的fileid写回ds16
    //paraId   是计算fcg中数值，不存在fcg时，旋转式样这些是默认值
    u32 paraId = calcCrc16((u8*)(&m_fileHead.rotateStyle),
                           ((&m_fileHead.needleTipComp) - (&m_fileHead.rotateStyle) + 1)*sizeof(u16));
    u32 headFileId = g_pCurEmbData->getDsDatHead()->checkCrc + paraId;//ds16文件头的crc + paraId
    g_pCurEmbData->setDsDatHeadFileID(headFileId);      //将计算得到的fileid写回到数据区ds16
    qDebug()<<"headFileId"<<headFileId;

    showPatternPreview();
}

//显示动框角度设置界面
void MainWidget::slotShowFrameAngleWi()
{
    if(m_pSheetWi != NULL)
    {
        QString topImageName;
        for(int i = 0; i < m_assistItemList.size(); i++)
        {
            if(m_assistItemList[i].m_enumFunction == ASSIST_ROOT)//动框角度界面用超级用户的图标
            {
                topImageName = m_assistItemList[i].m_topImageName;
                break;
            }
        }

        //加载按钮顶图图标
        QString tStyle = m_setControlStyle.getTopStyleSheet(topImageName);

        m_pSheetWi->setTypeLogo(tStyle);
        m_pSheetWi->setMainTitle(tr("Frame angle setting"));//动框角度设置
        m_pSheetWi->setSubTitle(tr("Root > Frame angle setting"));//超级用户 > 动框角度设置
        m_pSheetWi->show();
    }
}

void MainWidget::slotPunchManualChangeColor()
{
    if(m_pMainWidgetFunction != NULL)
    {
        m_pMainWidgetFunction->funPunchManualChangeColor();
    }
}

//每十万针主界面加载图片的进度条走一格
void MainWidget::slotChangeProgressBar(int value)
{
    ui->progressBar->setValue(value);
}

//快捷功能中的快捷按钮被点击
void MainWidget::slotQuickBtnClick()
{
    MyButton *button = (MyButton*) this->sender();

    if(button == NULL)
    {
        return;
    }

    //执行快捷按钮动作
    for(int i = 0; i < m_quickBtnList.size(); i++)
    {
        if(button == m_quickBtnList[i])
        {
            int idx = (m_curPages-1)*m_itemPerPage+i;
            int enumFun = m_quickItemList[idx].m_enumFunction;
            runCommonBtnFunction(enumFun);
            break;
        }
    }
}

//界面下方的快捷按钮被点击
void MainWidget::slotShortCutBtnClick()
{
    MyButton *button = (MyButton*) this->sender();

    if(button == NULL)
    {
        return;
    }

    //判断哪个快捷按钮被按下，获取功能索引并执行相关操作
    for(int i = 0; i < m_shortCutBtnList.size(); i++)
    {
        if(button == m_shortCutBtnList[i])
        {
            int commonBtnIdx = g_pSettings->readFromIniFile("HMI/commonbtn"+QString::number(i+1)).toInt();
            runCommonBtnFunction(commonBtnIdx);
            break;
        }
    }
}

//辅助功能中的辅助功能按钮被点击
void MainWidget::slotAssistBtnClick()
{
    MyButton *button = (MyButton*) this->sender();

    if(button == NULL)
    {
        return;
    }

    //执行快捷按钮动作
    for(int i = 0; i < m_assistBtnList.size(); i++)
    {
        if(button == m_assistBtnList[i])
        {
            int idx = (m_curPages-1)*m_itemPerPage+i;
            int enumFun = m_assistItemList[idx].m_enumFunction;
            runAssistBtnFunction(enumFun,i);
            break;
        }
    }
}

//调试功能按钮被点击
void MainWidget::slotDebugBtnClick()
{
    MyButton *button = (MyButton*) this->sender();

    if(button == NULL)
    {
        return;
    }
    //执行调试按钮动作
    for(int i = 0; i < m_debugBtnList.size(); i++)
    {
        if(button == m_debugBtnList[i])
        {
            int enumFun = m_debugItemList[i].m_enumFunction;
            runDebugBtnFunction(enumFun);
            break;
        }
    }
}

//花样设置中的花样设置按钮被点击
void MainWidget::slotPatternSetBtnClick()
{
    MyButton *button = (MyButton*) this->sender();

    if(button == NULL)
    {
        return;
    }

    //执行快捷按钮动作
    for(int i = 0; i < m_patternSetBtnList.size(); i++)
    {
        if(button == m_patternSetBtnList[i])
        {
            int enumFun = m_patternSetItemList[i].m_enumFunction;
            runPatternSetBtnFunction(enumFun,i);
            break;
        }
    }
}

//参数设置中的参数功能按钮被点击
void MainWidget::slotParaTypeBtnClick()
{
//    if(g_emDebugMode == nodebugMode)
//    {
//        if(g_emUser != factory)//权限不够先登录
//        {
//            m_pMainWidgetFunction->slotUserLogin(factory);
//            if(g_emUser != factory)//发送登录信号后，权限如果还没改变就返回
//                return;
//        }
//    }

    MyButton *button = (MyButton*) this->sender();

    if(button == NULL)
    {
        return;
    }

    QString tStyle = m_setControlStyle.getTopStyleSheet(ui->buttonParaSet->objectName());

    m_pParameterSetDlg->setTypeLogo(tStyle);
    m_pParameterSetDlg->setMainTitle(tr("Parameter setting"));

    //执行快捷按钮动作
    for(int i = 0; i < m_paraSetBtnList.size(); i++)
    {
        if(button == m_paraSetBtnList[i])
        {
            int paraType = m_paraSetItemList[i].m_paraType;
            QString subStr;
            int64_t sort = -1;

            switch (paraType)
            {
            case PARASET_POSITION:
                subStr = tr("Position parameters");//位置参数
                sort = MC_SORT_POSITION;
                break;
            case PARASET_SPEED:
                subStr = tr("Speed parameters");//速度参数
                sort = MC_SORT_SPEED;
                break;
            case PARASET_ACTION:
                subStr = tr("Action parameters");//动作参数
                sort = MC_SORT_ACTION;
                break;
            case PARASET_DETECT:
                subStr = tr("Detect parameters");//检测参数
                sort = MC_SORT_DETECT;
                break;
            case PARASET_SETTING:
                subStr = tr("Setting parameters");//设置参数
                sort = MC_SORT_SETTING;
                break;
            case PARASET_WORK:
                subStr = tr("Work parameters");//工作参数
                sort = MC_SORT_WORK;
                break;
            default:
                subStr = tr("Parameter setting");//参数设置
                sort = -1;
                break;
            }

            m_pParameterSetDlg->setSubTitle(tr("Parameter setting > ") + subStr);//参数设置 >
            //机器参数和工作参数
            m_pParameterSetDlg->setItemList(operate,PARA_TYPE_MACH|PARA_TYPE_WORK,sort);
            m_pParameterSetDlg->exec();
            break;
        }
    }
}

//设置超级用户图标
void MainWidget::slotSetButtonRootLogo(int level)
{
    ui->buttonUser->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonUser->objectName()+QString::number(level)));
}

//清空花版断线次数
void MainWidget::slotClearPatternBreakLineNum()
{
    m_fileHead.breakLineParkNum = 0;
}

//边框检查超限后重新定起始点
void MainWidget::slotResetStartPos(DataFilePos pos)
{
    //ui->labelTitle->setText("receive signal");
    if(m_pMainWidgetFunction != NULL)
    {
        //ui->labelTitle->setText("receive before");
        m_pMainWidgetFunction->funResetStartPoint(m_curFilePath,pos);
        //ui->labelTitle->setText("receive end");
    }
}

void MainWidget::slotDebugState()
{
    if(g_emDebugMode == debugMode)
    {
        ui->labelTitle->setStyleSheet(LABELREDSTYLE);
    }
    else
    {
        ui->labelTitle->setStyleSheet(LABELWHITESTYLE);
    }
}

void MainWidget::slotCloseRootPara()
{
    g_emUser = operate;
    m_pParameterSetDlg->done(0);
}

void MainWidget::slotChangeColorTable(int selColor, int colorIdx)
{
    if(selColor < 0)
    {
        return;
    }

    m_fileHead.switchTable[selColor] = colorIdx;
}

void MainWidget::slotColorOrderChange()
{
    m_pMainWidgetFunction->setPatternHeadConfig(m_curFilePath,m_fileHead);
    g_pCurEmbData->setDs16ColorOfTable(m_fileHead.switchTable);
    g_pCurEmbData->setEmbData();
    refreshShowColorUi();
    m_pMainWidgetFunction->sendPatternHead(m_curFilePath);//发送头文件
}

void MainWidget::slotReSetData(QByteArray table)
{
    //工作模式设定取消后恢复未设置的模式表
    memcpy(m_fileHead.switchTable,table,sizeof(m_fileHead.switchTable));
}

void MainWidget::onRefreshPatternTimer()
{
    // 文件执行进度(当前针数) labelNeedleIdx
    m_curDatIdx++;
    reSetDatIdx(m_curDatIdx);
    QPixmap patternPix = g_pCurEmbData->getPreviewImage();
    ui->labelPatternView->setPixmap(patternPix);
}

//1秒定时器
void MainWidget::onOneSecondTimer()
{
    // 获取系统当前时间
    QDateTime dateTime = QDateTime::currentDateTime();
    ui->labelTime->setText(dateTime.toString("yyyy/MM/dd HH:mm:ss"));
    refConnectUi(dateTime.time().second());//刷新连接
}

//5秒定时器
void MainWidget::onFiveSecondTimer()
{
    if(m_conFlag == 0)//已连接
    {

    }
    else
    {
        g_pMachine->setTcpConnectState(1);//将连接状态置为1
    }
    m_conFlag = -1;
}

void MainWidget::onTenMiniteTimer()
{
    s16 rel = m_pMainWidgetFunction->detectWifiConnect();
    if(rel > 0)//已连接
    {
        ui->buttonWifi->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonWifi->objectName()+"Connect"));
    }
    else
    {
        ui->buttonWifi->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonWifi->objectName()+"Unconnect"));
    }
}

//1分钟定时器,记录当前系统时间,用于上电时  计算  关机时间
void MainWidget::onOneMinTimer()
{
    // 获取系统当前时间
    QDateTime dateTime = QDateTime::currentDateTime();
    g_pSettings->writeToIniFile(("DateTime/second"),dateTime.toTime_t());//单位为秒
#if(0)
    //30天自动删除是只删除超过30天的记录
    //文件路径
    QDir apppath(qApp->applicationDirPath());
    QString csvfile;
    csvfile = apppath.path() + apppath.separator() + CSV_FILEID;
    //获取文件的创建时间
    QFileInfo info(csvfile);
    qDebug() << info.size();//获取文件大小
    QDateTime dt = info.created();//获取文件创建时间
    int days = dt.daysTo(dateTime);//获取文件相对于当前时间的天数
    if (days >30)
    {
        QFile::remove(csvfile);//大于30天，删除这个文件
    }
#endif
}

//刷新版本信息
//刷新版本信息
void MainWidget::onRefreshVer()
{
    //版本显示
    QString verStr = m_pMainWidgetFunction->getVersionStr();
    //    verStr.sprintf("XPlatForm-RP-HMI-L1910-V%d.%02d.%02d",
    //                   EMB_VER_CODE_Y,
    //                   EMB_VER_CODE_M,
    //                   EMB_VER_CODE_D);
#if(0)
    QString boardVerStr;
    MCInfo info1 = g_pMachine->getMcInfo();

    char softwareVerStr[32+1];//软件版本
    memcpy(softwareVerStr, info1.softwareVerStr, 32);
    softwareVerStr[32] = 0;
    QString strBoardVer;
    strBoardVer.sprintf("%s", softwareVerStr);
    if(strBoardVer.length() > 6)
    {
        QString str1;
        str1 = strBoardVer.right(6);
        boardVerStr = "-DewMock-V" + str1;
    }
#endif
    ui->labelHMIVersion->setText(verStr);//界面版本:
}

//主界面
void MainWidget::on_buttonMainMenu_clicked()
{
    hideMenuFrame();
    showPatternPreview();
    ui->buttonMainMenu->setCheckable(true);
    ui->buttonMainMenu->setChecked(true);
}

//花样设置
void MainWidget::on_buttonPatternSet_clicked()
{
    hideMenuFrame();
    ui->frameMenuBack->setVisible(true);
    ui->framePatternSet->setVisible(true);
    ui->buttonPatternSet->setCheckable(true);
    ui->buttonPatternSet->setChecked(true);
}

//参数设定按钮
void MainWidget::on_buttonParaSet_clicked()
{
    if(g_emMacType == MACHINE_ADHESIVE)
    {
        if(g_emDebugMode == nodebugMode)
        {
            if(g_emUser != repair)//权限不够先登录
            {
                m_pMainWidgetFunction->slotUserLogin(repair);
                if(g_emUser != repair)//发送登录信号后，权限如果还没改变就返回
                {
                    return;
                }
            }
        }
    }

    s16 paraSort = g_pSettings->readFromIniFile("HMI/paraSort").toInt();

    if(paraSort == 1)//分类显示参数
    {
        hideMenuFrame();
        ui->frameMenuBack->setVisible(true);
        ui->frameParaSet->setVisible(true);
        ui->buttonParaSet->setCheckable(true);
        ui->buttonParaSet->setChecked(true);
    }
    else if(paraSort == 0)//不分类显示参数
    {
        showPatternPreview();

        QString tStyle = m_setControlStyle.getTopStyleSheet(ui->buttonParaSet->objectName());

        m_pParameterSetDlg->setTypeLogo(tStyle);
        m_pParameterSetDlg->setMainTitle(tr("Parameter setting"));
        m_pParameterSetDlg->setSubTitle(tr("Parameter setting > Parameter setting"));
        //机器参数和工作参数
        m_pParameterSetDlg->setItemList(operate,PARA_TYPE_MACH|PARA_TYPE_WORK,MC_SORT_SETTING|MC_SORT_POSITION|MC_SORT_SPEED|MC_SORT_DETECT|MC_SORT_ACTION);
        m_pParameterSetDlg->exec();
    }
}

//快捷功能按钮
void MainWidget::on_buttonShortcutFunction_clicked()
{
    m_curPages = 1; // 当前页
    hideMenuFrame();
    ui->frameMenuBack->setVisible(true);
    ui->frameShortcutFunction->raise();
    ui->frameShortcutFunction->setVisible(true);
    ui->buttonShortcutFunction->setCheckable(true);
    ui->buttonShortcutFunction->setChecked(true);
    if(m_quickItemList.size() > m_itemPerPage)
    {
        ui->buttonShortCutPgDn->setVisible(true);
        ui->buttonShortCutPgUp->setVisible(true);
        ui->labelShortCutPage->setVisible(true);
        refreshPageUi(INTERFACE_SHORTCUT);
    }
}

//辅助功能按钮
void MainWidget::on_buttonAccessFunction_clicked()
{
    m_curPages = 1; // 当前页
    hideMenuFrame();
    ui->frameMenuBack->setVisible(true);
    ui->frameAccessFunction->setVisible(true);
    ui->buttonAccessFunction->setCheckable(true);
    ui->buttonAccessFunction->setChecked(true);
    if(m_assistItemList.size() > m_itemPerPage)
    {
        ui->buttonAssistPgDn->setVisible(true);
        ui->buttonAssistPgUp->setVisible(true);
        ui->labelAssistPage->setVisible(true);
        refreshPageUi(INTERFACE_ACCESS);
    }
}

//速度加
void MainWidget::on_buttonSpeedAdd_clicked()
{
    if(g_pMachine != NULL)
    {
        int speed = 0;
        if(m_speedLevel == 1)
        {
            speed = 10;
        }
        else if(m_speedLevel == 2)
        {
            speed = 50;
        }
        else if(m_speedLevel == 3)
        {
            speed = 100;
        }

        g_pMachine->msRpmChange(speed,0);
    }
}

//速度减
void MainWidget::on_buttonSpeedDec_clicked()
{
    if(g_pMachine != NULL)
    {
        int speed = 0;
        if(m_speedLevel == 1)
        {
            speed = -10;
        }
        else if(m_speedLevel == 2)
        {
            speed = -50;
        }
        else if(m_speedLevel == 3)
        {
            speed = -100;
        }

        g_pMachine->msRpmChange(speed,0);
    }
}

void MainWidget::on_buttonNineBtnUp_pressed()
{
    ui->frameNineBtn->setStyleSheet(m_setControlStyle.getBorderImageStyleSheet("frameNineBtnUp"));
    if(g_pMachine != NULL)
    {
        g_pMachine->manualAction(XY_MOVE_FRONT, m_speedLevel);
    }
}

void MainWidget::on_buttonNineBtnUp_released()
{
    ui->frameNineBtn->setStyleSheet(m_setControlStyle.getBorderImageStyleSheet(ui->frameNineBtn->objectName()));
    setFrameNineBtnStyle();
    if(g_pMachine != NULL)
    {
        g_pMachine->motoMove(XY_MOVE_FRONT, MT_MOVE_DIR_STOP, 0);
    }
}

void MainWidget::on_buttonNineBtnDown_pressed()
{
    ui->frameNineBtn->setStyleSheet(m_setControlStyle.getBorderImageStyleSheet("frameNineBtnDown"));
    if(g_pMachine != NULL)
    {
        g_pMachine->manualAction(XY_MOVE_BACK, m_speedLevel);
    }
}

void MainWidget::on_buttonNineBtnDown_released()
{
    ui->frameNineBtn->setStyleSheet(m_setControlStyle.getBorderImageStyleSheet(ui->frameNineBtn->objectName()));
    setFrameNineBtnStyle();
    if(g_pMachine != NULL)
    {
        g_pMachine->motoMove(XY_MOVE_BACK, MT_MOVE_DIR_STOP, 0);
    }
}

void MainWidget::on_buttonNineBtnLeft_pressed()
{
    ui->frameNineBtn->setStyleSheet(m_setControlStyle.getBorderImageStyleSheet("frameNineBtnLeft"));
    if(g_pMachine != NULL)
    {
        g_pMachine->manualAction(XY_MOVE_LEFT, m_speedLevel);
    }
}

void MainWidget::on_buttonNineBtnLeft_released()
{
    ui->frameNineBtn->setStyleSheet(m_setControlStyle.getBorderImageStyleSheet(ui->frameNineBtn->objectName()));
    setFrameNineBtnStyle();
    if(g_pMachine != NULL)
    {
        g_pMachine->motoMove(XY_MOVE_LEFT, MT_MOVE_DIR_STOP, 0);
    }
}

void MainWidget::on_buttonNineBtnRight_pressed()
{
    ui->frameNineBtn->setStyleSheet(m_setControlStyle.getBorderImageStyleSheet("frameNineBtnRight"));
    if(g_pMachine != NULL)
    {
        g_pMachine->manualAction(XY_MOVE_RIGHT, m_speedLevel);
    }
}

void MainWidget::on_buttonNineBtnRight_released()
{
    ui->frameNineBtn->setStyleSheet(m_setControlStyle.getBorderImageStyleSheet(ui->frameNineBtn->objectName()));
    setFrameNineBtnStyle();
    if(g_pMachine != NULL)
    {
        g_pMachine->motoMove(XY_MOVE_RIGHT, MT_MOVE_DIR_STOP, 0);
    }
}

void MainWidget::on_buttonNineBtnMiddle_pressed()
{
    m_speedLevel = m_speedLevel + 1;
    if(m_speedLevel > 3)
    {
        m_speedLevel = 1;
    }

    if(g_emMacType == MACHINE_PUNCH_SEW  ||
            g_emMacType == MACHINE_ADHESIVE ||
            g_emMacType == MACHINE_PUNCH_AUTOPOS)
    {
        emit siSpeedLevel(m_speedLevel);
    }

    bool cVal = ui->frameShortcutBtn->isEnabled();//按钮是否失能,是否锁界面

    if(cVal == true)
    {
        ui->frameNineBtn->setStyleSheet(m_setControlStyle.getBorderImageStyleSheet("frameNineBtnMiddle"));
    }
}

void MainWidget::on_buttonNineBtnMiddle_released()
{
    bool cVal = ui->frameShortcutBtn->isEnabled();//按钮是否失能,是否锁界面

    if(cVal == true)
    {
        ui->frameNineBtn->setStyleSheet(m_setControlStyle.getBorderImageStyleSheet(ui->frameNineBtn->objectName()));
    }

    setFrameNineBtnStyle();
}

//前进回退
void MainWidget::on_buttonNineBtn1_clicked()
{
    funForwardOrBack();
}

//锁针功能
void MainWidget::on_buttonNineBtn2_clicked()
{
    if(g_pMachine != NULL)
    {
        if ((m_mcStatus.workStatus & WORK_STA_ENSTATE) == WORK_STA_ENSTATE) //允许状态
        {
            //禁止工作
            g_pMachine->setDisableWorkSta();
        }
        else //禁止状态
        {
            //允许工作
            g_pMachine->setEnableWorkSta();
        }
    }
}

//工作状态切换
void MainWidget::on_buttonNineBtn3_clicked()
{
    //m_pRefreshPatternTimer->start();//测试花样实时刷新的定时器启动

    if(g_pMachine != NULL)
    {
        if ((m_mcStatus.workStatus & WORK_STA_SIMULATE) == WORK_STA_SIMULATE) //模拟工作
        {
            //正常工作
            g_pMachine->setNormalWork();
        }
        else //正常工作
        {
            //模拟工作
            g_pMachine->setSimulateWork();
        }
    }
}

//锁界面
void MainWidget::on_buttonNineBtn4_clicked()
{
    hideMenuFrame();
    showPatternPreview();
    ui->buttonMainMenu->setCheckable(true);
    ui->buttonMainMenu->setChecked(true);

    bool cVal = ui->frameShortcutBtn->isEnabled();//按钮是否失能,是否锁界面

    if(cVal == true)
    {
        ui->buttonNineBtn4->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNineBtn4->objectName()+"Unlock"));
        ui->frameNineBtn->setStyleSheet(m_setControlStyle.getBorderImageStyleSheet(ui->frameNineBtn->objectName()+"Disable"));
        setUiBtnEnable(false);
    }
    else
    {
        ui->buttonNineBtn4->setTopImage(m_setControlStyle.getTopStyleSheet(ui->buttonNineBtn4->objectName()));
        ui->frameNineBtn->setStyleSheet(m_setControlStyle.getBorderImageStyleSheet(ui->frameNineBtn->objectName()));
        setUiBtnEnable(true);
    }

    if(m_dispMode != EmbData::DISP_EXECING)//不是执行状态
    {
        g_pCurEmbData->setViewInfo(m_embBackPix);//带背景图的背景
        g_pCurEmbData->setEmbData();//ds16数据转换为画图数据

        m_dispMode = EmbData::DISP_ALL_EXEC;
        g_pCurEmbData->setDispMode(m_dispMode, 1);    // 重新画图

        m_dispMode = EmbData::DISP_EXECING;           // 设置为执行模式
        g_pCurEmbData->setDispMode(m_dispMode, 0);       // 设置为按进度执行模式
        g_pCurEmbData->setExecIndex(m_curDatIdx);     // 设置进度

        QPixmap patternPix = g_pCurEmbData->getPreviewImage();
        ui->labelPatternView->setPixmap(patternPix);
    }
}

//花样参数的快捷按钮
void MainWidget::on_buttonPatternInfo_clicked()
{
    if(m_curFilePath.length() <= 0)
    {
        return;
    }

    showPatternPreview();
    slotShowPatternPara(m_curFilePath);
}

void MainWidget::on_buttonNeedleBegin_clicked()
{
    m_forwardBackNeedleIdx = 0;
    addOrDecNeedleIdx(m_forwardBackNeedleIdx);
}

void MainWidget::on_buttonNeedleEnd_clicked()
{
    m_forwardBackNeedleIdx = g_pCurEmbData->getStitchNums();  //总针数
    addOrDecNeedleIdx(m_forwardBackNeedleIdx);
}

void MainWidget::on_buttonNeedleDec1_clicked()
{
    m_forwardBackNeedleIdx = m_forwardBackNeedleIdx - 1;
    addOrDecNeedleIdx(m_forwardBackNeedleIdx);
}

void MainWidget::on_buttonNeedleAdd1_clicked()
{
    m_forwardBackNeedleIdx = m_forwardBackNeedleIdx + 1;
    addOrDecNeedleIdx(m_forwardBackNeedleIdx);
}

void MainWidget::on_buttonNeedleDec10_clicked()
{
    m_forwardBackNeedleIdx = m_forwardBackNeedleIdx - 10;
    addOrDecNeedleIdx(m_forwardBackNeedleIdx);
}

void MainWidget::on_buttonNeedleAdd10_clicked()
{
    m_forwardBackNeedleIdx = m_forwardBackNeedleIdx + 10;
    addOrDecNeedleIdx(m_forwardBackNeedleIdx);
}

void MainWidget::on_buttonNeedleDec100_clicked()
{
    m_forwardBackNeedleIdx = m_forwardBackNeedleIdx - 100;
    addOrDecNeedleIdx(m_forwardBackNeedleIdx);
}

void MainWidget::on_buttonNeedleAdd100_clicked()
{
    m_forwardBackNeedleIdx = m_forwardBackNeedleIdx + 100;
    addOrDecNeedleIdx(m_forwardBackNeedleIdx);
}

void MainWidget::on_buttonNeedleDec1000_clicked()
{
    m_forwardBackNeedleIdx = m_forwardBackNeedleIdx - 1000;
    addOrDecNeedleIdx(m_forwardBackNeedleIdx);
}

void MainWidget::on_buttonNeedleAdd1000_clicked()
{
    m_forwardBackNeedleIdx = m_forwardBackNeedleIdx + 1000;
    addOrDecNeedleIdx(m_forwardBackNeedleIdx);
}

void MainWidget::on_buttonNeedleDec10000_clicked()
{
    m_forwardBackNeedleIdx = m_forwardBackNeedleIdx - 10000;
    addOrDecNeedleIdx(m_forwardBackNeedleIdx);
}

void MainWidget::on_buttonNeedleAdd10000_clicked()
{
    m_forwardBackNeedleIdx = m_forwardBackNeedleIdx + 10000;
    addOrDecNeedleIdx(m_forwardBackNeedleIdx);
}

void MainWidget::on_buttonForwardBackOk_clicked()
{
    if ((m_mcStatus.workStatus & WORK_STA_BUSY) != 0)    // 下位机在执行动作
    {
        return;
    }

    //g_pMachine->setFileExecProgress(0, m_curFileID, m_expara);
    g_pMachine->fastJump(m_expara.newIdx);//前进回退
    ui->frameForwardBack->setVisible(false);
    setUiBtnEnable(true);
    ui->buttonMainMenu->setCheckable(true);
    ui->buttonMainMenu->setChecked(true);
}

void MainWidget::on_buttonForwardBackCancel_clicked()
{
    g_pCurEmbData->setExecIndex(m_curDatIdx);// 更新针数

    QPixmap patternPix = g_pCurEmbData->getPreviewImage();
    ui->labelPatternView->setPixmap(patternPix);

    ui->frameForwardBack->setVisible(false);
    setUiBtnEnable(true);
    ui->buttonMainMenu->setCheckable(true);
    ui->buttonMainMenu->setChecked(true);
}

//退出登录
void MainWidget::on_buttonUser_clicked()
{
    //退回到无密码的普通用户
    if(g_emUser == repair || g_emUser == factory || g_emUser == root)
    {
        m_pMainWidgetFunction->funExitRoot();
        ui->buttonUser->setStyleSheet(m_setControlStyle.getStyleSheet(ui->buttonUser->objectName()));
    }
}

//刷新界面显示
void MainWidget::refreshPageUi(s16 type)
{
    if(m_itemPerPage <= 0)//界面每页按钮数
    {
        return;
    }

    //-----------
    int itemNum, pageNums;
    itemNum = pageNums = 0;

    if(type == INTERFACE_SHORTCUT)
    {
        itemNum = m_quickItemList.size();//快捷功能列表
    }
    else if(type == INTERFACE_ACCESS)
    {
        itemNum = m_assistItemList.size();//辅助功能列表
    }

    pageNums = (itemNum+m_itemPerPage-1) / m_itemPerPage;//计算总页数

    if (m_curPages > pageNums)                 // 当前页
    {
        m_curPages = pageNums;
    }
    if (m_curPages <= 1)
    {
        m_curPages = 1;
    }

    // 刷新文本和图标
    int i, itemidx;
    itemidx = (m_curPages-1) * m_itemPerPage;
    for (i = 0; i < m_itemPerPage; i++)
    {
        if (itemidx < itemNum)    //itemNum   从绣花参数一共有的按钮功能，可以是28+个
        {
            if(type == INTERFACE_SHORTCUT)
            {
                QString name = m_quickItemList[itemidx].m_name;
                m_quickLabelList[i]->setText(name);
                m_quickLabelList.at(i)->show();//名称

                QString topImageName = m_quickItemList[itemidx].m_topImageName;
                //加载按钮顶图图标
                QString btnStyle = m_setControlStyle.getTopStyleSheet(topImageName);
                m_quickBtnList[i]->setTopImage(btnStyle);
                m_quickBtnList.at(i)->show();
            }
            else if(type == INTERFACE_ACCESS)
            {
                QString name = m_assistItemList[itemidx].m_name;
                m_assistLabelList[i]->setText(name);
                m_assistLabelList.at(i)->show();//名称

                QString topImageName = m_assistItemList[itemidx].m_topImageName;
                //加载按钮顶图图标
                QString btnStyle = m_setControlStyle.getTopStyleSheet(topImageName);
                m_assistBtnList[i]->setTopImage(btnStyle);
                m_assistBtnList.at(i)->show();
            }
        }
        else
        {
            if(type == INTERFACE_SHORTCUT)
            {
                m_quickBtnList.at(i)->hide();//按钮
                m_quickLabelList.at(i)->hide();//名称
            }
            else if(type == INTERFACE_ACCESS)
            {
                m_assistBtnList.at(i)->hide();//按钮
                m_assistLabelList.at(i)->hide();//名称
            }
        }
        itemidx++;
    }

    // 刷新按钮
    if (m_curPages <= 1)
    {
        if(type == INTERFACE_SHORTCUT)
        {
            ui->buttonShortCutPgUp->setEnabled(false);
        }
        else if(type == INTERFACE_ACCESS)
        {
            ui->buttonAssistPgUp->setEnabled(false);
        }
    }
    else
    {
        if(type == INTERFACE_SHORTCUT)
        {
            ui->buttonShortCutPgUp->setEnabled(true);//上一页按钮显示
        }
        else if(type == INTERFACE_ACCESS)
        {
            ui->buttonAssistPgUp->setEnabled(true);
        }
    }
    if (m_curPages >= pageNums)//当前页大于等于总页数
    {
        if(type == INTERFACE_SHORTCUT)
        {
            ui->buttonShortCutPgDn->setEnabled(false);
        }
        else if(type == INTERFACE_ACCESS)
        {
            ui->buttonAssistPgDn->setEnabled(false);
        }
    }
    else
    {
        if(type == INTERFACE_SHORTCUT)
        {
            ui->buttonShortCutPgDn->setEnabled(true);
        }
        else if(type == INTERFACE_ACCESS)
        {
            ui->buttonAssistPgDn->setEnabled(true);
        }
    }

    if(pageNums == 0)
    {
        m_curPages = 0;
    }

    // 页信息
    QString str = tr("pageNum: ") + QString("%1/%2").arg(m_curPages).arg(pageNums);//页数:
    if(type == INTERFACE_SHORTCUT)
    {
        ui->labelShortCutPage->setText(str);
    }
    else if(type == INTERFACE_ACCESS)
    {
        ui->labelAssistPage->setText(str);
    }
}

void MainWidget::on_buttonShortCutPgUp_clicked()
{
    m_curPages--;
    refreshPageUi(INTERFACE_SHORTCUT);
}

void MainWidget::on_buttonShortCutPgDn_clicked()
{
    m_curPages++;
    refreshPageUi(INTERFACE_SHORTCUT);
}

void MainWidget::on_buttonAssistPgUp_clicked()
{
    m_curPages--;
    refreshPageUi(INTERFACE_ACCESS);
}

void MainWidget::on_buttonAssistPgDn_clicked()
{
    m_curPages++;
    refreshPageUi(INTERFACE_ACCESS);
}

void MainWidget::on_buttonColorAdd_clicked()
{
    m_forwardBackColorIdx = m_forwardBackColorIdx + 1;
    addOrDecColorIdx(m_forwardBackColorIdx,1);
}

void MainWidget::on_buttonColorDec_clicked()
{
    m_forwardBackColorIdx = m_forwardBackColorIdx - 1;
    addOrDecColorIdx(m_forwardBackColorIdx,-1);
}

void MainWidget::on_buttonNeedle_clicked()
{
    if(m_curFilePath.length() <= 0)
    {
        return;
    }

    patternColorSet();
}

void MainWidget::on_buttonDebugClose_clicked()
{
    ui->frameDebugFunction->setVisible(false);
    on_buttonAccessFunction_clicked();
}
